#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#TEMPLATE (FirebirdSQLTemplate, 'Firebird SQL Tool for Clarion'),FAMILY('ABC')
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!
#! This template was adapted from a SQL template by G W Bomford
#! Roberto Artigas Jr's template for Reserved words is used with his requirements
#! Since I modified it I have used my initials in the declared data so as not to discredit
#! G W Bomford OR Roberto Artigas Jr for my mistakes
#!
#! The person who modified this for Firebird - Jimmy Rogers - may be contacted by email at JKRogers@bellsouth.net
#!
#! No warranty of any kind is expressed, or implied, the template is used at your own risk.
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#! UTILITIES
#!
#! added the reserved words from Roberto Artigas Jr list
#!
#! #INCLUDE('D2G.TPW')                 #! Major table groups
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#UTILITY (FirebirdTemplateStep1, 'Step 1 - Generate topspeed table structures into an include file'), WIZARD
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#DISPLAY('This Utility will write out all the topspeed table structures into an include file.')
#DISPLAY('You do this before any changes are made to your topspeed dictionary.')
#DISPLAY('Make sure you know your method of conversion in Step 4.')
#DISPLAY('These structures are used for the converson of your tps to ODBC tables.')
#DISPLAY('We write out the converson files after the dictionary has been changed to ODBC .')
#DISPLAY('The name of the include file is TpsToOdbc.Inc.')
#DISPLAY()
#DISPLAY('A sub-directory off the App directory named... ''\convert'' is required for the convert files.')
#DISPLAY('The TpsToOdbc.Inc needs to be in the \Convert folder for Step 4.')
#DISPLAY()
#DISPLAY('The DLL and Lib file will need to be in your convert folder when compiling the conversion files')
#DISPLAY('if you use the Data Dll conversion method.')
#DISPLAY()
#DISPLAY('Step 2 writes the script files.')
#DISPLAY('Step 3 changes a txd to ODBC etc.. for import into a new dictionary.')
#DISPLAY('Step 4 writes the conversion files.')
#DISPLAY()
#DISPLAY('REQUIREMENTS')
#DISPLAY('A. CHANGES TO DICTIONARY')
#DISPLAY('  1. YOU CANNOT MAKE CHANGES TO THE COLUMN NAMES. ONLY THE EXTERNAL NAME.')
#DISPLAY('  2. YOU CANNOT ADD COLUMN NAMES UNTIL AFTER THE CONVERSION.')
#DISPLAY('  3. WE NEED AN EXACT MATCH FOR THE CONVERSION.')
#DISPLAY()
#DISPLAY('B. DICTIONARY TO USE FOR THIS TEMPLATE')
#DISPLAY('  1. MAKE SURE YOU USE YOUR DATADLL APP OR YOUR SINGLE EXE APP.')
#DISPLAY()
#DISPLAY('C. SOMETIMES ITS GOOD TO SHOUT')
#DISPLAY()
#!
#!
#DECLARE(%ASCIIFileRecord)
#DECLARE(%InstancePrefix)
#DECLARE(%InstanceQueue),MULTI
#DECLARE(%OutputFile)
#DECLARE (%CurrentPath)
#DECLARE (%JKRCounter)
#DECLARE (%FileStructure)
#!
#MESSAGE('Creating Topseed Convertion Files',1)
#! Set to current path
#! Set the current path to '\Scripts\'
#LOOP
  #SET (%JKRCounter, INSTRING('\',%DictionaryFile,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%CurrentPath,SUB(%DictionaryFile,1,%JKRCounter))
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#SET (%OutputFile, %CurrentPath & 'TpsToOdbc.Inc')

#CREATE(%OutputFile)

File structures for the topspeed files that will imported into the ODBC conversion files

#FOR (%File), WHERE (%FileDriver = 'TOPSPEED' AND %FileType = 'FILE' AND NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 )  )
[[%File]]
#IF(%FileOwner)
FileOwner=1
  #IF(Sub(%FileOwner,1,1) = '''')
FileOwnerIsAVariable=0
  #else  
FileOwnerIsAVariable=1
  #Endif
#ELSE  
FileOwner=0
#Endif
#IF(%FileName)
FileName=1
  #IF(Sub(%FileName,1,1) = '''')
FileNameIsAVariable=0
  #else  
FileNameIsAVariable=1
  #Endif
#ELSE
FileName=0
#Endif
#!
#SET(%FileStructure,'  FILE,DRIVER(''TOPSPEED''),PRE(' & %FilePrefix & ')' ) 
#!
#IF(%FileOwner)
  #IF(Sub(%FileOwner,1,1) = '''')
    #! found ' on FileOwner ist char of %FileOwner
    #SET(%FileStructure,%FileStructure & ',OWNER(' & %FileOwner & ')' )
  #else  
    #! found ! on FileOwner ist char of %FileOwner
    #SET(%FileStructure,%FileStructure & ',OWNER(FileOwnerPassword)' )
  #Endif
#Endif
#!
#IF(%FileName)
  #IF(Sub(%FileName,1,1) = '''')
    #! found ' on FileName ist char of %FileName
    #SET(%FileStructure,%FileStructure & ',NAME(' & %FileName & ')' )
  #else  
    #! found ! on FileName ist char of %FileName
    #SET(%FileStructure,%FileStructure & ',NAME(FullPathName)' )
  #Endif
#ELSE  
  #SET(%FileStructure,%FileStructure & ',NAME(FullPathName)' )
#Endif
#!
%[20]File %FileStructure
    #FOR (%Key)             #! %KeyIndex    Contains KEY, INDEX, or DYNAMIC
%KeyStruct
    #ENDFOR
    #FOR (%Field), WHERE(%FieldType = 'MEMO')
%FieldStruct
    #ENDFOR
    #FOR (%Field), WHERE(%FieldType = 'BLOB')
%FieldStruct  
    #ENDFOR
%FileStructRec,PRE()
    #FOR (%Field), WHERE(%FieldType <> 'MEMO' AND %FieldType <> 'BLOB')
%FieldStruct
    #ENDFOR
%FileStructRecEnd
%FileStructEnd
#ENDFOR
#CLOSE(%OutputFile)
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#UTILITY (FirebirdTemplateStep2, 'Step 2 - Scripts - Generate Firebird SQL Scripts from Topeed or ODBC tables'), WIZARD
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#! This template was adapted from a SQL template by G W Bomford
#!-----------------------------------------------
#SHEET
  #TAB('Page 1 0f 5'),FINISH(0)
    #BOXED('Generating Firebird SQL Scripts')
      #DISPLAY()
      #DISPLAY('MAKE BACKUP COPIES OF YOUR DICTIONARY.')
      #DISPLAY()
      #DISPLAY('*** The ''\SCRIPTS\'' Sub-Directory MUST exist! ***')
      #DISPLAY()
      #DISPLAY('See next Tab for steps to follow.')
      #DISPLAY()
      #DISPLAY('Select the Topspeed or ODBC tables to generate SQL scripts or leave blank to generate for all tables.')
      #DISPLAY()
      #DISPLAY('IF YOU CREATE AND OPTION CALLED LocalFile FOR A TABLE NO SCRIPT IS CREATED.')
      #DISPLAY('The USEROPTIONS are checked for LOCALFILE and this table is skipped if found.')
      #DISPLAY()
      #DISPLAY(' Leave Blank to Select ALL Topspeed or ODBC Tables')
      #PROMPT('Select Tables for SQL Script',FILE),%JKRSelectedFiles,SELECTION('Tables - Leave Blank to Select ALL TPS or ODBC Tables'),INLINE,AT(10)
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
  #TAB('Page 2 0f 5'),FINISH(0)
    #BOXED('Conditions when creating Firebird scripts')
      #DISPLAY()
      #DISPLAY('Name of the SQL file that is created for errors - SqlErrors.Txt:')
      #DISPLAY()
      #PROMPT('Check for conditions below and if found cancel writing script files?',CHECK),%JKRCheckForValidFieldNames,DEFAULT(1),AT(10)
      #DISPLAY()
      #DISPLAY('Conditions Checked')
      #DISPLAY('1. Reserved words are not allowed - use EXTERNAL NAME to correct.')
      #DISPLAY('2. EXTERNAL NAMES are checked for UPPERCASE.')
      #DISPLAY('3. Field Names > 27 Characters. Maximum in Firebird for object names is 31.')
      #DISPLAY('4. No primary key in a table in the dictionary is not allowed. It will cause errors at runtime.')
      #DISPLAY('** Template ASSUMES a string Boolean value has no '' on say the Y N or a T F and adds them.')
      #DISPLAY('    This is NOT allowed ''Y'' but this is Y. The Initial Value entered value must have '' around it.')
      #DISPLAY()
      #DISPLAY('The dictionary changes are described in Step 3.')
      #DISPLAY('Step 3 makes changes in a txd file for import into a new dictionary.')
      #DISPLAY('Always use the check box that prints a report of any found problems.')
      #DISPLAY('Keep using this until you have no more problems in the dictionary.')
      #DISPLAY()
      #DISPLAY('Remember that if you want your scripts to allow an existing application to work for testing')
      #DISPLAY('then you want the column and file names to match with the dictionary.')
      #DISPLAY('Use the external name attribute on your columns or let this template do it for you.')
    #ENDBOXED
  #ENDTAB
  #TAB('Page 3 of 5'),FINISH(0)
    #BOXED('Conversion Settings')
      #DISPLAY()
      #DISPLAY('Be consistant with the next 2 column Date and Time types.')
      #DISPLAY('If you do not change them to a Date and Time type in the Firebird Script')
      #DISPLAY('then do not change them in Step 3 that changes the TXD.')
      #DISPLAY()
      #PROMPT ('Change All LONGs With @D To DATE field type',check),%JKRChangeDateNames,DEFAULT(0),AT(10)
      #PROMPT ('Change All LONGs With @T To TIME field type',check),%JKRChangeTimeNames,DEFAULT(0),AT(10)
      #DISPLAY()
      #DISPLAY('Be consistant with the next column type change.')
      #DISPLAY('If you do not change them to a BLOB type in the Firebird Script')
      #DISPLAY('then do not change them in Step 3 that changes the TXD.')
      #DISPLAY()
      #PROMPT ('Make STRING CSTRING PSTRING above this size a BLOB for text',check),%JKRChangeStringTypesToBlob,DEFAULT(0),AT(10)
      #ENABLE(%JKRChangeStringTypesToBlob = 1),CLEAR
      #DISPLAY('Example: 2000 makes any of these strings that are 2000 or more in size into BLOBS')
      #DISPLAY('Enter a number or uncheck the box')
      #PROMPT ('',@N5),%JKRChangeStringTypesToBlobSize,DEFAULT(0),AT(10)
      #ENDENABLE
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
  #TAB('Page 4 of 5'),FINISH(0)
    #BOXED('Initial Values And Validity Checks')
      #DISPLAY()
      #DISPLAY('Initial Values And Validity Checks in the dictionary can cause problems when creating scripts')
      #DISPLAY('This could cause problems in your inported scripts if your column Initial Values do not work in Firebird')
      #DISPLAY('Validity Checks in the dictionary can cause problems when converting your data and also')
      #DISPLAY('when your program does not assign the value the same.')
      #DISPLAY('If Cannot Be Zero Or Blank is set it is always written into the scripts ')
      #DISPLAY()
      #DISPLAY('Use the Report for Initial Values and Validity Checks to see what you have before')
      #DISPLAY('creating scripts.')
      #DISPLAY()
      #PROMPT ('Do not use Initial Value from dictionary column to create a default for the script column',check),%JKRNoDefaults,DEFAULT(1),AT(10)
      #ENABLE(%JKRNoDefaults = 0),CLEAR
      #DISPLAY()
      #PROMPT ('Do not use Validity Checks from dictionary column to create a check constraint for the script column',check),%JKRFieldValidation,DEFAULT(1),AT(10)
      #DISPLAY()
      #DISPLAY('Initial Value=Default')
      #DISPLAY('Example: Today()=''NOW'' ')
      #DISPLAY('Example: Cus:No=CUSNO')
      #DISPLAY('Next example has an empty default so one is not created and = is required')
      #DISPLAY('Example: MONTH(TODAY())=')
      #DISPLAY('Enter the dictionary value = and the Firebird value')
      #DISPLAY('The scripts will get the right side value if the left side value is found.')
      #DISPLAY('The scripts will get all other entered Initial Values.')
      #PROMPT ('Initial Values',@S40),%JKRInitialValueList,MULTI('Change this initial value to this'),INLINE
      #ENDENABLE
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
  #TAB('Page 5 of 5'),FINISH(1)
    #BOXED('Firebird Conversion Notes')
      #DISPLAY()
      #DISPLAY('SCRIPTS ARE ONLY GENERATED FOR TOPSPEED AND ODBC TABLES!')
      #DISPLAY()
      #DISPLAY('The following rules are used for creating Firebird scripts.')
      #DISPLAY('BLOB  -> BLOB SUB_TYPE 0 SEGMENT SIZE 80')
      #DISPLAY('BYTE -> SMALLINT')
      #DISPLAY('CSTRING/PSTRING -> VARCHAR')
      #DISPLAY('DECIMAL/FLOAT -> DECIMAL')
      #DISPLAY('LONG/ULONG -> INTEGER')
      #DISPLAY('MEMO  -> BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
      #DISPLAY('SHORT/USHORT/BYTE -> SMALLINT')
      #DISPLAY('SREAL/BFLOAT4 -> FLOAT')
      #DISPLAY('REAL/BFLOAT8 -> DOUBLE PRECISION')
      #DISPLAY('STRING -> CHAR')
      #DISPLAY()
      #DISPLAY('STRING/CSTRING/PSTRING size over the template setting')
      #DISPLAY('-> BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
      #DISPLAY()
      #DISPLAY('STRING/CSTRING/PSTRING over 32765')
      #DISPLAY('-> BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
      #DISPLAY()
      #DISPLAY('''Not Null'' applied to columns marked as NON ZERO and BOOLEAN')
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
#ENDSHEET
#!
#DECLARE (%JKRKeyDescription)
#DECLARE (%FileExternalFlag)
#DECLARE (%FileThreadedFlag)
#DECLARE (%SortedFiles), UNIQUE
#DECLARE (%Groups), MULTI
#DECLARE (%JKRFileName)
#DECLARE (%JKRRelation)
#DECLARE (%JKRKeyName)
#DECLARE (%JKRFieldName)
#DECLARE (%JKRFieldType)
#DECLARE (%JKRShortDataType)
#DECLARE (%JKRHasPrimary)
#DECLARE (%JKRKeyField)
#DECLARE (%JKRCounter)
#DECLARE(%JKRCounterLoc,LONG)
#DECLARE (%JKRUniqueKeys)
#DECLARE (%RelationErrorMessage)
#DECLARE (%ValueConstruct)
#DECLARE (%JKRFileKeyField)
#DECLARE (%JKRFileFieldLink)
#DECLARE (%CurrentPath)
#DECLARE (%OutPutFile)
#DECLARE (%TotalChars)
#!
#DECLARE (%JKRPassedExternalName)
#DECLARE (%JKRFoundReseredWord)
#DECLARE (%JKRChangedReseredWord)
#DECLARE(%JKRAddSpaceCounter)
#DECLARE(%JKRIndexDeclaration)
#!
#DECLARE(%IndexForAllKeyColumns),UNIQUE   #! unique so we cannot add one already there
#!
#DECLARE(%JKRLeftSideOfStringLocation)
#DECLARE(%JKRRightSideOfStringLocation)
#DECLARE(%JKRLeftSideOfString)
#DECLARE(%JKRRightSideOfString)
#DECLARE(%JKRFoundLeftSideMatch,LONG)
#!
#MESSAGE('Creating Firebird Scripts',1)
#! Set the current path to '\Scripts\'
#LOOP
  #SET (%JKRCounter, INSTRING('\',%DictionaryFile,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%CurrentPath,SUB(%DictionaryFile,1,%JKRCounter) & 'Scripts\')
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#!
#SET (%OutputFile, %CurrentPath & 'SqlErrors.Txt')
#!
#IF (%JKRSelectedFiles)
  #FOR (%JKRSelectedFiles)
    #FIX (%FILE,%JKRSelectedFiles)
    #ADD (%SortedFiles, %File)
  #ENDFOR
#ELSE

  #FOR (%File), WHERE ((%FileDriver = 'TOPSPEED' OR %FileDriver = 'ODBC') AND %FileType = 'FILE'  AND NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 )  )
    #ADD (%SortedFiles, %File)
  #ENDFOR
#ENDIF
#!
#CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile
*/
#! 
#! added
#!---------------------------------------------------------------------
#INSERT(%ClarionReservedWords)
#INSERT(%SqlReservedWords)
#FOR(%ClarionWordList)
  #ADD(%SqlWordList,%ClarionWordList)
#ENDFOR
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
#! Check for Errors in Files and Fields
#IF (%JKRCheckForValidFieldNames = 1)
#INSERT (%JKRCheckNames)
  #IF (%JKRCounter > 0)
    #CLOSE (%OutputFile)
    #ABORT
  #ENDIF  
#ENDIF
#CLOSE (%OutputFile)
#!
#! If no errors in files and fields we can continue
#!
#SET (%OutputFile, %CurrentPath & 'SqlTablesAndTriggers.Txt')
#!
#CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile
*/
#IF (%JKRCounter = 0)
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT (%JKRSQLFileDetail,1)
      #! #INSERT (%JKRKeyDefinitions)
      #INSERT(%JKRGetPrimaryKeyColumn)
      #IF (%JKRHasPrimary = 1)
        #INSERT (%JKRTriggers,%File, %JKRKeyField)
      #ENDIF  
  #ENDFOR
  #!
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
#!
#SET (%OutputFile, %CurrentPath & 'SqlAll.Txt')
#!
#CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile
    
    This includes all these together
    1. TableWithoutDrop
    2. CreateSingleIndex
    3. Index
    4. ForeignKeys
    5. AutoNoTriggers
    6. SPReturnNextAutoNo
*/
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT (%JKRSQLFileDetail,0)
      #! #INSERT (%JKRKeyDefinitions)
      #INSERT(%JKRGetPrimaryKeyColumn)
      #IF (%JKRHasPrimary = 1)
        #INSERT (%JKRTriggers,%File, %JKRKeyField)
      #ENDIF  
  #ENDFOR
  #!
  #!  Create single indexes for all tables
  #!
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
  #INSERT(%JKRMakeSingleIndexFromKeyDefinitions)
  #ENDFOR
  #!
  #!  Indexes for all tables
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT (%JKRKeyDefinitions)
  #ENDFOR
  #!
  #!  ForeignKeys for all tables
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #FOR (%Relation)
      #INSERT (%JKRForeignKeys)
    #ENDFOR
  #ENDFOR
  #!
  #!  Auto No Triggers for all tables
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT(%JKRGetPrimaryKeyColumn)
    #IF (%JKRHasPrimary = 1)
      #INSERT (%JKRTriggers,%File, %JKRKeyField)
    #ENDIF  
  #ENDFOR
  #!
  #!  Stored procedures that return the next auto no inc on a tables primary key
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT(%JKRGetPrimaryKeyColumn)
    #IF (%JKRHasPrimary = 1)
      #INSERT (%JKRGenPrimaryKeySP,%File, %JKRKeyField)
    #ENDIF  
  #ENDFOR
  #!
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'TablesWithDrop.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

  Tables with drop table
*/
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT (%JKRSQLFileDetail,1)
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'TablesWithoutDrop.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

  Tables without drop table
*/
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT (%JKRSQLFileDetail,0)
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'Indexs.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Indexes for all tables
    
*/
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT (%JKRKeyDefinitions)
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #!
  #SET (%OutputFile, %CurrentPath &  'DropIndexs.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Drop Indexes for all tables
    
*/
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT (%JKRDropKeyDefinitions)
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'ForeignKeys.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Foreign keys
    
*/
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #FOR (%Relation)
      #INSERT (%JKRForeignKeys)
    #ENDFOR
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'AutoNoTriggers.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Auto No Triggers
    
*/
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT(%JKRGetPrimaryKeyColumn)
    #IF (%JKRHasPrimary = 1)
      #INSERT (%JKRTriggers,%File, %JKRKeyField)
    #ENDIF  
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'AutoNoTriggersWithNullCheck.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Auto No Triggers with null check on the primary column before incrementing
    
*/
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT(%JKRGetPrimaryKeyColumn)
    #IF (%JKRHasPrimary = 1)
      #INSERT (%JKRNullTriggers,%File, %JKRKeyField)
    #ENDIF  
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #!
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'SPReturnsNextAutoNo.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Stored procedures that return the next auto no inc on a tables primary key
    
*/
  #! 
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #INSERT(%JKRGetPrimaryKeyColumn)
    #IF (%JKRHasPrimary = 1)
      #INSERT (%JKRGenPrimaryKeySP,%File, %JKRKeyField)
    #ENDIF  
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'Constraints.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
   Created from definitions in %DictionaryFile

   Constraints
    
*/
  #!
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #FOR (%Relation)
      #INSERT (%JKRConstraints)
    #ENDFOR
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'NotNullColumns.TXT')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
   Created from definitions in %DictionaryFile

   All columns declared with NOT NULL condition
   Important for conversion purposes
    
*/
  #!
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #FOR (%File)
      #INSERT (%JKRNotNullColumns)
    #ENDFOR
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'DropTables.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Drop table for all tables
    
*/
  #!
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
    #SET (%JKRFileName, UPPER(%File))
  DROP TABLE %JKRFileName;
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'CreateSingleIndex.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Create single indexes for all tables
    
*/
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
  #INSERT(%JKRMakeSingleIndexFromKeyDefinitions)
  #ENDFOR
  #CLOSE (%OutputFile)
  #!
  #! -----------------------------------------------------------------------------------------------
  #!
  #SET (%OutputFile, %CurrentPath &  'DropSingleIndex.SQL')
  #CREATE (%OutputFile)
/* JKRSQL.Tpl SQL Script Generated %@D17@(TODAY()) at %@T7@(CLOCK())
    Created from definitions in %DictionaryFile

    Drop single indexes for all tables
    
*/
  #FOR (%SortedFiles)
    #FIX (%File, %SortedFiles)
  #INSERT(%JKRMakeDropSingleIndexFromKeyDefinitions)
  #ENDFOR
  #CLOSE (%OutputFile)
#ENDIF
#!
#!
#!-----------------------------------------------
#GROUP (%JKRSQLFileDetail,%JKRAddDropTable)
#!-----------------------------------------------
#! Print Dictionary 
#!-----------------------------------------------
#!

#IF (%FileDescription)
/*  %[23]SortedFiles %FileDescription  */
  #IF (%FileLongDesc)
#!/*  %FileLongDesc  */
  #ENDIF
#ELSE
/*  %SortedFiles*/
  #IF (%FileLongDesc)
#!/*  %FileLongDesc  */
  #ENDIF
#ENDIF

#SET (%JKRFileName, UPPER(%File))
  
#IF(%JKRAddDropTable = 1)  
/*  Drop the existing table & data if it already exists  */
  DROP TABLE %JKRFileName;
#ENDIF  
  CREATE TABLE %JKRFileName
  (
  #SET (%JKRCounter,0)
 #! #FOR (%Field)
    #INSERT (%JKRConvertFieldToSQL)
#!  #ENDFOR
  #INSERT (%JKRPrimaryKey)
  );
#!
#!-----------------------------------------------
#GROUP (%JKRConvertFieldToSQL)
#!-----------------------------------------------
#! Convert TPS data type to Firebird
#!-----------------------------------------------
#!
#! #CLEAR( %JKRFieldType)       
#!
#!  #FOR (%Field)
#! %[30]%FieldID    %FieldType
#!  #ENDFOR
  #FOR (%Field)
#! #SET (%JKRCounter, %JKRCounter + 1)
#! #IF (%JKRCounter > 1)                                             #! Insert previous field
#!       %[30]JKRFieldName    %JKRFieldType,       
#! #ENDIF
#! Use external name if specified - might be needed if SQL reserved words have been used
    #IF (%FieldName)
        #SET (%JKRFieldName, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    #ELSE
        #SET (%JKRFieldName, UPPER(%FieldID))
    #ENDIF
#!
#! See what type we have
#!
#! TargetDatabase = 'Firebird' 
 #CASE (%FieldType)
  #OF ('PICTURE') #OROF ('LIKE')  #OROF ('TYPE')
    #SET (%JKRFieldType,'PICTURE - TYPE - LIKE  -  ARE NOT ALLOWED')
  #OF ('BLOB')
    #SET (%JKRFieldType,'BLOB SUB_TYPE 0 SEGMENT SIZE 80')
  #OF ('BYTE')
    #SET (%JKRFieldType,'SMALLINT')
  #OF ('CSTRING') #OROF ('PSTRING')
    #IF (%FieldMemoSize > 32765)
      #SET (%JKRFieldType,'BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
    #ELSE
      #IF(%JKRChangeStringTypesToBlob = 1)
        #IF (%FieldMemoSize > %JKRChangeStringTypesToBlobSize-1)
          #SET (%JKRFieldType,'BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
        #ELSE
          #SET (%JKRFieldType,'VARCHAR' & '(' & %FieldMemoSize & ')')
        #ENDIF
      #ELSE
          #SET (%JKRFieldType,'VARCHAR' & '(' & %FieldMemoSize & ')')
      #ENDIF
    #ENDIF
  #OF ('DATE') 
    #SET (%JKRFieldType,'DATE')
  #OF ('TIME') 
    #SET (%JKRFieldType,'TIME')
  #OF ('LONG') 
    #! Convert longs fields to DATE and longs to Time if checked - else make interger
    #IF (INSTRING('D',UPPER(%FieldPicture),1,1))
      #IF(%JKRChangeDateNames = 1)
        #SET (%JKRFieldType,'DATE')
      #ELSE
        #SET (%JKRFieldType,'INTEGER')
      #ENDIF
    #ELSIF (INSTRING('T',UPPER(%FieldPicture),1,1))
      #IF(%JKRChangeTimeNames = 1)
        #SET (%JKRFieldType,'TIME')
      #ELSE
        #SET (%JKRFieldType,'INTEGER')
      #ENDIF
    #ELSE
        #SET (%JKRFieldType,'INTEGER')
    #ENDIF
  #OF ('ULONG')
    #SET (%JKRFieldType,'INTEGER')
  #OF ('SHORT') #OROF ('USHORT')
    #SET (%JKRFieldType,'SMALLINT')
  #OF ('STRING')
    #IF (%FieldMemoSize > 32765)
      #SET (%JKRFieldType,'BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
    #ELSE
      #IF(%JKRChangeStringTypesToBlob = 1)
        #IF (%FieldMemoSize > %JKRChangeStringTypesToBlobSize-1)
          #SET (%JKRFieldType,'BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
        #ELSE
          #SET (%JKRFieldType,'CHAR' & '(' & %FieldMemoSize & ')')
        #ENDIF
      #ELSE
          #SET (%JKRFieldType,'CHAR' & '(' & %FieldMemoSize & ')')
      #ENDIF
    #ENDIF
  #OF ('MEMO')
    #IF(%FieldMemoImage = 1)
      #SET (%JKRFieldType,'BLOB SUB_TYPE 0 SEGMENT SIZE 80')
    #ELSE
      #SET (%JKRFieldType,'BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
    #ENDIF
  #OF  ('DECIMAL')
  #OROF('PDECIMAL')
      #SET(%JKRFieldType, 'DECIMAL(' & %FieldMemoSize & ',' & %FieldPlaces & ')')
  #OF  ('SREAL')
  #OROF('BFLOAT4')
      #SET(%JKRFieldType, 'FLOAT')
  #OF  ('REAL')
  #OROF('BFLOAT8')
      #SET(%JKRFieldType, 'DOUBLE PRECISION')
  #OF  ('GROUP')
  #OROF('END')
      #CYCLE
 #ENDCASE
 #!
 #IF(%JKRNoDefaults = 0)
   #IF(%FieldInitial)
     #SET(%JKRFoundLeftSideMatch,0)
     #IF(ITEMS(%JKRInitialValueList))
       #FOR(%JKRInitialValueList)
         #IF(INSTRING('=',%JKRInitialValueList,1,1))
           #SET(%JKRLeftSideOfStringLocation,(INSTRING('=',%JKRInitialValueList,1,1)))
           #SET(%JKRLeftSideOfString,SUB(%JKRInitialValueList,1,%JKRLeftSideOfStringLocation-1))
           #SET(%JKRRightSideOfString,SUB(%JKRInitialValueList,%JKRLeftSideOfStringLocation+1,LEN(%JKRInitialValueList)))
           #IF(UPPER(CLIP(RIGHT(%JKRLeftSideOfString))) = UPPER(CLIP(RIGHT(%FieldInitial))) )
               #SET(%JKRFoundLeftSideMatch,1)
             #IF(CLIP(RIGHT(%JKRRightSideOfString))='')
               #! EMPTY JKRRightSideOfString %JKRRightSideOfString
               #CYCLE
             #ELSE  
               #! NO EMPTY JKRRightSideOfString %JKRRightSideOfString
               #SET (%JKRFieldType, %JKRFieldType & ' DEFAULT ' & CLIP(RIGHT(%JKRRightSideOfString)))
               #CYCLE
             #ENDIF
           #ENDIF
         #ELSE
           #CYCLE
         #ENDIF
       #ENDFOR
     #ENDIF
     #!
     #IF(%JKRFoundLeftSideMatch = 0)
        #IF (INSTRING('D',UPPER(%FieldPicture),1,1))
            #! do nothing for dates or times
        #ELSIF (INSTRING('T',UPPER(%FieldPicture),1,1))
            #! do nothing for dates or times
        #ELSE
           #! #SET (%JKRFieldType, %JKRFieldType & ' DEFAULT ')
           #SET (%JKRFieldType, %JKRFieldType & ' DEFAULT ' & %FieldInitial)
        #ENDIF
     #ENDIF
   #ENDIF
 #ENDIF
 #!
 #! If Cannot Be Zero Or Blank is set it is always written into the scripts
 #!
 #CASE(%FieldValidation)   
 #OF ( 'NONZERO')
    #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL')
 #ENDCASE
#IF(%JKRFieldValidation = 0)
  #CASE(%FieldValidation)   
   #OF ( 'BOOLEAN')
     #IF(%FieldTrueValue AND %FieldFalseValue)
       #CASE (%FieldType)
          #OF ('CSTRING') #OROF ('PSTRING') #OROF ('STRING')
            #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' = ' & '''' & %FieldTrueValue  & '''' & ' OR '  & %JKRFieldName & ' = ' & '''' & %FieldFalseValue & '''' & ')' )
          #ELSE
            #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' = ' & %FieldTrueValue  & ' OR '  & %JKRFieldName & ' = ' & %FieldFalseValue & ')' )
       #ENDCASE
     #ENDIF
   #OF ( 'INLIST')
     #IF (ITEMS(%FieldValues))
       #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' IN (')
       #SET (%JKRCounterLoc, 0)
       #FOR(%FieldValues)
         #IF (%JKRCounterLoc = 0)
           #SET (%JKRFieldType, %JKRFieldType & '''' & %FieldValues & '''' )
           #SET (%JKRCounterLoc, 1)
         #ELSE
           #SET (%JKRFieldType, %JKRFieldType & ',' & '''' & %FieldValues & '''' )
         #ENDIF
       #ENDFOR
       #SET (%JKRFieldType, %JKRFieldType & '))')
     #ENDIF
   #OF ( 'INRANGE')
     #IF (%FieldRangeLow AND %FieldRangeHigh)
        #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' BETWEEN ' & %FieldRangeLow & ' AND ' &  %FieldRangeHigh &')'  )
     #ELSIF (%FieldRangeLow AND NOT %FieldRangeHigh)
        #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' >= ' & %FieldRangeLow &')'  )
     #ELSIF (NOT %FieldRangeLow AND %FieldRangeHigh)
        #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' <= '  &  %FieldRangeHigh &')'  )
     #ENDIF
  #ENDCASE
#ENDIF
 %[30]JKRFieldName    %JKRFieldType,       
   #ENDFOR

#!
#!
#!-----------------------------------------------
#GROUP (%JKRPrimaryKey)
#!-----------------------------------------------
#! Define Primary Key for file and Unique Keys
#!
#!-----------------------------------------------
#!
#SET (%JKRFileName, UPPER(%File))
#!
#! See if file has a Primary key field
#SET (%JKRHasPrimary,0)
#FOR (%Key)
  #IF (%KeyPrimary)
    #SET (%JKRHasPrimary,1)
    #BREAK
  #ENDIF
#ENDFOR
#IF (%JKRHasPrimary = 1)
  #IF (%JKRCounter > 0)                                             #! Insert previous field and if only one in file set the if to 0
         %[30]JKRFieldName    %JKRFieldType,
  #ENDIF
  #FOR (%Key)
    #IF (%KeyPrimary = 1)
      #SET (%JKRCounter,0)
      #FOR (%KeyField)
        #SET (%JKRCounter,%JKRCounter + 1)
        #FIX (%Field, %KeyField)
        #! Use external name if specified - might be needed if SQL reserved words have been used for field names
    #IF (%FieldName)
        #SET (%JKRKeyField, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    #ELSE
        #SET (%JKRKeyField, UPPER(%FieldID))
    #ENDIF
        #IF (%JKRCounter > 1)
          #SET (%JKRFieldName, %JKRFieldName & ', ' & %JKRKeyField)
        #ELSE
          #SET (%JKRFieldName, %JKRKeyField)
        #ENDIF
      #ENDFOR
         CONSTRAINT PK_%JKRFileName PRIMARY KEY (%JKRFieldName)
    #ENDIF
  #ENDFOR
#ELSE                                                                 #! No Comma!
         %[30]JKRFieldName    %JKRFieldType
#ENDIF
#!
#!
#!-----------------------------------------------
#GROUP (%JKRKeyDefinitions)
#!-----------------------------------------------
#! Define Other Keys for all Files
#!
#!-----------------------------------------------
#! %JKRFileName
#! #IF (%FileName)
#!  #SET (%JKRFileName, UPPER(SUB(%FileName,2,LEN(%FileName)-2)))
#! #ELSE
  #SET (%JKRFileName, UPPER(%File))
#! #ENDIF
#!
#FOR (%Key), WHERE (%KeyPrimary = 0)
  #! %JKRFileName %JKRKeyName
  #IF (%KeyName)
     #SET (%JKRKeyName, UPPER(SUB(%KeyName,2,LEN(%KeyName)-2)))
  #ELSE
     #! no colons allowed 
     #SET (%JKRKeyName, UPPER(%FilePrefix) &    UPPER(%KeyId))
  #ENDIF
  #!
  #SET (%JKRCounter,0)
  #FOR (%KeyField)
    #SET (%JKRCounter,%JKRCounter + 1)
    #FIX (%Field, %KeyField)
    #! Use external name if specified - might be needed if SQL reserved words have been used for field names
    #IF (%FieldName)
        #SET (%JKRKeyField, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    #ELSE
        #SET (%JKRKeyField, UPPER(%FieldID))
    #ENDIF
    #IF (%JKRCounter > 1)
      #SET (%JKRFieldName, %JKRFieldName & ', ' & %JKRKeyField)
    #ELSE
      #SET (%JKRFieldName, %JKRKeyField)
    #ENDIF
    #IF (%KeyFieldSequence = 'DESCENDING')
     #!       #SET (%JKRFieldName, %JKRFieldName & ' DESCENDING')
      #SET (%JKRFieldName, %JKRFieldName)
    #ENDIF
  #ENDFOR
  #! 
  #IF (%KeyDuplicate = 0)
     #SET (%JKRIndexDeclaration, 'CREATE UNIQUE INDEX ' & Upper(%JKRKeyName) & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRFieldName) & ');')
  %JKRIndexDeclaration
  #!#SET(%JKRAddSpaceCounter,1)
  #ELSE
     #SET (%JKRIndexDeclaration, 'CREATE INDEX ' & Upper(%JKRKeyName) & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRFieldName) & ');')
  %JKRIndexDeclaration   
  #ENDIF
#ENDFOR
#!
#SET(%JKRAddSpaceCounter,1)
#IF(%JKRAddSpaceCounter > 0)
  #! add a blank space after any found keys for this table
    
#ENDIF
#!    
#!
#!-----------------------------------------------
#GROUP (%JKRDropKeyDefinitions)
#!-----------------------------------------------
#! Define Drop For Other Keys for all Files
#!
#!-----------------------------------------------
#! %JKRFileName
#! #IF (%FileName)
#!  #SET (%JKRFileName, UPPER(SUB(%FileName,2,LEN(%FileName)-2)))
#! #ELSE
  #SET (%JKRFileName, UPPER(%File))
#! #ENDIF
#!
#FOR (%Key), WHERE (%KeyPrimary = 0)
  #! %JKRFileName %JKRKeyName
  #IF (%KeyName)
     #SET (%JKRKeyName, UPPER(SUB(%KeyName,2,LEN(%KeyName)-2)))
  #ELSE
     #! no colons allowed 
     #SET (%JKRKeyName, UPPER(%FilePrefix) &    UPPER(%KeyId))
  #ENDIF
  #!
  #SET (%JKRCounter,0)
  #FOR (%KeyField)
    #SET (%JKRCounter,%JKRCounter + 1)
    #FIX (%Field, %KeyField)
    #! Use external name if specified - might be needed if SQL reserved words have been used for field names
    #IF (%FieldName)
        #SET (%JKRKeyField, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    #ELSE
        #SET (%JKRKeyField, UPPER(%FieldID))
    #ENDIF
    #IF (%JKRCounter > 1)
      #SET (%JKRFieldName, %JKRFieldName & ', ' & %JKRKeyField)
    #ELSE
      #SET (%JKRFieldName, %JKRKeyField)
    #ENDIF
    #IF (%KeyFieldSequence = 'DESCENDING')
      #SET (%JKRFieldName, %JKRFieldName & ' DESCENDING')
    #ENDIF
  #ENDFOR
  #! 
  #IF (%KeyDuplicate = 0)
     #SET (%JKRIndexDeclaration, 'DROP INDEX ' & Upper(%JKRKeyName) & ';' )
  %JKRIndexDeclaration   
  #!#SET(%JKRAddSpaceCounter,1)
  #ELSE
     #SET (%JKRIndexDeclaration, 'DROP INDEX ' & Upper(%JKRKeyName)  & ';' )
  %JKRIndexDeclaration   
  #ENDIF
#ENDFOR
#!
#!
#!-----------------------------------------------
#GROUP (%JKRConstraints)
#!-----------------------------------------------
#! Create constraints
#!
#!-----------------------------------------------
#!
#! NONE HERE SO STOP LOOKING
#!
#!-----------------------------------------------
#GROUP (%JKRTriggers, %UpperFileName, %AutoNoColumn)
#!-----------------------------------------------
#! Creates a trigger for all numeric primary keys
#!
#!-----------------------------------------------
#!
#! Return and make no Trigger for string primary keys
#!
#FOR (%Key)
   #IF (%KeyPrimary = 1)
      #SET (%JKRCounter,0)
      #FOR (%KeyField)
        #SET (%JKRCounter,%JKRCounter + 1)
        #FIX (%Field, %KeyField)
        #CASE (%FieldType)
          #OF ('BLOB')
          #OROF ('CSTRING')
          #OROF ('STRING')
          #OROF ('MEMO')
            #RETURN
          #OF ('BYTE')
          #OF ('LONG') #OROF ('ULONG')
          #OF ('SHORT') #OROF ('USHORT')
          #ELSE
            #RETURN
        #ENDCASE
      #ENDFOR
   #ENDIF         #!  (%KeyPrimary = 1)   
#ENDFOR
#!
#DECLARE(%UpperFileNameAutoNoString)
#!
#!
#! #SET(%UpperFileNameAutoNoString,%UpperFileName & 'AUTONO')
#SET(%UpperFileNameAutoNoString,UPPER(%AutoNoColumn) & 'AUTONO')
#!

/*  
    Table %UpperFileName  
    Trigger and generator names
    could excede the 31 character max - so be warned
*/

CREATE GENERATOR %UpperFileNameAutoNoString;
SET TERM !! ;
CREATE TRIGGER GET%UpperFileNameAutoNoString FOR %UpperFileName
ACTIVE BEFORE INSERT POSITION 0
AS 
BEGIN
  NEW.%AutoNoColumn = GEN_ID(%UpperFileNameAutoNoString, 1);
END  !!
SET TERM ; !!

#!
#!
#!-----------------------------------------------
#GROUP (%JKRNullTriggers, %UpperFileName, %AutoNoColumn)
#!-----------------------------------------------
#! Creates a trigger for all numeric primary keys
#! Create null only triggers so an insert is given a new primary key no only if it is null
#! use for those occasions when you have all ready got your
#! primary key no for your parent and also for the children from a call to a generator for the table
#!
#!-----------------------------------------------
#!
#! Return and make no Trigger for string primary keys
#!
#FOR (%Key)
   #IF (%KeyPrimary = 1)
      #SET (%JKRCounter,0)
      #FOR (%KeyField)
        #SET (%JKRCounter,%JKRCounter + 1)
        #FIX (%Field, %KeyField)
        #CASE (%FieldType)
          #OF ('BLOB')
          #OROF ('CSTRING')
          #OROF ('STRING')
          #OROF ('MEMO')
            #RETURN
          #OF ('BYTE')
          #OF ('LONG') #OROF ('ULONG')
          #OF ('SHORT') #OROF ('USHORT')
          #ELSE
            #RETURN
        #ENDCASE
      #ENDFOR
   #ENDIF         #!  (%KeyPrimary = 1)   
#ENDFOR
#!
#DECLARE(%UpperFileNameAutoNoString)
#!
#!
#! #SET(%UpperFileNameAutoNoString,%UpperFileName & 'AUTONO')
#SET(%UpperFileNameAutoNoString,UPPER(%AutoNoColumn) & 'AUTONO')
#!

/*  Table %UpperFileName  */
/*  Triggers and generator names using a null condition
    This generator is for the stored procedure for returning the auto inc on a table. 
    Use for getting the parent new record id for the children
    The trigger for the parent must be the one that does not call the generator unless the id is null
    could excede the 31 max - so be warned
*/

CREATE GENERATOR %UpperFileNameAutoNoString;
SET TERM !! ;
CREATE TRIGGER GET%UpperFileNameAutoNoString FOR %UpperFileName
ACTIVE BEFORE INSERT POSITION 0
AS 
BEGIN
  IF NEW.%AutoNoColumn IS NULL THEN NEW.%AutoNoColumn = GEN_ID(%UpperFileNameAutoNoString, 1);
END !!
SET TERM ; !!

#!
#!
#!-----------------------------------------------
#GROUP (%JKRGenPrimaryKeySP, %UpperFileName, %AutoNoColumn)
#!-----------------------------------------------
#! Creates a stored procedure for all numeric primary keys
#! use to return the primary key no from the generator call in the SP
#! use for those occasions when you need the primary key no for
#! your parent record and the child records
#!
#!-----------------------------------------------
#!
#! Return and make no Trigger for string primary keys
#!
#FOR (%Key)
   #IF (%KeyPrimary = 1)
      #SET (%JKRCounter,0)
      #FOR (%KeyField)
        #SET (%JKRCounter,%JKRCounter + 1)
        #FIX (%Field, %KeyField)
        #CASE (%FieldType)
          #OF ('BLOB')
          #OROF ('CSTRING')
          #OROF ('STRING')
          #OROF ('MEMO')
            #RETURN
          #OF ('BYTE')
          #OF ('LONG') #OROF ('ULONG')
          #ELSE
            #RETURN
        #ENDCASE
      #ENDFOR
   #ENDIF         #!  (%KeyPrimary = 1)   
#ENDFOR
#!
#DECLARE(%UpperFileNameAutoNoString)
#DECLARE(%UpperFileNameAutoNoStringSP)
#!
#!
#! #SET(%UpperFileNameAutoNoString,%UpperFileName & 'AUTONO')
#SET(%UpperFileNameAutoNoString,UPPER(%AutoNoColumn) & 'AUTONO')
#SET(%UpperFileNameAutoNoStringSP,UPPER(%AutoNoColumn) & 'AUTONO_SP')
#!


/*  Table %UpperFileName  */
/*  Stored procedure for returning the auto inc on a table. Use for getting the parent new record id for the children
     The trigger for the parent must be the one that does not call the generator unless the id is null
     This is a select procedure in Firebird and it operates a little different than an executable procedure
     If called by SELECT * FROM SP Name
     the SUSPEND IS REQUIRED so see below
     These names could excede the 31 max - so be warned
     The generator name is the same name given to the generator on the Primary key on the table
     so the generator needs to be present
*/


SET TERM !! ;
CREATE PROCEDURE %UpperFileNameAutoNoStringSP
RETURNS (AUTOINCNO INTEGER) AS
BEGIN
AUTOINCNO = GEN_ID(%UpperFileNameAutoNoString, 1); 
SUSPEND; 
END !!
SET TERM ; !!
#!
#!
#!-----------------------------------------------
#GROUP (%JKRGetPrimaryKeyColumn)
#!-----------------------------------------------
#! Get Primary Key column
#!
#!-----------------------------------------------
#!
#! See if file has a Primary key field
#SET (%JKRHasPrimary,0)
#FOR (%Key)
  #IF (%KeyPrimary)
    #SET (%JKRHasPrimary,1)
    #BREAK
  #ENDIF
#ENDFOR
#IF (%JKRHasPrimary = 1)
  #FOR (%Key)
    #IF (%KeyPrimary = 1)
      #SET (%JKRCounter,0)
      #FOR (%KeyField)
        #SET (%JKRCounter,%JKRCounter + 1)
        #FIX (%Field, %KeyField)
        #! Use external name if specified - might be needed if SQL reserved words have been used for field names
    #IF (%FieldName)
        #SET (%JKRKeyField, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    #ELSE
        #SET (%JKRKeyField, %FieldID)
    #ENDIF
        #IF (%JKRCounter > 1)
          #SET (%JKRFieldName, %JKRFieldName & ', ' & %JKRKeyField)
        #ELSE
          #SET (%JKRFieldName, %JKRKeyField)
        #ENDIF
      #ENDFOR
    #ENDIF
  #ENDFOR
#ENDIF
#!
#!-----------------------------------------------
#GROUP (%JKRCheckNames)
#!-----------------------------------------------
#! Check the names of files and fields
#!
#!-----------------------------------------------
#!
#SET (%JKRCounter, 0)
#FOR (%SortedFiles)
  #FIX (%File, %SortedFiles)
    #IF (%FileName)
      #INSERT (%JKRCheckName,UPPER(SUB(%File,2,LEN(%File)-2)),0)
    #ELSE
      #INSERT (%JKRCheckName,%File,0)
    #ENDIF
  #FOR (%Field)
   #CASE (%FieldType)
     #OF ('PICTURE') #OROF ('LIKE')  #OROF ('TYPE')
      #SET (%JKRCounter, %JKRCounter + 1)
        #IF (%JKRCounter = 1)
          Error File                            FieldName
        #ENDIF
        %[4]JKRCounter  %[30]File  %Field is a type PICTURE - LIKE - TYPE - and these are NOT ALLOWED
    #ENDCASE
    #!
    #IF (%FieldName)
      #INSERT (%JKRCheckName, SUB(%FieldName,2,LEN(%FieldName)-2),1)
    #ELSE
      #INSERT (%JKRCheckName, %FieldID,0)
    #ENDIF
  #ENDFOR
  #FOR (%Key)
  #!
  #IF (%KeyName)
      #INSERT (%JKRCheckName, UPPER(SUB(%KeyName,2,LEN(%KeyName)-2)),1)
  #ELSE
      #INSERT (%JKRCheckName, %KeyID,0)
  #ENDIF
    #! See if file has a Primary key field
  #ENDFOR
  #INSERT(%JKRCheckForPrimaryKey)
#ENDFOR
#!
#!-----------------------------------------------
#GROUP (%JKRCheckName,%JKRFieldNameToCheck,%JKRPassedExternalName)
#!-----------------------------------------------
#! Check the names of files and fields
#!
#!-----------------------------------------------
#!
#FIND(%SqlWordList, UPPER(%JKRFieldNameToCheck))                        #! search of SQL and clarion reserved words
#IF(%SqlWordList)                                                          
  #SET (%JKRCounter, %JKRCounter + 1)
  #IF (%JKRCounter = 1)
  Error File                            FieldName
  #ENDIF
  %[4]JKRCounter  *** %[30]File  %JKRFieldNameToCheck is a reserved word
#ENDIF                                                  
#IF (LEN(%JKRFieldNameToCheck) > 27)
  #SET (%JKRCounter, %JKRCounter + 1)
  #IF (%JKRCounter = 1)
  Error File                            FieldName
  #ENDIF
   #SET(%TotalChars,LEN(%JKRFieldNameToCheck))
  %[4]JKRCounter  %[30]File  %JKRFieldNameToCheck is longer than 27 characters - TOTAL %TotalChars
#ENDIF
  #! check for uppercase on %Fieldname
#IF(%JKRPassedExternalName=1)  
#IF (%JKRFieldNameToCheck <> UPPER(%JKRFieldNameToCheck))
  #SET (%JKRCounter, %JKRCounter + 1)
  #IF (%JKRCounter = 1)
  Error File                            FieldName
  #ENDIF
  %[4]JKRCounter  %[30]File  %JKRFieldNameToCheck is an external field name that has lower case characters NOT ALLOWED
#ENDIF
#ENDIF
#RETURN
#!
#!
#!-----------------------------------------------
#GROUP (%JKRCheckForPrimaryKey)
#!-----------------------------------------------
#! Write output file entry if no Primary Key for file 
#!
#!-----------------------------------------------
#!
#! See if file has a Primary key field
#SET (%JKRHasPrimary,0)
#FOR (%Key)
  #IF (%KeyPrimary)
    #FOR(%KeyField)
      #FIX(%Field,%KeyField)
      #IF(%FieldValidation <> 'NONZERO')
        #SET (%JKRCounter, %JKRCounter + 1)
  #IF (%JKRCounter = 1)
  Error File                            FieldName
  #ENDIF
  %[4]JKRCounter  %[30]File  %[30]KeyField Key column not marked as NONZERO
      #ENDIF
    #ENDFOR
    #SET (%JKRHasPrimary,1)
    #BREAK
  #ENDIF
#ENDFOR
#IF (%JKRHasPrimary = 0)
  #SET (%JKRCounter, %JKRCounter + 1)
  #IF (%JKRCounter = 1)
  Error File                            FieldName
  #ENDIF
  %[4]JKRCounter  %[30]File  Has No Primary Key Declared
#ENDIF
#!
#!
#!-----------------------------------------------
#GROUP (%JKRForeignKeys)
#!-----------------------------------------------
#!
#! Define Foreign Keys
#!
#!-----------------------------------------------
#!
#! CODE NOT COMPLETE
#!
#! #RETURN
#SET (%JKRFileName, UPPER(%File))
#IF (%FileRelationType = 'MANY:1')

  #SET (%JKRCounter,0)
  #FOR (%FileKeyField)
    #IF (%FileKeyFieldLink)
      #SET (%JKRCounter, %JKRCounter + 1)
      #FIX(%Field,%FileKeyField)
      #IF (%JKRCounter > 1)
        #! Use external name if specified - might be needed if SQL reserved words have been used for field names
        #IF (%FieldName)
          #SET (%JKRFileKeyField,%JKRFileKeyField & ', ' & UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
        #ELSE
          #SET (%JKRFileKeyField,%JKRFileKeyField & ', ' & UPPER(%FieldID))
        #ENDIF
      #ELSE
        #! Use external name if specified - might be needed if SQL reserved words have been used for field names
        #IF (%FieldName)
          #SET (%JKRFileKeyField,UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
        #ELSE
          #SET (%JKRFileKeyField,UPPER(%FieldID))
        #ENDIF
      #ENDIF
      #SET (%JKRFieldName, UPPER(%FileKeyFieldLink))
      #SET (%JKRRelation, UPPER(%Relation))
      #FIX (%File, %Relation)
      #FIX (%Field, %JKRFieldName)
      #IF (%JKRCounter > 1)
        #! Use external name if specified - might be needed if SQL reserved words have been used for field names
        #IF (%FieldName)
          #SET (%JKRFileFieldLink,%JKRFileFieldLink & ', ' & UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
        #ELSE
          #SET (%JKRFileFieldLink,%JKRFileFieldLink & ', ' & UPPER(%FieldID))
        #ENDIF
      #ELSE
        #! Use external name if specified - might be needed if SQL reserved words have been used for field names
        #IF (%FieldName)
          #SET (%JKRFileFieldLink,UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
        #ELSE
          #SET (%JKRFileFieldLink,UPPER(%FieldID))
        #ENDIF
      #ENDIF
    #ENDIF
  #ENDFOR
    #IF (NOT %RelationConstraintDelete AND NOT %RelationConstraintUPDATE)
        ALTER TABLE %JKRFileName
        ADD CONSTRAINT FK_%FilePrefix_%JKRRelation FOREIGN KEY(%JKRFileKeyField)
        REFERENCES %JKRRelation (%JKRFileFieldLink);
        
        
    #ELSE
      #IF (%RelationConstraintDelete AND NOT %RelationConstraintUPDATE)
        ALTER TABLE %JKRFileName
        ADD CONSTRAINT FK_%FilePrefix_%JKRRelation FOREIGN KEY(%JKRFileKeyField)
        REFERENCES %JKRRelation (%JKRFileFieldLink);
        /* REFERENCES %JKRRelation (%JKRFileFieldLink)
           ON DELETE ;   */
           
           
      #ENDIF
      #IF (%RelationConstraintUpdate AND NOT %RelationConstraintDelete)
        ALTER TABLE %JKRFileName
        ADD CONSTRAINT FK_%FilePrefix_%JKRRelation FOREIGN KEY(%JKRFileKeyField)
        REFERENCES %JKRRelation (%JKRFileFieldLink);
        /* REFERENCES %JKRRelation (%JKRFileFieldLink)
           ON UPDATE ;   */
           
           
      #ENDIF
      #IF (%RelationConstraintUpdate AND %RelationConstraintDelete)
        ALTER TABLE %JKRFileName
        ADD CONSTRAINT FK_%FilePrefix_%JKRRelation FOREIGN KEY(%JKRFileKeyField)
        REFERENCES %JKRRelation (%JKRFileFieldLink);
        /* REFERENCES %JKRRelation (%JKRFileFieldLink)
           ON UPDATE    
           ON DELETE ;   */
           
           
      #ENDIF
    #ENDIF
#ENDIF
#!
#!
#!-----------------------------------------------
#GROUP (%JKRNotNullColumns)
#!-----------------------------------------------
#!
#! Define all columns that will be NOT NULL in the script file
#!
#!-----------------------------------------------

  %FILE     -    NOT NULL DECLARED COLUMNS
  #FOR(%FIELD)
    #! #IF (%FieldValidation = 'BOOLEAN' OR %FieldValidation = 'NONZERO')
    #IF (%FieldValidation = 'NONZERO')
     %FIELD
    #ENDIF
  #ENDFOR
#!
#!
#!-----------------------------------------------
#GROUP (%JKRMakeSingleIndexFromKeyDefinitions)
#!-----------------------------------------------
#! Makes script for both an ascending and descending index for each column of a multi column key and single column key for all Files
#!-----------------------------------------------
#!
#SET (%JKRFileName, UPPER(%File))
#FOR (%Key), WHERE (%KeyPrimary = 0)
  #! %JKRFileName %JKRKeyName
  #IF (%KeyName)
     #SET (%JKRKeyName, UPPER(SUB(%KeyName,2,LEN(%KeyName)-2)))
  #ELSE
     #! no colons allowed 
     #SET (%JKRKeyName, UPPER(%FilePrefix) &    UPPER(%KeyId))
  #ENDIF
  #!
  #FOR (%KeyField)
    #FIX (%Field, %KeyField)
    #! Use external name if specified 
    #IF (%FieldName)
        #SET (%JKRKeyField, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    #ELSE
        #SET (%JKRKeyField, UPPER(%FieldID))
    #ENDIF
    #!
    #IF(SUB(%JKRKeyField,1,LEN(%FilePrefix) ) = UPPER(%FilePrefix) )
      #ADD(%IndexForAllKeyColumns,'CREATE INDEX ' & Upper(%JKRKeyField) & '_ASC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
      #ADD(%IndexForAllKeyColumns,'CREATE DESCENDING INDEX ' & Upper(%JKRKeyField) & '_DESC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
    #ELSE
      #ADD(%IndexForAllKeyColumns,'CREATE INDEX ' & Upper(%FilePrefix) & %JKRKeyField & '_ASC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
      #ADD(%IndexForAllKeyColumns,'CREATE DESCENDING INDEX ' & Upper(%FilePrefix) & %JKRKeyField & '_DESC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
    #ENDIF
  #ENDFOR
  #! 
#ENDFOR
#!
/* 

    Create both an ascending and descending index for each column of a multi column key and single column key for
    %File
    
*/
#FOR(%IndexForAllKeyColumns)
%IndexForAllKeyColumns
#ENDFOR
#! ADD 1 SPACES AFTER EACH TABLE

#FREE(%IndexForAllKeyColumns)    
#!    
#!
#!-----------------------------------------------
#GROUP (%JKRMakeDropSingleIndexFromKeyDefinitions)
#!-----------------------------------------------
#! Makes script for dropping both an ascending and descending index for each column of a multi column key and single column key for all Files
#!-----------------------------------------------
#!
#SET (%JKRFileName, UPPER(%File))
#FOR (%Key), WHERE (%KeyPrimary = 0)
  #! %JKRFileName %JKRKeyName
  #IF (%KeyName)
     #SET (%JKRKeyName, UPPER(SUB(%KeyName,2,LEN(%KeyName)-2)))
  #ELSE
     #! no colons allowed 
     #SET (%JKRKeyName, UPPER(%FilePrefix) &    UPPER(%KeyId))
  #ENDIF
  #!
  #FOR (%KeyField)
    #FIX (%Field, %KeyField)
    #! Use external name if specified 
    #IF (%FieldName)
        #SET (%JKRKeyField, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    #ELSE
        #SET (%JKRKeyField, UPPER(%FieldID))
    #ENDIF
    #!
    #IF(SUB(%JKRKeyField,1,LEN(%FilePrefix) ) = UPPER(%FilePrefix) )
      #ADD(%IndexForAllKeyColumns,'CREATE INDEX ' & Upper(%JKRKeyField) & '_ASC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
      #ADD(%IndexForAllKeyColumns,'CREATE DESCENDING INDEX ' & Upper(%JKRKeyField) & '_DESC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
    #ELSE
      #ADD(%IndexForAllKeyColumns,'DROP INDEX ' & Upper(%FilePrefix) & %JKRKeyField & '_ASC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
      #ADD(%IndexForAllKeyColumns,'DROP DESCENDING INDEX ' & Upper(%FilePrefix) & %JKRKeyField & '_DESC' & ' ON ' & UPPER(%JKRFileName) & '(' & UPPER(%JKRKeyField) & ');' )
    #ENDIF
  #ENDFOR
  #! 
#ENDFOR
#!
/* 

    Create a Drop Indes for  the both an ascending and descending index for each column of a multi column key and single column key for
    %File
    
*/
#FOR(%IndexForAllKeyColumns)
%IndexForAllKeyColumns
#ENDFOR
#! ADD 1 SPACES AFTER EACH TABLE

#FREE(%IndexForAllKeyColumns)    
#!
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#UTILITY (FirebirdTemplateStep3, 'Step 3 - Dictionary Change - change column names/ types and driver for SQL Dictionary in a TXD'), WIZARD
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#! This template was adapted from a SQL template by G W Bomford
#!-----------------------------------------------
#SHEET
  #TAB('Page 1 0f 3'),FINISH(0)
    #BOXED('Change driver and column types in a TXD file')
      #DISPLAY()
      #DISPLAY('MAKE BACKUP COPIES OF YOUR DICTIONARY.')
      #DISPLAY()
      #DISPLAY('This is for changing the driver, column names and types, table owner, NAME attribute ')
      #DISPLAY(' and removing the Auto Inc in a TOPSPEED Or ODBC table only.')
      #DISPLAY(' You can overwrite or add the table name to the tables NAME attr.')
      #DISPLAY()
      #DISPLAY('IF YOU CREATE AND OPTION CALLED LocalFile FOR A TABLE NO CHANGES ARE MADE.')
      #DISPLAY('The USEROPTIONS are checked for LOCALFILE and this table is skipped if found.')
      #DISPLAY()
      #DISPLAY('Enter or select the TXD file name to read')
      #PROMPT('',OPENDIALOG('Pick File','Source|*.TXD')),%JKRSelectedTxdFile,REQ,AT(10)
      #DISPLAY()
      #DISPLAY('Enter the NEW TXD file name')
      #PROMPT ('',@s250),%JKRNewTxdFile,REQ,AT(10)
      #DISPLAY()
      #PROMPT ('Change Driver From Topspeed To ODBC',check),%JKRChangeDriverNames,DEFAULT(0),AT(10)
      #PROMPT ('Make table NAME attribute same as the table name',check),%JKRAddTableNames,DEFAULT(0),AT(10)
      #PROMPT ('Make the table OWNER attribute this variable name',check),%JKRAddTableOwner,DEFAULT(0),AT(10)
      #ENABLE(%JKRAddTableOwner = 1),CLEAR
      #DISPLAY('Example: Glo:dbOwner')
      #PROMPT ('',@S50),%JKRTableOwnerVariable,DEFAULT('Glo:dbOwner'),AT(10)
      #ENDENABLE
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
  #TAB('Page 2 0f 3'),FINISH(0)
    #BOXED('')
      #DISPLAY()
      #PROMPT ('Add external name to all columns as table prefix column name',check),%AddTablePrefixToAll,DEFAULT(0),AT(10)
      #PROMPT ('Add external name to a column/key reserved word as table prefix column/key name',check),%SetTablePrefixOnReservedWords,DEFAULT(0),AT(10)
      #DISPLAY()
      #PROMPT ('Move all Memo declarations to the file structure as strings',check),%ChangeMemo,DEFAULT(0),AT(10)
      #DISPLAY()
      #PROMPT ('Remove Auto Increment from keys',check),%RemoveAutoInc,DEFAULT(0),AT(10)
      #DISPLAY()
      #DISPLAY('Be consistant with the next 2 column Date and Time types.')
      #DISPLAY('If you did not change them to a Date and Time type in the Firebird Script')
      #DISPLAY('then do not change them in Step 3 that changes the TXD.')
      #DISPLAY()
      #PROMPT ('Change All LONGs With @D To DATE field type',check),%JKRChangeDateNames,DEFAULT(0),AT(10)
      #PROMPT ('Change All LONGs With @T To TIME field type',check),%JKRChangeTimeNames,DEFAULT(0),AT(10)
      #DISPLAY()
      #DISPLAY('Be consistant with the next column type and size change for a Firebird TEXT BLOB.')
      #DISPLAY('If you do not change them to a BLOB type in the Firebird Script then do not change them ')
      #DISPLAY('here to a string 63990 that changes the TXD. If you do, create the scripts again.')
      #DISPLAY()
      #DISPLAY('Check the box to change all STRING CSTRING PSTRING above the entered size below')
      #PROMPT ('Make all STRING CSTRING PSTRING a STRING 63990 - a BLOB for text in Firebird',check),%JKRChangeStringTypesToBlob,DEFAULT(0),AT(10)
      #ENABLE(%JKRChangeStringTypesToBlob = 1),CLEAR
      #DISPLAY('Example: 2000 makes any of these strings that are 2000 or more in size into a STRING 63990')
      #PROMPT ('Enter a number or uncheck the box',@N5),%JKRChangeStringTypesToBlobSize,DEFAULT(0)
      #ENDENABLE
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
  #TAB('Page 3 of 3'),FINISH(1)
    #BOXED('Change these column types in the TXD file')
      #DISPLAY()
      #DISPLAY('DRIVER FROM TOPSPEED TO ODBC')
      #DISPLAY()
      #DISPLAY('Table Name written in the Tables NAME Attri in Uppercase')
      #DISPLAY()
      #DISPLAY('LONG with @D changes to DATE')
      #DISPLAY('LONG with @T changes to TIME')
      #DISPLAY()
      #DISPLAY('MEMO types are changed by this template. They are changed to a string.')
      #DISPLAY('The STRING size is 63990.This is what they import as. In the scripts they')
      #DISPLAY('are declared as a BLOB SUB_TYPE TEXT SEGMENT SIZE 80')
      #DISPLAY()
      #DISPLAY('The AUTO INC can be removed from a primary key.')
      #DISPLAY()
      #DISPLAY('The scripts are created first and checked for the type of errors.')
      #DISPLAY('This template can correct some errors by changing')
      #DISPLAY('or adding external names to the columns.')
      #DISPLAY()
      #DISPLAY('The create conversion in step 4 can be done at any time if the')
      #DISPLAY('tables to convert have been changed to ODBC.')
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
#ENDSHEET
#!
#DECLARE (%CurrentPath)
#DECLARE(%ASCIIFileRecord)
#DECLARE(%AsciiFileRecordCopy)
#!
#DECLARE(%NewTxdAsciiRecord),MULTI
#DECLARE(%NewTxdAsciiRecordHolder)
#!
#DECLARE (%JKRFieldName)
#DECLARE (%JKRFieldType)
#DECLARE (%JKRCounter)
#!
#DECLARE(%JKRLeftSideOfStringLocation)
#DECLARE(%JKRRightSideOfStringLocation)
#DECLARE(%JKRLeftSideOfString)
#DECLARE(%JKRRightSideOfString)
#DECLARE(%FoundName)
#DECLARE(%FoundReseredWord,LONG)
#DECLARE(%JKRFilePrefix)
#DECLARE(%JKRFoundComment)
#DECLARE(%JKRFoundSpace,LONG)
#DECLARE(%JKREndStatementCounter,LONG)
#!
#DECLARE(%JKRAddNameAttribute,LONG)
#DECLARE(%JKRColumnName)
#DECLARE(%InDeclaredKeys,LONG)
#DECLARE(%InRecordStructure,LONG)
#DECLARE(%JKRFoundDateColumn,LONG)
#DECLARE(%JKRFoundTimeColumn,LONG)
#DECLARE(%FoundReservedWord,LONG)
#!
#DECLARE(%JKRFoundUserOption,LONG)
#DECLARE(%JKRFoundLocalFile,LONG)
#!
#DECLARE(%JKRNotTPSFile,LONG)
#DECLARE(%JKRBeginOfTableCheck,LONG)
#!
#DECLARE(%MemoDeclarations),MULTI
#DECLARE(%FoundMemo,LONG)
#DECLARE(%KeyDeclarations),MULTI
#DECLARE(%KeyTempStorage),MULTI
#!
#MESSAGE('Modifying TXD file',1)
#! setup check for reserved words
  #INSERT(%ClarionReservedWords)
  #INSERT(%SqlReservedWords)
  #FOR(%ClarionWordList)
    #ADD(%SqlWordList,%ClarionWordList)
  #ENDFOR
#!
  #INSERT(%JKROpenStep5TxdFile)
#!
#! ONLY ONE LINE THE CODE IS IN GROUPS
#!
#GROUP (%JKROpenStep5TxdFile)
#!-----------------------------------------------
#!
#! opens the txd file and makes the changes
#!
#!-----------------------------------------------
#set(%JKRCounter,0)
#! 
#OPEN(%JKRSelectedTxdFile),READ
#! 
#! #IF(%ERRORCODE)
#!   %ERROR(%ERRORCODE)
#! #RETURN
#! #ENDIF
#!
#! %JKRBeginOfTableCheck is used to set the begin of each table
#!
#SET(%JKRBeginOfTableCheck,1)
#LOOP
    #READ(%ASCIIFileRecord)
    #IF(%ASCIIFileRecord = %EOF)
        #BREAK
    #ENDIF
    #!
    #!--------BEGIN OF SKIP NON TOPSPEED FILES----------------------------
    #!
    #IF (INSTRING('FILE,DRIVER(',UPPER(%ASCIIFileRecord),1,1))
      #IF (INSTRING('FILE,DRIVER(''TOPSPEED''',UPPER(%ASCIIFileRecord),1,1) OR INSTRING('FILE,DRIVER(''ODBC''',UPPER(%ASCIIFileRecord),1,1))
        #SET(%JKRNotTPSFile,0)
        #SET(%JKRBeginOfTableCheck,0)
        #SET(%JKRFoundUserOption,0)
        #INSERT(%JKRGetFilePrefix)
        #INSERT(%JKRChangeDriverType)
        #!
        #! read next line of file ident and write to txd
        #!
        #READ(%ASCIIFileRecord)
        #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
        #!
        #SET(%JKREndStatementCounter,2)
        #SET(%InDeclaredKeys,1) #! set this here so we can get the keys after table checks and before record statement
        #!
        #CYCLE
      #ELSE
        #SET(%JKRNotTPSFile,1)
        #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
        #CYCLE
      #ENDIF
    #ENDIF
    #!
    #!
    #! *   END OF SKIP NON TOPSPEED FILES
    #!
    #!
    #! *   BEGIN OF LOCALFILE CHECK - this is always done before the file declaration in the TXD 
    #!
    #! we stay in this if until %JKRBeginOfTableCheck gets set to 0 - gets set to 0 by instring(Driver( and in this if statement
    #! gets reset to a 1 after out of record structure and at start
    #IF(%JKRBeginOfTableCheck = 1)
      #! check for a [USEROPTION] so we can then check for LOCALFILE on next pass
      #IF (SUB(%ASCIIFileRecord,1,12) = '[USEROPTION]')
        #SET(%JKRFoundUserOption,1)
        #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
        #CYCLE
      #ENDIF  
      #! check for a local file ON FIRST LINE AFTER [USEROPTION]
      #IF(%JKRFoundUserOption = 1)
        #IF (SUB(UPPER(%ASCIIFileRecord),1,10) = '!LOCALFILE')
          #SET(%JKRFoundLocalFile,1)
          #SET(%JKRFoundUserOption,0)
          #SET(%JKRBeginOfTableCheck,0)
          #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
          #CYCLE
        #ENDIF  
      #ENDIF  
      #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
      #CYCLE
    #ENDIF  
    #!
    #! *      END OF LOCALFILE CHECK
    #!
    #! *      TEST FOR END OF A RECORD CONDITIONS 
    #!
    #IF (UPPER(SUB(%ASCIIFileRecord,1,6)) = 'RECORD')
     #!
     #! * copy keys to txd before Record Structure
     #!
      #FOR(%KeyDeclarations)
        #!
        #! * check for auto on key
        #!
        #IF (SUB(%KeyDeclarations,1,2) = '!!')
          #IF(%RemoveAutoInc = 1 AND INSTRING(',AUTO',%KeyDeclarations,1,1) )      
            #SET(%JKRLeftSideOfString,SUB(%KeyDeclarations,1,( INSTRING(',AUTO',%KeyDeclarations,1,1) -1)))
            #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString)
            #CYCLE
          #ENDIF  
        #ENDIF  
        #!
        #! * check for ! or [ add and cycle
        #!
        #IF((SUB(%KeyDeclarations,1,1) = '!') OR (SUB(%KeyDeclarations,1,1) = '['))
          #ADD(%NewTxdAsciiRecord,%KeyDeclarations)
        #ELSE
          #!
          #! * check name on declaration for reserved word- either way do group that adds to queue
          #!
          #IF(INSTRING(',NAME(',%KeyDeclarations,1,1) )
            #INSERT(%JKRCheckKey,0,%KeyDeclarations)
            #! added to %NewTxdAsciiRecord in group so we just cycle
            #CYCLE
          #ELSE  
            #INSERT(%JKRCheckKey,1,%KeyDeclarations)
            #! added to %NewTxdAsciiRecord in group so we just cycle
            #CYCLE
          #ENDIF
        #ENDIF
      #ENDFOR     
      #!
      #! * always free temp queues
      #!
      #FREE(%KeyDeclarations)
      #!
      #! * now add the  'RECORD' ascii line
      #!
      #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
      #!
      #! * set in record structure and out of keys
      #!
      #SET(%InRecordStructure,1)
      #SET(%InDeclaredKeys,0)
      #CYCLE
   #ENDIF  
    #!
    #! * In record structure tests the next if statement sets us back to look for begin of a table structure if true
    #!
    #IF(%InRecordStructure)
      #!
      #! add indent line and cycle
      #!
      #IF (SUB(%ASCIIFileRecord,1,2) = '!!')
        #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
        #CYCLE
      #ENDIF  
      #!
      #! add a ! or [ line and cycle
      #!
      #IF (SUB(%ASCIIFileRecord,1,1) = '!' OR SUB(%ASCIIFileRecord,1,1) = '[' )
        #!
        #! TEST FOR DATE AND TIME CONDITIONS
        #!
        #IF(INSTRING('(@D',UPPER(%ASCIIFileRecord),1,1) AND SUB(%ASCIIFileRecord,1,1) = '!' )
          #SET(%JKRFoundDateColumn,1)
        #ENDIF
        #IF(INSTRING('(@T',UPPER(%ASCIIFileRecord),1,1) AND SUB(%ASCIIFileRecord,1,1) = '!' )
          #SET(%JKRFoundTimeColumn,1)
        #ENDIF
        #!
        #!    END TEST FOR DATE AND TIME CONDITIONS
        #!
        #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
        #CYCLE
      #ENDIF  
      #!
      #IF (SUB(CLIP(LEFT(%ASCIIFileRecord)),1,3) = 'END')
        #IF(%JKREndStatementCounter > 2) #! in a group so we write and cycle
          #SET(%JKREndStatementCounter, %JKREndStatementCounter - 1)
          #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
          #CYCLE
        #ENDIF
        #! add any memos to the end of the record structure
        #IF(%ChangeMemo = 1)
          #FOR(%MemoDeclarations)
            #! if we find the declaration check the column conditions
            #IF(INSTRING(' MEMO(',%MemoDeclarations,1,1)  AND ( (SUB(%MemoDeclarations,1,1) <> '!') OR (SUB(%MemoDeclarations,1,1) <> '[') ) )
              #IF(INSTRING(',NAME(',%MemoDeclarations,1,1) )
                #INSERT(%JKRCheckColumn,0,%MemoDeclarations)
                #! added to %NewTxdAsciiRecord in group so we just cycle
                #CYCLE
              #ELSE  
                #INSERT(%JKRCheckColumn,1,%MemoDeclarations)
                #! added to %NewTxdAsciiRecord in group so we just cycle
                #CYCLE
              #ENDIF
            #ENDIF
            #ADD(%NewTxdAsciiRecord,%MemoDeclarations)
          #ENDFOR
          #SET(%FoundMemo, 0)
          #FREE(%MemoDeclarations)
        #ENDIF
        #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
        #SET(%InDeclaredKeys,0)
        #SET(%InRecordStructure,0)
        #SET(%JKRBeginOfTableCheck,1)
        #SET(%JKRFoundLocalFile,0)
        #SET(%JKRNotTPSFile,0)
        #CYCLE
      #ENDIF  
    #ENDIF
    #!
    #! check for group
    #!
    #IF(%InRecordStructure)
        #! we add the group back to the txd and then inc the end statement counter to catch the end of the group
        #IF(INSTRING(' GROUP',%ASCIIFileRecord,1,1) )
          #SET(%JKREndStatementCounter, %JKREndStatementCounter + 1)
          #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
          #CYCLE
        #ENDIF
        #IF(INSTRING(',NAME(',%ASCIIFileRecord,1,1) )
          #INSERT(%JKRCheckColumn,0,%AsciiFileRecord)
          #CYCLE
        #ELSE  
          #INSERT(%JKRCheckColumn,1,%AsciiFileRecord)
          #CYCLE
        #ENDIF
    #ENDIF
    #!
    #! check keys before record
    #!
    #IF(%InDeclaredKeys)
       #ADD(%KeyTempStorage,%ASCIIFileRecord)
       #IF (SUB(%ASCIIFileRecord,1,2) = '!!')
         #IF(%FoundMemo = 1)
           #FOR(%KeyTempStorage)
             #ADD(%MemoDeclarations,%KeyTempStorage)
           #ENDFOR
           #SET(%FoundMemo,0)
           #FREE(%KeyTempStorage)
         #ELSE
           #FOR(%KeyTempStorage)
             #ADD(%KeyDeclarations,%KeyTempStorage)
           #ENDFOR
           #SET(%FoundMemo,0)
           #FREE(%KeyTempStorage)
         #ENDIF
       #ENDIF
       #IF(%ChangeMemo=1)
          #IF(INSTRING(' MEMO(',%ASCIIFileRecord,1,1) )
            #SET(%FoundMemo,1)
          #ENDIF
       #ENDIF
       #CYCLE
    #ENDIF
    #!
    #! THIS LAST ONE GETS ANYTHING NOT FOUND BY CONDITIONS
    #!
    #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
#ENDLOOP
#CLOSE(%JKRSelectedTxdFile),READ
#! Remove Extension
#set(%JKRCounter,0)
#! #LOOP
#!   #SET (%JKRCounter, INSTRING('.',%JKRNewTxdFile,1,%JKRCounter+1))
#!   #IF (%JKRCounter)
#!     #SET (%JKRNewTxdFile,SUB(%JKRNewTxdFile,1,%JKRCounter-1))
#!   #ELSE
#!     #BREAK
#!   #ENDIF
#! #ENDLOOP
#!
#! #SET(%JKRNewTxdFile, %JKRNewTxdFile)
#! #SET(%JKRNewTxdFile,%CurrentPath & %JKRNewTxdFile & '.TXD')
#CREATE(%JKRNewTxdFile)
#FOR(%NewTxdAsciiRecord)
%NewTxdAsciiRecord
#ENDFOR
#CLOSE(%JKRNewTxdFile)
#!
#!----------------------------------------
#GROUP(%JKRChangeDriverType)
#!----------------------------------------
#!
#!  change driver to ODBC and also check for NAME attri change
#!
#IF(%JKRFoundLocalFile = 1 OR %JKRNotTPSFile = 1)
      #ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
      #RETURN
#ENDIF
#!
#IF(%JKRChangeDriverNames=1)
     #SET(%JKRLeftSideOfStringLocation,INSTRING('FILE,DRIVER(',%ASCIIFileRecord,1,1) + 12)
     #SET(%JKRRightSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation)-2 )
     #SET(%JKRLeftSideOfString,SUB(%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
     #SET(%JKRRightSideOfString,SUB(%ASCIIFileRecord,(%JKRRightSideOfStringLocation+1),len(clip(%ASCIIFileRecord)) ) )
     #! just set and check next conditions add to new txa in the end
     #SET(%ASCIIFileRecord,%JKRLeftSideOfString & 'ODBC' & %JKRRightSideOfString)
     #IF(%JKRAddTableNames = 1)
           !#SET(%ASCIIFileRecord,%JKRLeftSideOfString & 'ODBC' & %JKRRightSideOfString)
       #INSERT(%JKRAddTableName)
           #!#ELSE
           #!#ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & 'ODBC' & %JKRRightSideOfString)
     #ENDIF 
     #! #RETURN
     #IF(%JKRAddTableOwner = 1)
        #INSERT(%JKRAddTableOwnerName)
     #ENDIF 
#ELSE      
     #IF(%JKRAddTableNames = 1)
       #INSERT(%JKRAddTableName)
          #!#ELSE
          #! #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & 'ODBC' & %JKRRightSideOfString)
     #ENDIF 
          #! #RETURN
     #IF(%JKRAddTableOwner = 1)
        #INSERT(%JKRAddTableOwnerName)
     #ENDIF 
#ENDIF
#ADD(%NewTxdAsciiRecord,%ASCIIFileRecord)
#!
#!
#!----------------------------------------
#GROUP(%JKRAddTableName)
#!----------------------------------------
   #SET(%JKRRightSideOfStringLocation,INSTRING( ' ',%ASCIIFileRecord,1,1))
   #SET(%FoundName,UPPER(SUB(%ASCIIFileRecord,1,(%JKRRightSideOfStringLocation-1))))
   #IF(INSTRING(',NAME(',%ASCIIFileRecord,1,1) )
      #SET(%JKRLeftSideOfStringLocation,INSTRING(',NAME(',%ASCIIFileRecord,1,1) + 5)
      #SET(%JKRRightSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation) - 1)
      #SET(%JKRLeftSideOfString,SUB(%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
      #SET(%JKRRightSideOfString,SUB(%ASCIIFileRecord,(%JKRRightSideOfStringLocation+1),len(clip(%ASCIIFileRecord)) ) )
      #SET(%ASCIIFileRecord,%JKRLeftSideOfString & '<39>' & %FoundName & '<39>' & %JKRRightSideOfString)
      #! #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & '<39>' & %FoundName & '<39>' & %JKRRightSideOfString)
   #ELSE
     #SET(%JKRLeftSideOfStringLocation,INSTRING('FILE,DRIVER(',%ASCIIFileRecord,1,1) + 13)
     #SET(%JKRLeftSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
     #SET(%JKRRightSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation) )
     #SET(%JKRLeftSideOfString,SUB(%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
     #SET(%JKRRightSideOfString,SUB(%ASCIIFileRecord,(%JKRRightSideOfStringLocation+1),len(clip(%ASCIIFileRecord)) ) )
      #SET(%ASCIIFileRecord,%JKRLeftSideOfString & ',NAME(''' & %FoundName & ''')' & %JKRRightSideOfString)
     #! #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & ',NAME(''' & %FoundName & ''')' & %JKRRightSideOfString)
   #ENDIF
#!
#!
#!----------------------------------------
#GROUP(%JKRAddTableOwnerName)
#!----------------------------------------
#!
   #IF(INSTRING(',OWNER(',%ASCIIFileRecord,1,1) )
      #SET(%JKRLeftSideOfStringLocation,INSTRING(',OWNER(',%ASCIIFileRecord,1,1) + 6)
      #SET(%JKRRightSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation) - 1)
      #SET(%JKRLeftSideOfString,SUB(%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
      #SET(%JKRRightSideOfString,SUB(%ASCIIFileRecord,(%JKRRightSideOfStringLocation+1),len(clip(%ASCIIFileRecord)) ) )
      #SET(%ASCIIFileRecord,%JKRLeftSideOfString & %JKRTableOwnerVariable & %JKRRightSideOfString)
      #! #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & '<39>' & %FoundName & '<39>' & %JKRRightSideOfString)
   #ELSE

     #SET(%JKRLeftSideOfStringLocation,INSTRING('FILE,DRIVER(',%ASCIIFileRecord,1,1) + 13)
     #SET(%JKRLeftSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
     #SET(%JKRRightSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation) )
     #SET(%JKRLeftSideOfString,SUB(%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
     #SET(%JKRRightSideOfString,SUB(%ASCIIFileRecord,(%JKRRightSideOfStringLocation+1),len(clip(%ASCIIFileRecord)) ) )
      #SET(%ASCIIFileRecord,%JKRLeftSideOfString & ',OWNER(' & %JKRTableOwnerVariable & ')' & %JKRRightSideOfString)
     #! #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & ',NAME(''' & %FoundName & ''')' & %JKRRightSideOfString)
   #ENDIF
#!
#!
#!----------------------------------------
#GROUP (%JKRCheckKey,%JKRAddNameAttribute,%AsciiFileRecordCopy)
#!-----------------------------------------------
#!
#! adds name attr to key
#!
#!-----------------------------------------------
#!
#! check existing Name attribute when passed a 0
#! add name attribute when passed a 1
#! FontSize                   BYTE !Font Size
#IF(%JKRAddNameAttribute = 0)
      #SET(%JKRLeftSideOfStringLocation,INSTRING(',NAME(',%AsciiFileRecordCopy,1,1) + 6)
      #SET(%JKRRightSideOfStringLocation,INSTRING(')',%AsciiFileRecordCopy,1,%JKRLeftSideOfStringLocation) - 2)
      #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,%JKRLeftSideOfStringLocation))
      #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,(%JKRRightSideOfStringLocation+1),len(clip(%AsciiFileRecordCopy)) ) )
      #SET(%FoundName,UPPER(SUB(%AsciiFileRecordCopy,(%JKRLeftSideOfStringLocation+1),%JKRRightSideOfStringLocation-(%JKRLeftSideOfStringLocation))))
  #!
  #IF(%SetTablePrefixOnReservedWords = 1 And %AddTablePrefixToAll = 0)
    #SET(%FoundReservedWord, 0)
    #FIND(%SqlWordList, UPPER(%FoundName))                        #! search of SQL and clarion reserved words
    #IF(%SqlWordList)                       
      #SET(%FoundReservedWord, 1)
    #ENDIF                                                  
  #ENDIF
  #!
  #IF(%AddTablePrefixToAll = 1 OR %FoundReseredWord = 1)
    #SET(%FoundName,%JKRFilePrefix & %FoundName)
  #ENDIF
  #!
    #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & UPPER(%FoundName) & %JKRRightSideOfString)
  #!
#ElsIF(%JKRAddNameAttribute = 1)
    #! we add the Name attribute
    #SET(%JKRLeftSideOfStringLocation,INSTRING('KEY(',%AsciiFileRecordCopy,1,1) + 3)
    #SET(%JKRLeftSideOfStringLocation,INSTRING(')',%AsciiFileRecordCopy,1,%JKRLeftSideOfStringLocation) )
    #SET(%JKRRightSideOfStringLocation,INSTRING(')',%AsciiFileRecordCopy,1,%JKRLeftSideOfStringLocation))
    #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,%JKRLeftSideOfStringLocation))
    #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,(%JKRRightSideOfStringLocation+1),len(clip(%AsciiFileRecordCopy)) ) )

    #SET(%JKRFoundSpace,INSTRING(' ',%AsciiFileRecordCopy,1,1))
    #SET(%FoundName,UPPER(SUB(%AsciiFileRecordCopy,1,(%JKRFoundSpace-1))))
    #!
    #IF(%SetTablePrefixOnReservedWords = 1 And %AddTablePrefixToAll = 0)
      #SET(%FoundReseredWord, 0)
      #FIND(%SqlWordList, UPPER(%FoundName))                        #! search of SQL and clarion reserved words
      #IF(%SqlWordList)                       
        #SET(%FoundReseredWord, 1)
      #ENDIF                                                  
    #ENDIF
    #!
    #IF(%AddTablePrefixToAll = 1 OR %FoundReseredWord = 1)
      #SET(%FoundName,%JKRFilePrefix & %FoundName)
      #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & ',NAME(''' & UPPER(%FoundName) & ''') ' & %JKRRightSideOfString)
    #ELSE  
      #ADD(%NewTxdAsciiRecord,%AsciiFileRecordCopy)
    #ENDIF
    #!
#ENDIF
#!
#!
#!-----------------------------------------------
#GROUP (%JKRCheckColumn,%JKRAddNameAttribute,%AsciiFileRecordCopy)
#!-----------------------------------------------
#!
#! adds name attr to column
#!
#!-----------------------------------------------
#!
#IF(%JKRFoundLocalFile = 1 OR %JKRNotTPSFile = 1)
      #ADD(%NewTxdAsciiRecord,%AsciiFileRecordCopy)
      #CYCLE
#ENDIF
#!
#! check existing Name attribute when passed a 0
#! add name attribute when passed a 1
#!
#!  check all columns for type change first 
#!  a variable was set before entering this group to check or not
#!  this group sets %AsciiFileRecordCopy to the new type with everything else the same
#!
#INSERT(%JKRCheckColumnType,%AsciiFileRecordCopy)
#!
#IF(%JKRAddNameAttribute = 0)
  #SET(%JKRLeftSideOfStringLocation,INSTRING(',NAME(',%AsciiFileRecordCopy,1,1) + 6)
  #SET(%JKRRightSideOfStringLocation,INSTRING(')',%AsciiFileRecordCopy,1,%JKRLeftSideOfStringLocation) - 2)
  #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,%JKRLeftSideOfStringLocation))
  #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,(%JKRRightSideOfStringLocation+1),len(clip(%AsciiFileRecordCopy)) ) )
  #SET(%FoundName,UPPER(SUB(%AsciiFileRecordCopy,(%JKRLeftSideOfStringLocation+1),%JKRRightSideOfStringLocation-(%JKRLeftSideOfStringLocation))))
  #!
  #IF(%SetTablePrefixOnReservedWords = 1 And %AddTablePrefixToAll = 0)
    #SET(%FoundReservedWord, 0)
    #FIND(%SqlWordList, UPPER(%FoundName))                        #! search of SQL and clarion reserved words
    #IF(%SqlWordList)                       
      #SET(%FoundReservedWord, 1)
    #ENDIF                                                  
  #ENDIF
  #!
  #IF(%AddTablePrefixToAll = 1 OR %FoundReseredWord = 1)
    #SET(%FoundName,%JKRFilePrefix & %FoundName)
  #ENDIF
#!
    #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & UPPER(%FoundName) & %JKRRightSideOfString)
#!
#ElsIf(%JKRAddNameAttribute = 1)
  #! we add the Name attribute
  #IF (INSTRING('!',%AsciiFileRecordCopy,1,1))
    #SET(%JKRFoundComment,INSTRING('!',%AsciiFileRecordCopy,1,1))
    #SET(%JKRFoundSpace,INSTRING(' ',%AsciiFileRecordCopy,1,1))
    #SET(%FoundName,UPPER(SUB(%AsciiFileRecordCopy,1,(%JKRFoundSpace-1))))
    #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,(%JKRFoundComment-2)))
    #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,%JKRFoundComment,len(clip(%AsciiFileRecordCopy)) ))
  #ELSE
    #SET(%JKRFoundSpace,INSTRING(' ',%AsciiFileRecordCopy,1,1))
    #SET(%FoundName,UPPER(SUB(%AsciiFileRecordCopy,1,(%JKRFoundSpace-1))))
    #SET(%JKRLeftSideOfString, Clip(%AsciiFileRecordCopy))
    #SET(%JKRRightSideOfString,'')
  #ENDIF
  #!
  #IF(%SetTablePrefixOnReservedWords = 1 And %AddTablePrefixToAll = 0)
    #SET(%FoundReseredWord, 0)
    #FIND(%SqlWordList, UPPER(%FoundName))                        #! search of SQL and clarion reserved words
    #IF(%SqlWordList)                       
      #SET(%FoundReseredWord, 1)
    #ENDIF                                                  
  #ENDIF
  #!
  #IF(%AddTablePrefixToAll = 1 OR %FoundReseredWord = 1)
    #SET(%FoundName,%JKRFilePrefix & %FoundName)
    #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & ',NAME(''' & UPPER(%FoundName) & ''') ' & %JKRRightSideOfString)
  #ELSE  
    #ADD(%NewTxdAsciiRecord,%ASCIIFileRecordCopy)
  #ENDIF
  #!
#ENDIF
  #!
  #!
#!----------------------------------------
#GROUP(%JKRCheckColumnType,* %AsciiFileRecordCopy)
#!----------------------------------------
#DECLARE(%StringSizeNo,LONG)
#DECLARE(%LeftSidePos,LONG)
#DECLARE(%RightSidePos,LONG)
#!
#!  * ck for date and time longs - memo -  string size
#!
#IF(%ChangeMemo = 1)
  #IF (INSTRING(' MEMO(',UPPER(%AsciiFileRecordCopy),1,1))
     #!
     #!  * make sure we have a memo
     #!
     #SET(%LeftSidePos,(INSTRING(')',UPPER(%AsciiFileRecordCopy),1,1)))
     #IF(INSTRING('MEMO(',UPPER(%AsciiFileRecordCopy),1,1) < %LeftSidePos  )
        #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,(INSTRING('MEMO(',UPPER(%AsciiFileRecordCopy),1,1)-1)))
        #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,%LeftSidePos+1,len(%AsciiFileRecordCopy) ) )
        #SET(%AsciiFileRecordCopy,%JKRLeftSideOfString & 'STRING(63990)' & %JKRRightSideOfString)
        #RETURN
    #ENDIF
  #ENDIF
#ENDIF
#!
#IF(%JKRChangeStringTypesToBlob = 1)
     #!
     #!  * make sure we have a string
     #!  * if we find a string check the size
     #!
  #IF (INSTRING(' STRING(',UPPER(%AsciiFileRecordCopy),1,1))
    #SET(%LeftSidePos,(INSTRING('(',%AsciiFileRecordCopy,1,1) + 1 ) )
    #IF(INSTRING(' STRING(',UPPER(%AsciiFileRecordCopy),1,1) < %LeftSidePos  )
      #SET(%RightSidePos,INSTRING(')',%AsciiFileRecordCopy,1,%LeftSidePos)  )
      #SET(%StringSizeNo,SUB(%AsciiFileRecordCopy,%LeftSidePos,(%RightSidePos-%LeftSidePos)) )
      #IF(%StringSizeNo > %JKRChangeStringTypesToBlobSize - 1)
        #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,(INSTRING('STRING(',UPPER(%AsciiFileRecordCopy),1,1)-1)))
        #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,(INSTRING(')',UPPER(%AsciiFileRecordCopy),1,%LeftSidePos)+1),len(%AsciiFileRecordCopy)) )
        #SET(%AsciiFileRecordCopy,%JKRLeftSideOfString & 'STRING(63990)' & %JKRRightSideOfString)
        #RETURN
      #ENDIF
    #ENDIF
  #ENDIF
#ENDIF
#!
#IF(%JKRChangeDateNames=1)
  #IF(%JKRFoundDateColumn = 1)
    #IF (INSTRING(' LONG',UPPER(%AsciiFileRecordCopy),1,1))
      #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,(INSTRING('LONG',UPPER(%AsciiFileRecordCopy),1,1)-1)))
      #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,(INSTRING('LONG',UPPER(%AsciiFileRecordCopy),1,1)+4),len(clip(%AsciiFileRecordCopy)) ))
      #SET(%AsciiFileRecordCopy,%JKRLeftSideOfString & 'DATE' & %JKRRightSideOfString)
      #SET(%JKRFoundDateColumn,0)
      #RETURN
    #ENDIF
  #ENDIF
#ENDIF
#IF(%JKRChangeTimeNames=1)
  #IF(%JKRFoundTimeColumn = 1)
    #IF (INSTRING(' LONG',UPPER(%AsciiFileRecordCopy),1,1))
      #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,(INSTRING('LONG',UPPER(%AsciiFileRecordCopy),1,1)-1)))
      #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,(INSTRING('LONG',UPPER(%AsciiFileRecordCopy),1,1)+4),len(clip(%AsciiFileRecordCopy)) ))
      #SET(%AsciiFileRecordCopy,%JKRLeftSideOfString & 'TIME' & %JKRRightSideOfString)
      #SET(%JKRFoundTimeColumn,0)
      #RETURN
    #ENDIF
  #ENDIF
#ENDIF
#!
#!
#! now check for byte or memo types
#!
#!  #IF (INSTRING('BYTE',UPPER(%AsciiFileRecordCopy),1,1))
#!    #SET(%JKRLeftSideOfString,SUB(%AsciiFileRecordCopy,1,(INSTRING('BYTE',UPPER(%AsciiFileRecordCopy),1,1)-1)))
#!    #SET(%JKRRightSideOfString,SUB(%AsciiFileRecordCopy,(INSTRING('BYTE',UPPER(%AsciiFileRecordCopy),1,1)+4),len(clip(%AsciiFileRecordCopy)) ))
#!    #ADD(%NewTxdAsciiRecord,%JKRLeftSideOfString & 'SHORT' & %JKRRightSideOfString)
#!    #RETURN
#!  #ENDIF
#!
#!
#!-----------------------------------------------
#GROUP (%JKRGetFilePrefix)
#!-----------------------------------------------
#!
#! gets the table prefix
#!
#!-----------------------------------------------


      #SET(%JKRLeftSideOfStringLocation,INSTRING(',PRE(',%ASCIIFileRecord,1,1) + 5)
      #SET(%JKRRightSideOfStringLocation,INSTRING(')',%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation) - 1)
      #SET(%JKRLeftSideOfString,SUB(%ASCIIFileRecord,1,%JKRLeftSideOfStringLocation))
      #SET(%JKRRightSideOfString,Left(SUB(%ASCIIFileRecord,(%JKRRightSideOfStringLocation+1),len(clip(%ASCIIFileRecord)) ) ))
      #SET(%JKRFilePrefix,UPPER(SUB(%ASCIIFileRecord,(%JKRLeftSideOfStringLocation),(%JKRRightSideOfStringLocation+1)-(%JKRLeftSideOfStringLocation ))))
     #!  #SET(%JKRFilePrefix,UPPER(SUB(%ASCIIFileRecord,(%JKRLeftSideOfStringLocation+1),%JKRRightSideOfStringLocation-(%JKRLeftSideOfStringLocation ))))
#!
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#UTILITY (FirebirdTemplateStep4, 'Step 4 - Convert - TPS to Firebird conversion program'), WIZARD
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#! This template was adapted from a SQL template by G W Bomford
#SHEET
  #TAB('Page 1 0f 3'),FINISH(0)
      #DISPLAY('This wizard will generate a conversion program for your Topspeed table data to ')
      #DISPLAY('a Firebird database. ')
      #DISPLAY('A sub-directory off the App directory named... ''\convert'' is required.')
      #DISPLAY('This is where the global dll and lib file need to be if you use them.')
      #DISPLAY()
      #DISPLAY('YOU MUST HAVE CREATED YOUR TOPSPEED TABLE DECLARATIONS IN STEP 1.')
      #DISPLAY()
      #DISPLAY('YOU MUST HAVE YOUR TABLES CHANGED TO ODBC AND THE COLUMNS SET PROPERLY.')
      #DISPLAY()
      #DISPLAY('YOU CANNOT HAVE CHANGED THE COLUMN NAMES. ONLY THE EXTERNAL NAME.')
      #DISPLAY()
      #DISPLAY('If you have a table declared as a Topspeed driver type - no conversion file is created.')
      #DISPLAY('If you create a  UserOption LOCALFILEe for a table - no conversion file is created.')
      #DISPLAY('The USEROPTIONS are checked for LOCALFILE and this table is skipped if found.')
      #DISPLAY()
      #DISPLAY('**** The ''<<ApplicationPath>\convert'' sub directory MUST EXIST ***')
      #DISPLAY()
      #DISPLAY('Select ODBC Files to convert or none for all')
      #PROMPT ('',FILE),%JKRFileToConvert,SELECTION('Files - Leave Blank to Select ALL ODBC Files'),INLINE,AT(10)
      #DISPLAY()
  #ENDTAB
  #TAB('Page 2 0f 3'),FINISH(0)
      #DISPLAY()
      #DISPLAY('Two Conversion Methods Are available.')
      #DISPLAY()
      #DISPLAY('1. Use a data dll with each topspeed table having a table variable for setting the path and name.')
      #DISPLAY('  a.) A procedure named SetFileNamePath must exist in the dll. This procedure sets the path')
      #DISPLAY('       passed by address and the file name for each table.')
      #DISPLAY('       Example: ')
      #DISPLAY('       SetFileNamePath( *string psPath)')
      #DISPLAY('       Access:FileName.SetName = clip(psPath) & \Sys1.tps')
      #DISPLAY('  b.) Each convert file calls this dll using the table imported from the include file created in Step 1')
      #DISPLAY('       A program is created to compile and run all convert files. Each convert file first deletes any data')
      #DISPLAY('       in the existing database table(already created with the script files).')
      #DISPLAY()
      #DISPLAY('2. Your topspeed tables use the same table name in the dictionary as the ones on the disk or they')
      #DISPLAY('   use the Name attribute(Full PathName)in the dictionary as the path and name of the')
      #DISPLAY('   file or files on the disk. You can have these mixed in the dictionary but if you set a path')
      #DISPLAY('   this would be for all tables with a variable in the Name attribute')
      #DISPLAY()
  #ENDTAB
  #TAB('Page 3 0f 3'),FINISH(1)
      #DISPLAY()
      #PROMPT ('Use a Data Dll of your Topspeed files you wish to convert',CHECK),%UseGlobalDllForConversion,AT(10),Default(1)
      #ENABLE(%UseGlobalDllForConversion = 1)
      #DISPLAY('We need to select the Lib file to compile the convert modules')
      #DISPLAY('and the data dll needs to be seen when running them.')
      #DISPLAY('Select the Lib file of the Data Dll to use for your conversion')
      #PROMPT('',OPENDIALOG('Select the Lib file','Clarion LIB File|*.LIB')),%TopspeedDataDllName,AT(10)
      #ENDENABLE
      #DISPLAY()
      #ENABLE(%UseGlobalDllForConversion = 0),CLEAR
      #DISPLAY('If you use a variable in the Name attribute or not but you use the table name as the file name')
      #DISPLAY('you may need to set the path to your topspeeed files')
      #DISPLAY()
      #PROMPT ('I need to set the path to my topspeed files',CHECK),%UsePathToTopspeedFiles,AT(10),Default(0)
      #ENDENABLE
      #DISPLAY()
      #ENABLE(%UseGlobalDllForConversion = 1 OR %UsePathToTopspeedFiles = 1),CLEAR
      #DISPLAY('Select the location of the Topspeed files to convert by selecting one file')
      #PROMPT('',OPENDIALOG('Select One Topspeed File To Get The Path Only','Topspeed Data Files|*.TPS')),%TopspeedFilePath,AT(10)
      #ENDENABLE
      #DISPLAY()
      #DISPLAY('Enter the SQL Connect String')
      #DISPLAY('This can be a DSN or a DSN-less string')
      #DISPLAY('A DSN-less example')
      #DISPLAY('Firebird/InterBase(r) driver;UID=SYSDBA;PWD=masterkey;DBNAME=Bigdog:D:\TEST.FDB')
      #PROMPT ('',@S200),%ConnectString,AT(10),REQ
      #DISPLAY()
      #DISPLAY('WHEN CONVERTING EACH RECORD.')
      #DISPLAY('If the index scripts have been loaded into the database and you have invalid data to convert.')
      #DISPLAY('an Add should not allow any bad data in the database.')
      #DISPLAY('Not 100% sure about this one.')
      #DISPLAY()
      #DISPLAY('I want to ADD a new record to the Firebird database table. It will APPEND if left unchecked.')
      #PROMPT ('',CHECK),%AddODBCRecord,DEFAULT(0),AT(10)
      #DISPLAY()
      #DISPLAY('I want to turn on the error message procedure for each record converting.')
      #PROMPT ('',CHECK),%AddErrorMessage,DEFAULT(0),AT(10)
      #DISPLAY()
  #ENDTAB
#ENDSHEET
#!
#DECLARE (%JKRKeyDescription)
#DECLARE (%FileExternalFlag)
#DECLARE (%FileThreadedFlag)
#DECLARE (%SortedFiles), UNIQUE
#DECLARE (%Groups), MULTI
#DECLARE (%ValueConstruct)
#DECLARE (%OutputFile)
#DECLARE (%OldFile)
#DECLARE (%NewFile)
#DECLARE (%UpperNewFile)
#DECLARE (%WhichFile)
#DECLARE (%JKRFieldName)
#DECLARE (%JKRFieldType)
#DECLARE (%JKRKeyField)
#DECLARE (%CurrentPath)
#DECLARE (%JKRCounter)
#DECLARE (%JKRFieldSize)
#DECLARE (%OneRecordFile)
#DECLARE (%JKRFileToConvert2)
#DECLARE (%JKRFileOwner,LONG)
#DECLARE (%JKRFileOwnerIsAVariable,LONG)
#DECLARE (%JKRFileName,LONG)
#DECLARE (%JKRFileNameIsAVariable,LONG)
#!
#! for importing tps structure
#!
#DECLARE(%ASCIIFileRecord)
#DECLARE (%FoundTpsFile)
#DECLARE (%TpsFileDefines)
#!
#! Remove selected file
#SET (%JKRCounter, 0)
#LOOP
  #SET (%JKRCounter, INSTRING('\',%TopspeedFilePath,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%CurrentPath,SUB(%TopspeedFilePath,1,%JKRCounter))
    #CYCLE
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#SET (%TopspeedFilePath,%CurrentPath)
#!
#! Set the current path to '\Convert\'
#SET (%JKRCounter,1)
#LOOP
  #SET (%JKRCounter, INSTRING('\',%DictionaryFile,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%CurrentPath,SUB(%DictionaryFile,1,%JKRCounter) & 'Convert\')
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#!
#MESSAGE('Creating Convertion Program',1)
#!
#!***********************************************************************************************************************************************************************
#! for now just set these here and not on the template screen
#!
#!      #SET(%TopspeedFilePath, 'C:\sc55\data\')
#!      #SET(%TopspeedDataDllName, 'GLO55D')
#!      #SET(%ConnectString, 'Star Consignment')
#!
#!***********************************************************************************************************************************************************************
#! convert generation
#!***********************************************************************************************************************************************************************
#!
#IF (%JKRFileToConvert)
#INSERT(%JKRCreateConversionProgram,0)
#ELSE
  #FOR (%File), WHERE (%FileDriver = 'ODBC' AND %FileType = 'FILE' AND NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 )  )
  #! #FOR (%File), WHERE (%FileDriver = 'TOPSPEED' AND %FileType = 'FILE' AND NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 )  )
  #! #FOR (%File), WHERE (%FileDriver = 'TOPSPEED' And NOT (INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) OR INSTRING('ONERECORDFILE',UPPER(%FileUserOptions),1,1 ))  )
#SET (%JKRFileToConvert2,UPPER(%File))
#INSERT(%JKRCreateConversionProgram,0)
  #ENDFOR
  #! #FOR (%File), WHERE (%FileDriver = 'TOPSPEED' And INSTRING('ONERECORDFILE',UPPER(%FileUserOptions),1,1 ) )
#! #SET (%JKRFileToConvert2,UPPER(%File))
#! #INSERT(%JKRCreateConversionProgram,1)
#!  #ENDFOR
#ENDIF
#!
#!
#INSERT(%JKRCreateMultiConversionProgram)
#!
#!*******************************************************************************************************************************************
#! delete data generation
#!*******************************************************************************************************************************************
#INSERT(%JKRCreateMultiDELDataProgram)
#!
#IF (%JKRFileToConvert)
#INSERT(%JKRCreateDeleteDataProgram)
#ELSE
   #FOR (%File), WHERE (%FileDriver = 'ODBC' AND %FileType = 'FILE' And NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) ) 
   #SET (%JKRFileToConvert2,UPPER(%File))
#INSERT(%JKRCreateDeleteDataProgram)
  #ENDFOR
#ENDIF
#!
#!
#!
#!*******************************************************************************************************************************************
#!
#!-----------------------------------------------
#GROUP(%JKRCreateConversionProgram,%OneRecordFile)
#!-----------------------------------------------
#! Generate a conversion program for the nominated file(s)
#!-----------------------------------------------
#! #MESSAGE('Creating Convertion Program',1)
#! #MESSAGE('For File: ' & %JKRFileToConvert2,2)
#! #FIX (%File,%JKRFileToConvert2)
#SET (%OldFile,'Old' & %JKRFileToConvert2)
#SET (%NewFile,'New' & %JKRFileToConvert2)
#!
#! Create the Project file first
#SET (%OutputFile, %CurrentPath & 'CNV' & %File & '.Prj')
#CREATE (%OutputFile)
#SET (%ValueConstruct,'-- ' & %Outputfile)
%ValueConstruct
%#noedit
%#system win32
%#model clarion dll
%#set RELEASE = on
%#pragma debug(vid=>off)
#SET (%ValueConstruct,'#compile "' & %CurrentPath & 'CNV' & %File & '.clw"')
%ValueConstruct
%#pragma link("C55TPS%%X%%%%L%%.LIB")
%#pragma link("C55ODB%%X%%%%L%%.LIB")
#IF(%UseGlobalDllForConversion = 1)
%#pragma link("%TopspeedDataDllName")
#ENDIF
#SET (%ValueConstruct,'#link "' & %CurrentPath & 'CNV' & %File & '.exe"')
%ValueConstruct

#CLOSE (%OutputFile)

#! Now create the CLW file
#! The file to create is named FileNameC.Clw
#SET (%OutputFile, %CurrentPath & 'CNV' & %File & '.CLW')
#CREATE (%OutputFile)
#!
!JKRConvertSQL.Tpl Conversion code generated %@D17@(TODAY()) at %@T7@(CLOCK())
! This file is named %OutputFile
! Created from definitions in %DictionaryFile
! A 32 bit Project file with the same name has also been created

                  PROGRAM

#IF(%UseGlobalDllForConversion = 1)
#! set this to the name of your global data dll
#! the SetFileNamePath is the procedure in the dll that sets the path
#! of where your data files are located
                  MAP
                    CheckError(string),LONG
                    MODULE('DataDll')
SetFileNamePath        PROCEDURE(*STRING),DLL
                    END
                    
                  END
#ELSE
                  MAP
                    CheckError(string),LONG
                  END
#ENDIF

Count             ULONG
TotalRecords      ULONG
FullPathName      string(255)
Glo:dbOwner string(200)
FileOwnerPassword string(50)

#INSERT(%GetTpsFileDetail)
#! #SET (%WhichFile,'OLD')
#! #INSERT (%FileDetail,%WhichFile)

#SET (%WhichFile,'NEW')
#INSERT (%FileDetail,%WhichFile)

PROGRESS WINDOW('Converting %File'),AT(,,239,67),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
       STRING('Converting Record No:'),AT(61,22)
       STRING(@n9),AT(143,22),USE(Count)
       STRING('Total Records:'),AT(61,36),USE(?String3)
       STRING(@n9),AT(143,36),USE(TotalRecords)
     END

  CODE
   #! path of your data files
   #IF(%UseGlobalDllForConversion = 1)
  FullPathName = '%TopspeedFilePath'
  SetFileNamePath(FullPathName)
   #ELSE  
     #IF(%JKRFileNameIsAVariable=0)
     #! in the the topspeed table declaration FullPathName = %FileName
     #ELSE
  FullPathName = '%TopspeedFilePath%File.tps'
     #ENDIF
   #ENDIF
   
  Glo:dbOwner = '%ConnectString'
  
  #IF(%JKRFileOwnerIsAVariable=1)
  FileOwnerPassword = 
  #Endif
   
  OPEN(%File)
  #! If Errorcode() = 2 then return. ! file not found
  IF CheckError('%File') THEN RETURN.
  TotalRecords = RECORDS(%File)
  If TotalRecords = 0 Then Return.

  OPEN(Progress)

  OPEN(%NewFile)
  IF CheckError('%NewFile') THEN RETURN.

  0{PROP:TEXT} = 'Deleting Records In ODBC Table %File'
  Count = 0
  SET(%NewFile)
  LOOP
    NEXT(%NewFile)
    IF ErrorCode() = 33 THEN BREAK.
    DELETE(%NewFile)
    IF CheckError('%NewFile') THEN CYCLE.
    Count += 1
    DISPLAY(?Count)
  END

  STREAM(%File)
  !STREAM(%NewFile)

  0{PROP:TEXT} = 'Converting Records For ODBC Table %File'
  Count = 0
  SET(%File)
  LOOP
    NEXT(%File)
    IF ErrorCode() = 33 THEN BREAK.
    DO AssignRecord
    #IF(%AddODBCRecord = 1)
    ADD(%NewFile)
    #ELSE
    APPEND(%NewFile)
    #ENDIF
    #IF(%OneRecordFile=0)
      #IF(%AddErrorMessage = 0)
    IF ErrorCode() THEN CYCLE.
    ! IF CheckError('%NewFile') THEN CYCLE.
      #ELSE
    IF CheckError('%NewFile') THEN CYCLE.
    ! IF ErrorCode() THEN CYCLE.
      #ENDIF
    Count += 1
    DISPLAY(?Count)
    #ELSE
    BREAK
    #ENDIF
  END

  FLUSH(%File)
  !FLUSH(%NewFile)
  BUILD(%NewFile)

  CLOSE(%File)
  CLOSE(%NewFile)
  #! MESSAGE(Count & ' records converted','Finished')

AssignRecord      ROUTINE

#FOR (%FIELD)
    #!
    #CASE(%FieldType)
    #OF ('PICTURE') #OROF ('LIKE')  #OROF ('TYPE')
    ! %FIELD FieldType - PICTURE - TYPE - LIKE  -  ARE NOT ALLOWED
    #OF ('GROUP') #OROF ('END')
      #CYCLE
    #ENDCASE
    #!
    #IF (%FieldName)
    #SET(%JKRFieldName, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
    NEW:%[20]JKRFieldName = %Field
    #ELSE
    #SET(%JKRFieldName, UPPER(%FieldID))
    NEW:%[20]JKRFieldName = %Field
    #! NEW:%[20]FieldID = %Field
    #ENDIF
    #!
    #CASE(%FieldValidation)   
     #OF ( 'BOOLEAN')
       #IF(%FieldTrueValue AND %FieldFalseValue)
         #CASE (%FieldType)
            #OF ('CSTRING') #OROF ('PSTRING') #OROF ('STRING')
      ! IF %Field = ''
        ! NEW:%JKRFieldName = '%FieldTrueValue'
        ! NEW:%JKRFieldName = '%FieldFalseValue'
      ! END
            #ELSE
      ! IF %Field = 0
        ! NEW:%JKRFieldName = %FieldTrueValue
        ! NEW:%JKRFieldName = %FieldFalseValue
      ! END
         #ENDCASE
       #ENDIF
     #OF ( 'INLIST')
       #IF (ITEMS(%FieldValues))
         #FOR(%FieldValues)
      ! IF %Field = ''
      !   NEW:%JKRFieldName = %FieldValues
      ! END
         #ENDFOR
       #ENDIF
     #OF ( 'INRANGE')
       #IF (%FieldRangeLow AND %FieldRangeHigh)
      ! IF %Field = 0
      !   NEW:%JKRFieldName = %FieldRangeLow
      !   NEW:%JKRFieldName = %FieldRangeHigh
      ! END
       #ELSIF (%FieldRangeLow AND NOT %FieldRangeHigh)
      ! IF %Field = 0
      !   NEW:%JKRFieldName = %FieldRangeLow
      ! END
       #ELSIF (NOT %FieldRangeLow AND %FieldRangeHigh)
      ! IF %Field = 0
      !   NEW:%JKRFieldName = %FieldRangeHigh
      ! END
       #ENDIF
    #ENDCASE
#ENDFOR

CheckError        FUNCTION(psFileName)
  CODE
  IF ERRORCODE() THEN
    IF ERRORCODE() = 90 THEN
      STOP('Error On File ' & psFileName & ': ' & FILEERROR())
    ELSE
      STOP('Error On File ' & psFileName & ': ' & ERROR())
    END
  END
  RETURN 0

#CLOSE (%OutputFile)

#!-----------------------------------------------
#GROUP (%GetTpsFileDetail)
#!-----------------------------------------------
#! read in tps file structure
#!-----------------------------------------------
#!
#! #IF(%FileOwner)
#!FileOwner=1
#!  #IF(Sub(%FileOwner,1,1) = '''')
#!FileOwnerIsAVariable=0
#!  #else  
#!FileOwnerIsAVariable=1
#!  #Endif
#!#ELSE  
#!FileOwner=0
#!#Endif
#!#IF(%FileName)
#!FileName=1
#!  #IF(Sub(%FileName,1,1) = '''')
#!FileNameIsAVariable=0
#!  #else  
#!FileNameIsAVariable=1
#!  #Endif
#!#ELSE
#!FileName=0
#!#Endif
#!
#SET(%TpsFileDefines,%CurrentPath & 'TpsToOdbc.Inc')
#OPEN(%TpsFileDefines),READ
#LOOP
    #READ(%ASCIIFileRecord)
    #IF(%ASCIIFileRecord = %EOF)
        #BREAK
    #ENDIF
    #!
    #If(SUB(%ASCIIFileRecord,1,2) = '[[')
#!       FOUND [[  -  %ASCIIFileRecord
      #IF(UPPER(%ASCIIFileRecord) = '[[' & UPPER(%File) & ']]')
        #Set(%FoundTpsFile,1)
        #READ(%ASCIIFileRecord)
        #IF(SUB(%ASCIIFileRecord,1,11) = 'FileOwner=1')
          #SET(%JKRFileOwner,1)
          #READ(%ASCIIFileRecord)
          #IF(SUB(%ASCIIFileRecord,1,22) = 'FileOwnerIsAVariable=1')
            #SET(%JKRFileOwnerIsAVariable,1)
            #READ(%ASCIIFileRecord)
          #ELSE
            #READ(%ASCIIFileRecord)
            #SET(%JKRFileOwnerIsAVariable,0)
          #ENDIF
        #ELSIF(SUB(%ASCIIFileRecord,1,11) = 'FileOwner=0')
          #SET(%JKRFileOwner,0)
          #READ(%ASCIIFileRecord)
        #ENDIF
        #IF(SUB(%ASCIIFileRecord,1,11) = 'FileName=1')
          #SET(%JKRFileName,1)
          #READ(%ASCIIFileRecord)
          #IF(SUB(%ASCIIFileRecord,1,21) = 'FileNameIsAVariable=1')
            #SET(%JKRFileNameIsAVariable,1)
            #READ(%ASCIIFileRecord)
          #ELSE
            #READ(%ASCIIFileRecord)
            #SET(%JKRFileNameIsAVariable,0)
          #ENDIF
        #ELSIF(SUB(%ASCIIFileRecord,1,11) = 'FileName=0')
          #SET(%JKRFileName,0)
          #READ(%ASCIIFileRecord)
        #ENDIF
      #ENDIF
    #ENDIF
    #!
    #IF(%FoundTpsFile=1 And SUB(%ASCIIFileRecord,1,2) <> '[[')
      #IF( SUB(%ASCIIFileRecord,1,LEN(%FILE)) = %FILE)
        #IF(%UseGlobalDllForConversion = 1 )
 
%[25]File FILE,DRIVER('TOPSPEED'),PRE(%FilePrefix),EXTERNAL(''),DLL(dll_mode)
          #cycle
        #ELSE
#! extract owner and place in this assignment
#! %[25]File FILE,DRIVER('TOPSPEED'),PRE(%FilePrefix),NAME(FilePath)
#! the record was written correctly in step 1
%ASCIIFileRecord    
          #cycle
        #ENDIF
      #ENDIF
%ASCIIFileRecord    
    #EndIf
    #IF(SUB(%ASCIIFileRecord,1,2) = '[[' AND %FoundTpsFile=1)
      #break
    #EndIf
#ENDLOOP
#Set(%FoundTpsFile,0)
#CLOSE(%TpsFileDefines),READ
#!
#!-----------------------------------------------
#GROUP (%FileDetail,%OldOrNew)
#!-----------------------------------------------
#! Convert to Firebird
#!-----------------------------------------------
#!

!%File  %FileDescription

  #SET (%ValueConstruct, SUB(%FileStruct, INSTRING(' ', %FileStruct, 1, 1), LEN(%FileStruct)))
  #SET (%FileExternalFlag, %False)
  #CASE (%OverrideExternal)
  #OF ('External')
    #SET (%FileExternalFlag, %True)
    #IF (%OverrideExternalSource)
      #SET (%ValueConstruct, %ValueConstruct & ',EXTERNAL(''' & %OverrideExternalSource & '''),DLL(dll_mode)')
    #ELSE
      #SET (%ValueConstruct, %ValueConstruct & ',EXTERNAL(''''),DLL(dll_mode)')
    #ENDIF
  #OF ('Use Default')
    #IF (%DefaultExternal = 'All External')
      #IF (%DefaultExternalAPP)
        #SET (%FileExternalFlag, %True)
      #ENDIF
      #IF (%DefaultExternalSource)
        #SET (%ValueConstruct, %ValueConstruct & ',EXTERNAL(''' & %DefaultExternalSource & '''),DLL(dll_mode)')
      #ELSE
        #SET (%ValueConstruct, %ValueConstruct & ',EXTERNAL(''''),DLL(dll_mode)')
      #ENDIF
    #ENDIF
  #OF ('Not External')
  #ELSE
    #IF (%DefaultExternal = 'All External')
      #IF (%DefaultExternalAPP)
        #SET (%FileExternalFlag, %True)
      #ENDIF
      #IF (%DefaultExternalSource)
        #SET (%ValueConstruct, %ValueConstruct & ',EXTERNAL(''' & %DefaultExternalSource & '''),DLL(dll_mode)')
      #ELSE
        #SET (%ValueConstruct, %ValueConstruct & ',EXTERNAL(''''),DLL(dll_mode)')
      #ENDIF
    #ENDIF
  #ENDCASE
  #IF (EXTRACT(%ValueConstruct, 'EXTERNAL'))
    #IF (EXTRACT(%ValueConstruct, 'NAME'))
      #SET (%ValueConstruct, REPLACE(%ValueConstruct, 'NAME', ''))
    #ENDIF
  #ENDIF
  #!
  #!
  #IF (%OldOrNew = 'OLD')
   #! done in GROUP (%GetTpsFileDetail)
   #!  %File %ValueConstruct
  #ELSIF (%OldOrNew = 'NEW')
    #SET(%UpperNewFile,UPPER(%File))
New%[20]File  FILE,DRIVER('ODBC'),NAME('%UpperNewFile'),OWNER(Glo:dbOwner),PRE(NEW),BINDABLE,THREAD
  #ENDIF
  #!
  #!
#IF (%OldOrNew = 'OLD')
  #FOR (%Key)
%KeyStruct
  #ENDFOR
  #FOR (%Field), WHERE(%FieldType = 'MEMO')
%FieldStruct
  #ENDFOR
  #FOR (%Field), WHERE(%FieldType = 'BLOB')
%FieldStruct  
  #ENDFOR
%FileStructRec,PRE()
  #FOR (%Field), WHERE(%FieldType <> 'MEMO' AND %FieldType <> 'BLOB')
%FieldStruct
  #ENDFOR
#ELSIF (%OldOrNew = 'NEW')
  #FOR (%Key),WHERE(%KeyPrimary = 1)
    #SET (%JKRCounter,0)
        #FOR (%KeyField)
          #SET (%JKRCounter,%JKRCounter + 1)
          #FIX (%Field, %KeyField)
          #IF (%FieldName)
             #IF(%JKRCounter > 1)
               #SET (%JKRKeyField,CLIP(%JKRKeyField) & ',' &  UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
             #ELSE
               #SET (%JKRKeyField, 'NEW:' & UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
             #ENDIF
          #ELSE
             #IF(%JKRCounter > 1)
               #SET (%JKRKeyField,CLIP(%JKRKeyField) & ',' &  'NEW:' & %FieldID)
             #ELSE
             #SET (%JKRKeyField, 'NEW:' & %FieldID)
             #ENDIF
          #ENDIF
        #ENDFOR #! %KEYFIELD
  #ENDFOR
PRIMARYKEY               KEY(%JKRKeyField),PRIMARY
%FileStructRec,PRE()
 #! these are the odbc defines
 #!
  #FOR (%Field)
    #! Convert Date fields to DATE and TIME to TIME
    #IF (INSTRING('D',UPPER(%FieldPicture),1,1))
      #! Convert longs fields to DATE and longs to Time if checked - else make interger
      #!#IF(%JKRChangeDateNames = 1)
      #!  #SET (%JKRFieldType,'DATE')
      #!#ELSE
     #!   #SET (%JKRFieldType,'LONG')
     #! #ENDIF
    #!#ELSIF (INSTRING('T',UPPER(%FieldPicture),1,1))
    #!  #IF(%JKRChangeTimeNames = 1)
    #!    #SET (%JKRFieldType,'TIME')
    #!  #ELSE
    #!    #SET (%JKRFieldType,'LONG')
    #!  #ENDIF
    #ENDIF
    #CASE(%FieldType)
    #OF ('PICTURE') #OROF ('LIKE')  #OROF ('TYPE')
    #SET (%JKRFieldType,'PICTURE - TYPE - LIKE  -  ARE NOT ALLOWED')
    #OF ('GROUP') #OROF ('END')
      #CYCLE
    #ENDCASE
    #IF(%FieldType = 'MEMO')
      #SET (%JKRFieldType,'STRING(63000)')
    #ELSIF(%FieldType = 'LONG')
      #SET (%JKRFieldType,'LONG')
    #ELSIF(%FieldType = 'SHORT')
      #SET (%JKRFieldType,'SHORT')
    #ELSIF(%FieldType = 'BYTE')
      #! #SET (%JKRFieldType,'SHORT')
       #SET (%JKRFieldType,'BYTE')
    #ELSIF(%FieldType = 'STRING' OR %FieldType = 'CSTRING')
      #SET (%JKRFieldType,SUB(%FieldStatement,1,INSTRING(')',%FieldStatement,1,1) ) ) #! TAKE OUT NAME ATTRIBUTE
    #ELSIF(%FieldType = 'PSTRING')
      #SET (%JKRFieldType,SUB(%FieldStatement,1,INSTRING(')',%FieldStatement,1,1) ) ) #! TAKE OUT NAME ATTRIBUTE
    #ELSIF(%FieldType = 'REAL') 
      #SET(%JKRFieldType, 'DECIMAL(' & %FieldMemoSize & ',' & %FieldPlaces & ')')
    #ELSIF(%FieldType = 'PDECIMAL')
      #SET(%JKRFieldType, 'DECIMAL(' & %FieldMemoSize & ',' & %FieldPlaces & ')')
    #ELSIF(%FieldType = 'SREAL')
      #SET(%JKRFieldType, 'FLOAT')
    #ELSIF(%FieldType = 'BFLOAT4')
      #SET(%JKRFieldType, 'FLOAT')
    #ELSIF(%FieldType = 'REAL')
      #SET(%JKRFieldType, 'DOUBLE PRECISION')
    #ELSIF(%FieldType = 'BFLOAT8')
      #SET(%JKRFieldType, 'DOUBLE PRECISION')
    #ELSE
      #SET (%JKRFieldType, %FieldStatement)
    #ENDIF
#!
#! we should have the dictionary set for ODBC at this time so just write out the column name and type from the dictionary
#!
#! jkr comment out 03-31-2004
   #! #SET (%JKRFieldType, %FieldStatement)
#!
#! IF NAME SET IN COLUMN    
#! 
#!
   #IF (%FieldName)
    #SET(%JKRFieldName, UPPER(SUB(%FieldName,2,LEN(%FieldName)-2)))
%[28]JKRFieldName  %JKRFieldType
   #ELSE
    #SET(%JKRFieldName, UPPER(%FieldID))
%[28]JKRFieldName  %JKRFieldType
   #ENDIF
  #ENDFOR
#ENDIF
%FileStructRecEnd
%FileStructEnd
#!
#!-----------------------------------------------
#GROUP(%JKRCreateMultiConversionProgram)
#!-----------------------------------------------
#! Generate a conversion program for the nominated file(s)
#!-----------------------------------------------
#! Create a source of run commands for all created Projects
#SET (%OutputFile, %CurrentPath & 'CompileAndRunAllConverts.CLW')
#CREATE (%OutputFile)

                  PROGRAM
                  INCLUDE('EQUATES.CLW')                    !Include standard equates
                  MAP
                  END


  CODE

  ! these are the run statements to convert each file. the projects for each file
  ! have been placed into this programs project so they will all compile together
  
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************
  ! because you should have already imported your INDEX scripts into the database we use ADD and not append
  ! this is so no bad data can be converted into your SQL database
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************

   #FOR (%File), WHERE (%FileDriver = 'ODBC' AND %FileType = 'FILE' And NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) )
               ! run CNV%File.exe
              #SET(%ValueConstruct,'RUN(' & '<39>' & %CurrentPath & 'CNV' & %File & '.exe' & '<39>' & ',1)' )
              %ValueConstruct

   #ENDFOR
  
              Return
#CLOSE (%OutputFile)


#! #MESSAGE('Creating Conversion Program',1)
#! #MESSAGE('For File: ' & %JKRFileToConvert2,2)
#!
#! Create the Project file first
#SET (%OutputFile, %CurrentPath & 'CompileAndRunAllConverts' & '.Prj')
#CREATE (%OutputFile)
#SET (%ValueConstruct,'-- ' & %Outputfile)
%ValueConstruct
%#noedit
%#system win32
%#model clarion dll
%#set RELEASE = on
%#pragma debug(vid=>off)
#!
#FOR (%File), WHERE (%FileDriver = 'ODBC' AND %FileType = 'FILE' And NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) )
#! #include "CNVColors.Prj"
#SET(%ValueConstruct,'#include "' & %CurrentPath & 'CNV' & %File & '.Prj"')
%ValueConstruct
#ENDFOR
#!
#SET (%ValueConstruct,'#compile "' & %CurrentPath & 'CompileAndRunAllConverts.clw"')
%ValueConstruct
#SET (%ValueConstruct,'#link "' & %CurrentPath & 'CompileAndRunAllConverts.exe"')
%ValueConstruct

#CLOSE (%OutputFile)
#!
#!-----------------------------------------------
#GROUP(%JKRCreateDeleteDataProgram)
#!-----------------------------------------------
#! Generate a delete data program for the nominated file(s)
#!-----------------------------------------------
#! #MESSAGE('Creating Convertion Program',1)
#! #MESSAGE('For File: ' & %JKRFileToConvert2,2)
#SET (%OldFile,'Old' & %JKRFileToConvert2)
#SET (%NewFile,'New' & %JKRFileToConvert2)
#!
#! Create the Project file first
#SET (%OutputFile, %CurrentPath & 'DEL' & %File & '.Prj')
#CREATE (%OutputFile)
#SET (%ValueConstruct,'-- ' & %Outputfile)
%ValueConstruct
%#noedit
%#system win32
%#model clarion dll
%#set RELEASE = on
%#pragma debug(vid=>off)
#SET (%ValueConstruct,'#compile "' & %CurrentPath & 'DEL' & %File & '.clw"')
%ValueConstruct
%#pragma link("C55TPS%%X%%%%L%%.LIB")
%#pragma link("C55ODB%%X%%%%L%%.LIB")
#SET (%ValueConstruct,'#link "' & %CurrentPath & 'DEL' & %File & '.exe"')
%ValueConstruct

#CLOSE (%OutputFile)

#! Now create the CLW file
#! The file to create is named FileNameC.Clw
#SET (%OutputFile, %CurrentPath & 'DEL' & %File & '.CLW')
#CREATE (%OutputFile)
#!
!JKRConvertSQL.Tpl Conversion code generated %@D17@(TODAY()) at %@T7@(CLOCK())
! This file is named %OutputFile
! Created from definitions in %DictionaryFile
! A 32 bit Project file with the same name has also been created

                  PROGRAM

                  MAP
                    CheckError(string),LONG
                  END

Count             ULONG
TotalRecords      ULONG
FilePath          string(255)

#! #SET (%WhichFile,'OLD')
#! #INSERT (%FileDetail,%WhichFile)

#SET (%WhichFile,'NEW')
#INSERT (%FileDetail,%WhichFile)

PROGRESS WINDOW('Converting %File'),AT(,,239,67),FONT('MS Sans Serif',8,,),CENTER,SYSTEM,GRAY,DOUBLE
       STRING('Converting Record No:'),AT(61,22)
       STRING(@n9),AT(143,22),USE(Count)
       STRING('Total Records:'),AT(61,36),USE(?String3)
       STRING(@n9),AT(143,36),USE(TotalRecords)
     END

  CODE

  OPEN(Progress)

  OPEN(%NewFile)
  IF CheckError('%NewFile') THEN RETURN.

  0{PROP:TEXT} = 'Deleting Records In ODBC Table %File'
  Count = 0
  SET(%NewFile)
  LOOP
    NEXT(%NewFile)
    IF ErrorCode() = 33 THEN BREAK.
    DELETE(%NewFile)
    IF CheckError('%NewFile') THEN CYCLE.
    Count += 1
    DISPLAY(?Count)
  END

  CLOSE(%NewFile)

CheckError        FUNCTION(psFileName)
  CODE
  IF ERRORCODE() THEN
    IF ERRORCODE() = 90 THEN
      STOP('Error On File ' & psFileName & ': ' & FILEERROR())
    ELSE
      STOP('Error On File ' & psFileName & ': ' & ERROR())
    END
  END
  RETURN 0

#CLOSE (%OutputFile)

#!-----------------------------------------------
#GROUP(%JKRCreateMultiDELDataProgram)
#!-----------------------------------------------
#! Generate a conversion program for the nominated file(s)
#!-----------------------------------------------
#! Create a source of run commands for all created Projects
#SET (%OutputFile, %CurrentPath & 'DELMULTI.CLW')
#CREATE (%OutputFile)

                  PROGRAM
                  INCLUDE('EQUATES.CLW')                    !Include standard equates
                  MAP
                  END


  CODE

  ! these are the run statements to convert each file. the projects for each file
  ! have been placed into this programs project so they will all compile together
  
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************
  ! because you should have already imported your INDEX scripts into the database we use ADD and not append
  ! this is so no bad data can be converted into your SQL database
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************
  ! **********************                                    IMPORTANT                             ****************************

   #FOR (%File), WHERE (%FileDriver = 'ODBC' AND %FileType = 'FILE' And NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) )
               ! run CNV%File.exe
              #SET(%ValueConstruct,'RUN(' & '<39>' & %CurrentPath & 'DEL' & %File & '.exe' & '<39>' & ',1)' )
              %ValueConstruct

   #ENDFOR
  
              Return
#CLOSE (%OutputFile)


#! #MESSAGE('Creating Convertion Program',1)
#! #MESSAGE('For File: ' & %JKRFileToConvert2,2)
#!
#! Create the Project file first
#SET (%OutputFile, %CurrentPath & 'DELMULTI' & '.Prj')
#CREATE (%OutputFile)
#SET (%ValueConstruct,'-- ' & %Outputfile)
%ValueConstruct
%#noedit
%#system win32
%#model clarion dll
%#set RELEASE = on
%#pragma debug(vid=>off)
#!
#FOR (%File), WHERE (%FileDriver = 'ODBC' AND %FileType = 'FILE' And NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) )
#SET(%ValueConstruct,'#include "' & %CurrentPath & 'DEL' & %File & '.Prj"')
%ValueConstruct
#ENDFOR
#!
#SET (%ValueConstruct,'#compile "' & %CurrentPath & 'DELMULTI.clw"')
%ValueConstruct
#SET (%ValueConstruct,'#link "' & %CurrentPath & 'DELMULTI.exe"')
%ValueConstruct

#CLOSE (%OutputFile)
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#UTILITY (FirebirdTemplateReport1, 'Report of Byte,Ushort,Ulong,Type,Sreal,Picture,Pdecimal,Like,Group'), WIZARD
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#! This template was adapted from a SQL template by G W Bomford
#!-----------------------------------------------
#SHEET
  #TAB('Page 1 0f 1'),FINISH(1)
    #BOXED('Documenting the dictionary''s Topspeed files')
      #DISPLAY()
      #DISPLAY('Leave this list empty to select all Topspeed files in the current dictionary')
      #DISPLAY()
      #PROMPT ('Select Topspeed Files',FILE),%JKRSelectedFiles,SELECTION('Files - Leave Blank to Select ALL TPS Files'),INLINE,AT(10,100)
      #DISPLAY()
      #DISPLAY('This wizard generates a printout of all the Topspeed files,')
      #DISPLAY('or only the selected files, in the current dictionary.')
      #DISPLAY()
      #PROMPT('Do you want a printout of Fields for each file?',OPTION),%JKRShowFieldDetails
      #PROMPT('Yes, show all information for the Files',RADIO),AT(100,,215)
      #PROMPT('No, just show the File Header and Relationships.',RADIO),AT(100,,224)
      #DISPLAY()
      #PROMPT ('Name of Text File to Create:',@S40),%OutPutFile,DEFAULT('Files.Txt'),AT(100)
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
#ENDSHEET
#!
#DECLARE (%JKRCounter)
#DECLARE (%CurrentPath)
#DECLARE (%JKRKeyDescription)
#DECLARE (%FileExternalFlag)
#DECLARE (%FileThreadedFlag)
#DECLARE (%SortedFiles), UNIQUE
#DECLARE (%Groups), MULTI
#DECLARE (%ValueConstruct)
#DECLARE (%PageBreak)
#DECLARE (%RelationErrorMessage)
#!
#DECLARE (%JKROutputFileLine), MULTI
#!
#SET (%PageBreak, CHR(12))
#! Set the current path to '\Application Path\'
#LOOP
  #SET (%JKRCounter, INSTRING('\',%DictionaryFile,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%CurrentPath,SUB(%DictionaryFile,1,%JKRCounter))
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#!
#! Remove Extension
#LOOP
  #SET (%JKRCounter, INSTRING('.',%OutputFile,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%OutputFile,SUB(%OutputFile,1,%JKRCounter-1))
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#!
#IF (ITEMS(%JKRSelectedFiles))
  #FOR (%JKRSelectedFiles)
    #FIX (%FILE,%JKRSelectedFiles)
    #ADD (%SortedFiles, %File)
  #ENDFOR
#ELSE
  #FOR (%File), WHERE ((%FileDriver = 'TOPSPEED' OR %FileDriver = 'ODBC') AND %FileType = 'FILE' And NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) )
    #ADD (%SortedFiles, %File)
  #ENDFOR
#ENDIF
#!
#!
#FOR (%SortedFiles)
  #FIX (%File, %SortedFiles)
  #SET(%JKRCounter,1)
  #INSERT(%JKRFieldDetails)
#ENDFOR
#!
#!
#SET (%OutputFile, %CurrentPath & %OutputFile & '.TXT')
#!
#CREATE (%OutputFile)
JKRSQL.Tpl Dictionary Report Generated %@D17@(TODAY()) at %@T7@(CLOCK())
This file is named: %OutputFile
Topspeed file details for: %[43]DictionaryFile


#FOR(%JKROutputFileLine)
%JKROutputFileLine
#ENDFOR
#CLOSE (%OutputFile)
#!
#!
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#UTILITY (FirebirdTemplateReport2, 'Report of Initial Values And Validity Checks For Dictionary Columns'), WIZARD
#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#!-----------------------------------------------
#SHEET
  #TAB('Page 1 0f 1'),FINISH(1)
    #BOXED('Initial Values and Valitity Checks''s Topspeed/ODBC Initial Values')
      #DISPLAY()
      #DISPLAY('Leave this list empty to select all Topspeed or ODBC tables.')
      #DISPLAY()
      #PROMPT ('Select Topspeed/ODBC Tables',FILE),%JKRSelectedFiles,SELECTION('Tables - Leave Blank to Select ALL Topspeed/ODBC Tables'),INLINE,AT(10,100)
      #DISPLAY()
      #DISPLAY('This wizard generates a printout of all the Topspeed/ODBC TABLES,')
      #DISPLAY('or only the selected files, in the current dictionary.')
      #DISPLAY()
    #ENDBOXED
  #ENDTAB
#ENDSHEET
#!
#DECLARE (%JKRCounter)
#DECLARE(%JKRCounterLoc,LONG)
#DECLARE (%JKRFieldName)
#DECLARE (%JKRFieldType)
#DECLARE (%CurrentPath)
#DECLARE (%JKRKeyDescription)
#DECLARE (%FileExternalFlag)
#DECLARE (%FileThreadedFlag)
#DECLARE (%SortedFiles), UNIQUE
#DECLARE (%Groups), MULTI
#DECLARE (%ValueConstruct)
#DECLARE (%PageBreak)
#DECLARE (%RelationErrorMessage)
#DECLARE (%OutPutFile)
#!
#DECLARE (%JKROutputFileLine), MULTI
#!
#SET (%PageBreak, CHR(12))
#! Set the current path to '\Application Path\'
#LOOP
  #SET (%JKRCounter, INSTRING('\',%DictionaryFile,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%CurrentPath,SUB(%DictionaryFile,1,%JKRCounter))
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#!
#! Remove Extension
#LOOP
  #SET (%JKRCounter, INSTRING('.',%OutputFile,1,%JKRCounter+1))
  #IF (%JKRCounter)
    #SET (%OutputFile,SUB(%OutputFile,1,%JKRCounter-1))
  #ELSE
    #BREAK
  #ENDIF
#ENDLOOP
#!
#IF (ITEMS(%JKRSelectedFiles))
  #FOR (%JKRSelectedFiles)
    #FIX (%FILE,%JKRSelectedFiles)
    #ADD (%SortedFiles, %File)
  #ENDFOR
#ELSE
  #FOR (%File), WHERE ((%FileDriver = 'TOPSPEED' OR %FileDriver = 'ODBC') AND %FileType = 'FILE' And NOT INSTRING('LOCALFILE',UPPER(%FileUserOptions),1,1 ) )
    #ADD (%SortedFiles, %File)
  #ENDFOR
#ENDIF
#!
#!
#FOR (%SortedFiles)
  #FIX (%File, %SortedFiles)
  #SET(%JKRCounter,1)
  #INSERT(%JKRFieldItialValues)
#ENDFOR
#FOR (%SortedFiles)
  #FIX (%File, %SortedFiles)
  #SET(%JKRCounter,1)
  #INSERT(%JKRFieldValidityChecks)
#ENDFOR
#!
#!
#SET (%OutputFile, %CurrentPath & 'InitialValues' & '.TXT')
#!
#CREATE (%OutputFile)
Dictionary Report Generated %@D17@(TODAY()) at %@T7@(CLOCK())
This file is named: %OutputFile
Topspeed file details for: %[43]DictionaryFile

Initial Values and Validity checks from the dictionary


#FOR(%JKROutputFileLine)
%JKROutputFileLine
#ENDFOR
#CLOSE (%OutputFile)
#!
#!
#!-----------------------------------------------
#GROUP (%JKRFieldItialValues)
#!-----------------------------------------------
#! Print Dictionary Group
#!-----------------------------------------------
#!
  #FOR (%Field)
     #IF (%JKRCounter = 1)
       #ADD(%JKROutputFileLine,'')
       #ADD(%JKROutputFileLine,'')
       #ADD(%JKROutputFileLine, %FILE & '  FILE TYPE = ' & %FILEDRIVER)
       #ADD(%JKROutputFileLine, 'Inital Values')
       #SET(%JKRCounter,0)
     #ENDIF
     #IF(%FieldInitial)
       #ADD(%JKROutputFileLine, '    '  & %FIELDID & '    ' & %FIELDTYPE & '    ' & %FieldInitial)
     #ENDIF
  #ENDFOR
#!
#!
#!-----------------------------------------------
#GROUP (%JKRFieldValidityChecks)
#!-----------------------------------------------
#! Print Dictionary Group
#!-----------------------------------------------
#!
  #ADD(%JKROutputFileLine,'')
  #ADD(%JKROutputFileLine,'')
  #FOR (%Field),WHERE(%FieldValidation = 'NONZERO' OR %FieldValidation = 'BOOLEAN' OR %FieldValidation = 'INLIST' OR %FieldValidation = 'INRANGE')
     #IF (%JKRCounter = 1)
       #ADD(%JKROutputFileLine, %FILE & '  FILE TYPE = ' & %FILEDRIVER)
       #ADD(%JKROutputFileLine, 'Validity Checks In Script Form')
       #SET(%JKRCounter,0)
     #ENDIF
     #!
     #SET (%JKRFieldName, %FieldID)
     #SET (%JKRFieldType, %FieldType)
     #!
     #CASE(%FieldValidation)   
      #OF ( 'NONZERO')
         #SET (%JKRFieldType, %JKRFieldType & '    ' & '  NOT NULL')
      #OF ( 'BOOLEAN')
        #IF(%FieldTrueValue AND %FieldFalseValue)
          #CASE (%FieldType)
             #OF ('CSTRING') #OROF ('PSTRING') #OROF ('STRING')
               #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' = ' & '''' & %FieldTrueValue  & '''' & ' OR '  & %JKRFieldName & ' = ' & '''' & %FieldFalseValue & '''' & ')' )
             #ELSE
               #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' = ' & %FieldTrueValue  & ' OR '  & %JKRFieldName & ' = ' & %FieldFalseValue & ')' )
          #ENDCASE
        #ENDIF
      #OF ( 'INLIST')
        #IF (ITEMS(%FieldValues))
          #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' IN (')
          #SET (%JKRCounterLoc, 0)
          #FOR(%FieldValues)
            #IF (%JKRCounterLoc = 0)
              #SET (%JKRFieldType, %JKRFieldType & '''' & %FieldValues & '''' )
              #SET (%JKRCounterLoc, 1)
            #ELSE
              #SET (%JKRFieldType, %JKRFieldType & ',' & '''' & %FieldValues & '''' )
            #ENDIF
          #ENDFOR
          #SET (%JKRFieldType, %JKRFieldType & '))')
        #ENDIF
      #OF ( 'INRANGE')
        #IF (%FieldRangeLow AND %FieldRangeHigh)
           #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' BETWEEN ' & %FieldRangeLow & ' AND ' &  %FieldRangeHigh &')'  )
        #ELSIF (%FieldRangeLow AND NOT %FieldRangeHigh)
           #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' >= ' & %FieldRangeLow &')'  )
        #ELSIF (NOT %FieldRangeLow AND %FieldRangeHigh)
           #SET (%JKRFieldType, %JKRFieldType & '  NOT NULL CHECK(' & %JKRFieldName & ' <= '  &  %FieldRangeHigh &')'  )
        #ENDIF
      #ENDCASE
      #ADD(%JKROutputFileLine, '    '  & %JKRFieldName & '    ' & %JKRFieldType )
      #! %[30]JKRFieldName    %JKRFieldType,       
  #ENDFOR
#!
#!
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#! Filename:    d2g.tpw
#! Purpose:     Major generic groups
#! Author:      Copyright  1999-2002 by Roberto Artigas Jr
#!              All rights reserved world wide.
#! Changes:
#! 2002.11.13   Roberto Artigas Jr
#!  *   Added reserved words for several backends. They are...
#!      DB2v7, MySQLv4, Oracle9i, PostgreSQLv7, SQL2000
#! 2002.06.28   Roberto Artigas Jr
#!  *   Added reserved words for SAP SQL backend
#! 2002.03.08   Roberto Artigas Jr
#!  *   Added new SQL items to reserved list
#! 2001.12.30   Lew Strock
#!  *   Added reserve words for Pervasive PSQL
#! 2001.10.27   Roberto Artigas Jr
#!  *   More MySQL documentation reading more keywords added
#! 2001.10.24   Roberto Artigas Jr
#!  *   Per Bruce Johnson - Keywords: ACCESS, APPLICATION
#! 2001.10.22   Roberto Artigas Jr
#!  *   Firebird docs from http://www.ibphoenix.com/ibp_download.html#DOCS
#!      Added Firebird only reserved SQL words.
#! 2001.10.21   Roberto Artigas Jr
#!  *   Added new SQL items to reserved list
#! 2001.10.17   Roberto Artigas Jr
#!  *   Added new PROP: items to reserved list
#! 2001.07.27   Roberto Artigas Jr
#!  *   Broke appart into smaller pieces
#!
#!--------------------------------------------------------------------!
#! 2001.01.18.THU - Roberto Artigas Jr          IMPORTANT PLEASE READ !
#!--------------------------------------------------------------------!
#! This group contains the code necessary to build a searchable list  !
#! of SQL reserved words. This is used to make sure field, key, and   !
#! table names are not in conflict with SQL reserved words.           !
#!--------------------------------------------------------------------!
#! NOTE: These SQL reserved words are in alphabetically order.        !
#! And after spending numerous hours typing all these SQL reserved    !
#! words into this template, they better remain in order.             !
#!--------------------------------------------------------------------!
#! NOTE: There are probably SQL VENDOR SPECIFIC reserved words that   !
#! I do not know about. If you know of some, please let me know.      !
#! That way I can keep this list of reserved words up to date.        !
#!--------------------------------------------------------------------!
#! ALSO: I am a realist. I can pretty much say with a great amount of !
#! certainty, that once having seen this list, most individuals are   !
#! not going to type in their own to achieve the same functionality.  !
#! If you use this list at least have the courtesy of giving credit   !
#! to Roberto Artigas Jr for having typed all of this in. Leave this  !
#! documentation block intact and give credit where credit is due.    !
#!--------------------------------------------------------------------!
#GROUP(%SqlReservedWords)
  #DECLARE(%SqlWordCount)
  #DECLARE(%SqlWordItem)
  #DECLARE(%SqlWordList),MULTI,UNIQUE
  #ADD(%SqlWordList,'A')                                    #! 'A'
  #ADD(%SqlWordList,'ABS')
  #ADD(%SqlWordList,'ABORT')                                #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'ABSOLUTE')
  #ADD(%SqlWordList,'ABSTIME')
  #ADD(%SqlWordList,'ACCESS')                               #! RAS.2001.10.24
  #ADD(%SqlWordList,'ACOS')
  #ADD(%SqlWordList,'ACQUIRE')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'ACTION')
  #ADD(%SqlWordList,'ACTIVE')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'ADA')
  #ADD(%SqlWordList,'ADD')
  #ADD(%SqlWordList,'ADD_MONTHS')
  #ADD(%SqlWordList,'ADMIN')
  #ADD(%SqlWordList,'AFTER')
  #ADD(%SqlWordList,'AGGREGATE')
  #ADD(%SqlWordList,'ALIAS')
  #ADD(%SqlWordList,'ALL')
  #ADD(%SqlWordList,'ALLOCATE')
  #ADD(%SqlWordList,'ALLOW')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'ALTER')
  #ADD(%SqlWordList,'ALWAYS')
  #ADD(%SqlWordList,'ALLOCATE')
  #ADD(%SqlWordList,'ANALYSE')                              #! RAS.2002.11.13 / PostgreSQLv7
  #ADD(%SqlWordList,'ANALYZE')                              #! RAS.2002.11.13 / PostgreSQLv7
  #ADD(%SqlWordList,'AND')
  #ADD(%SqlWordList,'ANSI')
  #ADD(%SqlWordList,'ANSI_NULLS')
  #ADD(%SqlWordList,'ANY')
  #ADD(%SqlWordList,'APPLICATION')                          #! RAS.2001.10.24
  #ADD(%SqlWordList,'ARE')
  #ADD(%SqlWordList,'ARRAY')
  #ADD(%SqlWordList,'AS')
  #ADD(%SqlWordList,'ASC')
  #ADD(%SqlWordList,'ASCENDING')                            #! RAS.2001.10.22
  #ADD(%SqlWordList,'ASCII')
  #ADD(%SqlWordList,'ASCII_CHAR')
  #ADD(%SqlWordList,'ASCII_CODE')
  #ADD(%SqlWordList,'ASENSITIVE')
  #ADD(%SqlWordList,'ASIN')
  #ADD(%SqlWordList,'ASSERTION')
  #ADD(%SqlWordList,'ASSIGNMENT')
  #ADD(%SqlWordList,'ATAN')
  #ADD(%SqlWordList,'ATAN2')
  #ADD(%SqlWordList,'ATOMIC')                               #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'ASUTIME')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'ASYMMETRIC')
  #ADD(%SqlWordList,'ASYNC')
  #ADD(%SqlWordList,'AT')
  #ADD(%SqlWordList,'ATOMIC')
  #ADD(%SqlWordList,'ATTRIBUTE')
  #ADD(%SqlWordList,'AUDIT')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'AUTHID')
  #ADD(%SqlWordList,'AUTHORIZATION')
  #ADD(%SqlWordList,'AUTO')
  #ADD(%SqlWordList,'AUTOCOMMIT')                           #! RAS.2001.10.27
  #ADD(%SqlWordList,'AUTO_INCREMENT')
  #ADD(%SqlWordList,'AUTODLL')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'AUTOSHRINK')
  #ADD(%SqlWordList,'AUX')                                  #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'AUXILIARY')                            #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'AVG')
  #ADD(%SqlWordList,'AVG_ROW_LENGTH')
  #ADD(%SqlWordList,'B')                                    #! 'B'
  #ADD(%SqlWordList,'BACK')
  #ADD(%SqlWordList,'BACKUP')                               #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'BASED')                                #! RAS.2001.10.22
  #ADD(%SqlWordList,'BASENAME')                             #! RAS.2001.10.22
  #ADD(%SqlWordList,'BASE_NAME')                            #! RAS.2001.10.22
  #ADD(%SqlWordList,'BDB')                                  #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'BEFORE')
  #ADD(%SqlWordList,'BEGIN')
  #ADD(%SqlWordList,'BERKLEYDB')                            #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'BETWEEN')
  #ADD(%SqlWordList,'BFILE')
  #ADD(%SqlWordList,'BIGINT')
  #ADD(%SqlWordList,'BINARY')
  #ADD(%SqlWordList,'BINARY_INTEGER')
  #ADD(%SqlWordList,'BIT')
  #ADD(%SqlWordList,'BIT_ADD')
  #ADD(%SqlWordList,'BIT_AND')                              #! RAS.2001.10.27
  #ADD(%SqlWordList,'BIT_LENGTH')
  #ADD(%SqlWordList,'BIT_OR')                               #! RAS.2001.10.27
  #ADD(%SqlWordList,'BIT_ORD')
  #ADD(%SqlWordList,'BLOB')
  #ADD(%SqlWordList,'BLOBEDIT')                             #! RAS.2001.10.22
  #ADD(%SqlWordList,'BODY')
  #ADD(%SqlWordList,'BOOL')
  #ADD(%SqlWordList,'BOOLEAN')
  #ADD(%SqlWordList,'BOTH')
  #ADD(%SqlWordList,'BOX')
  #ADD(%SqlWordList,'BREADTH')
  #ADD(%SqlWordList,'BREAK')                                #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'BROWSE')                               #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'BUFFER')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'BUFFERPOOL')                           #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'BULK')
  #ADD(%SqlWordList,'BULKCOPY')
  #ADD(%SqlWordList,'BY')
  #ADD(%SqlWordList,'C')                                    #! 'C'
  #ADD(%SqlWordList,'CACHE')                                #! RAS.2001.10.22
  #ADD(%SqlWordList,'CALL')
  #ADD(%SqlWordList,'CALLED')
  #ADD(%SqlWordList,'CAPTURE')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'CARDINALITY')
  #ADD(%SqlWordList,'CASCADE')
  #ADD(%SqlWordList,'CASCADED')
  #ADD(%SqlWordList,'CASE')
  #ADD(%SqlWordList,'CAST')
  #ADD(%SqlWordList,'CATALOG')
  #ADD(%SqlWordList,'CATALOGEXTRACT')                       #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'CATALOGLOAD')                          #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'CATALOG_NAME')
  #ADD(%SqlWordList,'CCSID')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'CEIL')
  #ADD(%SqlWordList,'CEILING')
  #ADD(%SqlWordList,'CHAIN')
  #ADD(%SqlWordList,'CHANGE')                               #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'CHAR')
  #ADD(%SqlWordList,'CHAR_BASE')
  #ADD(%SqlWordList,'CHAR_INDEX')
  #ADD(%SqlWordList,'CHAR_LENGTH')
  #ADD(%SqlWordList,'CHAR16')
  #ADD(%SqlWordList,'CHAR2')
  #ADD(%SqlWordList,'CHAR4')
  #ADD(%SqlWordList,'CHAR8')
  #ADD(%SqlWordList,'CHARACTER')
  #ADD(%SqlWordList,'CHARACTER_LENGTH')
  #ADD(%SqlWordList,'CHARACTER_SET_CATALOG')
  #ADD(%SqlWordList,'CHARACTER_SET_NAME')
  #ADD(%SqlWordList,'CHARACTER_SET_SCHEMA')
  #ADD(%SqlWordList,'CHARACTERISTICS')
  #ADD(%SqlWordList,'CHANGE')
  #ADD(%SqlWordList,'CHECK')
  #ADD(%SqlWordList,'CHECK_POINT_LEN')                      #! RAS.2001.10.22
  #ADD(%SqlWordList,'CHECK_POINT_LENGTH')                   #! RAS.2001.10.22
  #ADD(%SqlWordList,'CHECKED')
  #ADD(%SqlWordList,'CHECKPOINT')                           #! RAS.2002.11.12 / SQL2000
  #ADD(%SqlWordList,'CHECKSUM')
  #ADD(%SqlWordList,'CHOOSE')
  #ADD(%SqlWordList,'CHR')
  #ADD(%SqlWordList,'CIDR')
  #ADD(%SqlWordList,'CIRCLE')
  #ADD(%SqlWordList,'CLASS')
  #ADD(%SqlWordList,'CLASS_ORIGIN')
  #ADD(%SqlWordList,'CLOB')
  #ADD(%SqlWordList,'CLOSE')
  #ADD(%SqlWordList,'CLUSTER')
  #ADD(%SqlWordList,'CLUSTERED')
  #ADD(%SqlWordList,'COALESCE')
  #ADD(%SqlWordList,'COBOL')
  #ADD(%SqlWordList,'CODESET')                              #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'CODETYPE')                             #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'COLLATE')
  #ADD(%SqlWordList,'COLLATION')
  #ADD(%SqlWordList,'COLLATION_CATALOG')
  #ADD(%SqlWordList,'COLLATION_NAME')
  #ADD(%SqlWordList,'COLLATION_SCHEMA')
  #ADD(%SqlWordList,'COLLECT')
  #ADD(%SqlWordList,'COLLECTION')                           #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'COLLID')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'COLUMN')
  #ADD(%SqlWordList,'COLUMN_NAME')
  #ADD(%SqlWordList,'COLUMNS')
  #ADD(%SqlWordList,'COMMAND_FUNCTION')
  #ADD(%SqlWordList,'COMMAND_FUNCTION_CODE')
  #ADD(%SqlWordList,'COMMENT')
  #ADD(%SqlWordList,'COMMIT')
  #ADD(%SqlWordList,'COMMITED')
  #ADD(%SqlWordList,'COMPILETIME')                          #! RAS.2001.10.22
  #ADD(%SqlWordList,'COMPLETION')
  #ADD(%SqlWordList,'COMPRESS')
  #ADD(%SqlWordList,'COMPUTE')                              #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'COMPUTED')                             #! RAS.2001.10.22
  #ADD(%SqlWordList,'CONCAT')
  #ADD(%SqlWordList,'CONCURRENT')                           #! RAS.2001.10.27
  #ADD(%SqlWordList,'CONDITION_NUMBER')
  #ADD(%SqlWordList,'CONDITIONAL')                          #! RAS.2001.10.22
  #ADD(%SqlWordList,'CONNECT')
  #ADD(%SqlWordList,'CONNECTION')
  #ADD(%SqlWordList,'CONNECTION_NAME')
  #ADD(%SqlWordList,'CONSTANT')
  #ADD(%SqlWordList,'CONSTRAINT')
  #ADD(%SqlWordList,'CONSTRAINT_CATALOG')
  #ADD(%SqlWordList,'CONSTRAINT_NAME')
  #ADD(%SqlWordList,'CONSTRAINT_SCHEMA')
  #ADD(%SqlWordList,'CONSTRAINTS')
  #ADD(%SqlWordList,'CONSTRUCTOR')
  #ADD(%SqlWordList,'CONTAINING')                           #! RAS.2001.10.22
  #ADD(%SqlWordList,'CONTAINS')
  #ADD(%SqlWordList,'CONTAINSTABLE')                        #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'CONTINUE')
  #ADD(%SqlWordList,'CONVERT')
  #ADD(%SqlWordList,'CORR')
  #ADD(%SqlWordList,'CORRESPONDING')
  #ADD(%SqlWordList,'COS')
  #ADD(%SqlWordList,'COSH')
  #ADD(%SqlWordList,'COT')
  #ADD(%SqlWordList,'COUNT')
  #ADD(%SqlWordList,'COUNT_BIG')                            #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'COVAR_POP')
  #ADD(%SqlWordList,'COVAR_SAMP')
  #ADD(%SqlWordList,'CREATE')
  #ADD(%SqlWordList,'CREATETAB')                            #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'CROSS')
  #ADD(%SqlWordList,'CS')                                   #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'CSTRING')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'CUBE')
  #ADD(%SqlWordList,'CUME_DIST')
  #ADD(%SqlWordList,'CURDATE')
  #ADD(%SqlWordList,'CURRENT')
  #ADD(%SqlWordList,'CURRENT_DATE')
  #ADD(%SqlWordList,'CURRENT_DEFAULT_TRANSFORM_GROUP')
  #ADD(%SqlWordList,'CURRENT_LC_PATH')                      #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'CURRENT_PATH')
  #ADD(%SqlWordList,'CURRENT_ROLE')
  #ADD(%SqlWordList,'CURRENT_SERVER')                       #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'CURRENT_TIME')
  #ADD(%SqlWordList,'CURRENT_TIMESTAMP')
  #ADD(%SqlWordList,'CURRENT_TIMEZONE')                     #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'CURRENT_TRANSFORM_GROUP_FOR_TYPE')
  #ADD(%SqlWordList,'CURRENT_USER')
  #ADD(%SqlWordList,'CURRVAL')
  #ADD(%SqlWordList,'CURTIME')
  #ADD(%SqlWordList,'CURSOR')
  #ADD(%SqlWordList,'CURSOR_NAME')
  #ADD(%SqlWordList,'CYCLE')
  #ADD(%SqlWordList,'D')                                    #! 'D'
  #ADD(%SqlWordList,'DATA')
  #ADD(%SqlWordList,'DATABASE')
  #ADD(%SqlWordList,'DATABASES')
  #ADD(%SqlWordList,'DATAEXTRACT')                          #! 2002.06.28 / SAP
  #ADD(%SqlWordList,'DATALOAD')                             #! 2002.06.28 / SAP
  #ADD(%SqlWordList,'DATAUPDATE')                           #! 2002.06.28 / SAP
  #ADD(%SqlWordList,'DATE')
  #ADD(%SqlWordList,'DATE_FORMAT')
  #ADD(%SqlWordList,'DATEADD')
  #ADD(%SqlWordList,'DATEDIFF')
  #ADD(%SqlWordList,'DATENAME')
  #ADD(%SqlWordList,'DATEPART')
  #ADD(%SqlWordList,'DATETIME')
  #ADD(%SqlWordList,'DATETIME_INTERVAL_CODE')
  #ADD(%SqlWordList,'DATETIME_INTERVAL_PRECISION')
  #ADD(%SqlWordList,'DAY')
  #ADD(%SqlWordList,'DAY_HOUR')
  #ADD(%SqlWordList,'DAY_MINUTE')
  #ADD(%SqlWordList,'DAY_SECOND')
  #ADD(%SqlWordList,'DAYNAME')
  #ADD(%SqlWordList,'DAYOFMONTH')
  #ADD(%SqlWordList,'DAYOFWEEK')
  #ADD(%SqlWordList,'DAYOFYEAR')
  #ADD(%SqlWordList,'DAYS')                                 #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DB')                                   #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'DB2')                                  #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'DB2GENERAL')                           #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DB2SQL')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DBA')                                  #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DBCC')                                 #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'DBEXTRACT')                            #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'DBINFO')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DBLOAD')                               #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'DBO')
  #ADD(%SqlWordList,'DBSPACE')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DB_KEY')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'DEALLOCATE')
  #ADD(%SqlWordList,'DEBUG')                                #! RAS.2001.10.22
  #ADD(%SqlWordList,'DEC')
  #ADD(%SqlWordList,'DECIMAL')
  #ADD(%SqlWordList,'DECLARE')
  #ADD(%SqlWordList,'DEFAULT')
  #ADD(%SqlWordList,'DEFERRABLE')
  #ADD(%SqlWordList,'DEFERRED')
  #ADD(%SqlWordList,'DEFINED')
  #ADD(%SqlWordList,'DEFINER')
  #ADD(%SqlWordList,'DEGREE')
  #ADD(%SqlWordList,'DELAYED')
  #ADD(%SqlWordList,'DELAY_KEY_WRITE')
  #ADD(%SqlWordList,'DELETE')
  #ADD(%SqlWordList,'DENSE_RANK')
  #ADD(%SqlWordList,'DENY')                                 #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'DEPTH')
  #ADD(%SqlWordList,'DEREF')
  #ADD(%SqlWordList,'DERIVED')
  #ADD(%SqlWordList,'DESC')
  #ADD(%SqlWordList,'DESCENDING')                           #! RAS.2001.10.22
  #ADD(%SqlWordList,'DESCRIBE')
  #ADD(%SqlWordList,'DESCRIPTOR')
  #ADD(%SqlWordList,'DESTROYED')
  #ADD(%SqlWordList,'DESTRUCTOR')
  #ADD(%SqlWordList,'DETECTION')
  #ADD(%SqlWordList,'DETERMINISTIC')
  #ADD(%SqlWordList,'DIAGNOSTICS')
  #ADD(%SqlWordList,'DIALECT')
  #ADD(%SqlWordList,'DICTIONARY')
  #ADD(%SqlWordList,'DISALLOW')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DISCONNECT')
  #ADD(%SqlWordList,'DISK')                                 #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DISPATCH')
  #ADD(%SqlWordList,'DISPLAY')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'DISTINCT')
  #ADD(%SqlWordList,'DISTINCTROW')
  #ADD(%SqlWordList,'DISTRIBUTED')                          #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'DO')
  #ADD(%SqlWordList,'DOMAIN')
  #ADD(%SqlWordList,'DOUBLE')
  #ADD(%SqlWordList,'DROP')
  #ADD(%SqlWordList,'DSSIZE')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'DUMMY')                                #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'DUMP')                                 #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'DUMPFILE')                             #! RAS.2001.10.27
  #ADD(%SqlWordList,'DYNAMIC')
  #ADD(%SqlWordList,'DYNAMIC_FUNCTION')
  #ADD(%SqlWordList,'DYNAMIC_FUNCTION_CODE')
  #ADD(%SqlWordList,'E')                                    #! 'E'
  #ADD(%SqlWordList,'EACH')
  #ADD(%SqlWordList,'EBCDIC')                               #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'ECHO')                                 #! RAS.2001.10.22
  #ADD(%SqlWordList,'EDIT')                                 #! RAS.2001.10.22
  #ADD(%SqlWordList,'EDITPROC')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'ELEMENT')                              #! RAS.2002.03.08
  #ADD(%SqlWordList,'ELSE')
  #ADD(%SqlWordList,'ELSEIF')
  #ADD(%SqlWordList,'ELSIF')
  #ADD(%SqlWordList,'ELT')
  #ADD(%SqlWordList,'ENCLOSED')                             #! RAS.2001.10.27
  #ADD(%SqlWordList,'ENCRYPT')
  #ADD(%SqlWordList,'END')
  #ADD(%SqlWordList,'END-EXEC')
  #ADD(%SqlWordList,'EQUALS')
  #ADD(%SqlWordList,'ERASE')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'ERRLVL')                               #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'ESCAPE')
  #ADD(%SqlWordList,'ESCAPED')
  #ADD(%SqlWordList,'ENCLOSED')
  #ADD(%SqlWordList,'ENTRY_POINT')                          #! RAS.2001.10.22
  #ADD(%SqlWordList,'ENUM')
  #ADD(%SqlWordList,'EUR')                                  #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'EVENT')                                #! RAS.2001.10.22
  #ADD(%SqlWordList,'EVERY')
  #ADD(%SqlWordList,'EX')                                   #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'EXCEPT')
  #ADD(%SqlWordList,'EXCEPTION')
  #ADD(%SqlWordList,'EXCLUDE')
  #ADD(%SqlWordList,'EXCLUSIVE')
  #ADD(%SqlWordList,'EXEC')
  #ADD(%SqlWordList,'EXECUTE')
  #ADD(%SqlWordList,'EXISTS')
  #ADD(%SqlWordList,'EXIT')
  #ADD(%SqlWordList,'EXP')
  #ADD(%SqlWordList,'EXPLAIN')
  #ADD(%SqlWordList,'EXTENDS')
  #ADD(%SqlWordList,'EXTERN')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'EXTERNAL')
  #ADD(%SqlWordList,'EXTRACT')
  #ADD(%SqlWordList,'F')                                    #! 'F'
  #ADD(%SqlWordList,'FALSE')
  #ADD(%SqlWordList,'FASTLOAD')                             #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'FETCH')
  #ADD(%SqlWordList,'FENCED')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'FIELDPROC')                            #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'FIELDS')
  #ADD(%SqlWordList,'FILE')
  #ADD(%SqlWordList,'FILEGROWTH')
  #ADD(%SqlWordList,'FILENAME')
  #ADD(%SqlWordList,'FILLFACTOR')
  #ADD(%SqlWordList,'FILTER')
  #ADD(%SqlWordList,'FINAL')
  #ADD(%SqlWordList,'FIND')
  #ADD(%SqlWordList,'FIRST')
  #ADD(%SqlWordList,'FIXED')                                #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'FLOAT')
  #ADD(%SqlWordList,'FLOAT4')
  #ADD(%SqlWordList,'FLOAT8')
  #ADD(%SqlWordList,'FLOOR')
  #ADD(%SqlWordList,'FLUSH')
  #ADD(%SqlWordList,'FOLLOWING')
  #ADD(%SqlWordList,'FOR')
  #ADD(%SqlWordList,'FORALL')
  #ADD(%SqlWordList,'FOREIGN')
  #ADD(%SqlWordList,'FORMAT')
  #ADD(%SqlWordList,'FORMATED')                             #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'FORTRAN')
  #ADD(%SqlWordList,'FOUND')
  #ADD(%SqlWordList,'FREE')
  #ADD(%SqlWordList,'FREE_IT')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'FREETEXT')                             #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'FREETEXTTABLE')                        #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'FROM')
  #ADD(%SqlWordList,'FROM_DAYS')
  #ADD(%SqlWordList,'FROM_UNIXTIME')
  #ADD(%SqlWordList,'FULL')
  #ADD(%SqlWordList,'FULLTEXT')                             #! RAS.2001.10.27
  #ADD(%SqlWordList,'FUNCTION')
  #ADD(%SqlWordList,'G')                                    #! 'G'
  #ADD(%SqlWordList,'GDSCODE')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'GEMINI')
  #ADD(%SqlWordList,'GENERAL')
  #ADD(%SqlWordList,'GENERATED')
  #ADD(%SqlWordList,'GENERATOR')                            #! RAS.2001.10.21
  #ADD(%SqlWordList,'GENE_ID')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'GET')
  #ADD(%SqlWordList,'GETDATE')
  #ADD(%SqlWordList,'GLOBAL')
  #ADD(%SqlWordList,'GO')
  #ADD(%SqlWordList,'GOTO')
  #ADD(%SqlWordList,'GRANT')
  #ADD(%SqlWordList,'GRANTED')
  #ADD(%SqlWordList,'GRANTS')
  #ADD(%SqlWordList,'GRAPHIC')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'GREATEST')
  #ADD(%SqlWordList,'GROUP')
  #ADD(%SqlWordList,'GROUP_COMMIT_WAIT')                    #! RAS.2001.10.22
  #ADD(%SqlWordList,'GROUP_COMMIT_WAIT_TIME')               #! RAS.2001.10.22
  #ADD(%SqlWordList,'GROUPING')
  #ADD(%SqlWordList,'H')                                    #! 'H'
  #ADD(%SqlWordList,'HANDLER')                              #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'HAVING')
  #ADD(%SqlWordList,'HEAP')
  #ADD(%SqlWordList,'HELP')
  #ADD(%SqlWordList,'HEX')                                  #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'HIERARCHY')
  #ADD(%SqlWordList,'HIGH_PRIORITY')
  #ADD(%SqlWordList,'HILO')                                 #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'HOLD')
  #ADD(%SqlWordList,'HOLDLOCK')                             #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'HOST')
  #ADD(%SqlWordList,'HOSTS')
  #ADD(%SqlWordList,'HOUR')
  #ADD(%SqlWordList,'HOUR_MINUTE')
  #ADD(%SqlWordList,'HOUR_SECOND')
  #ADD(%SqlWordList,'HOURS')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'I')                                    #! 'I'
  #ADD(%SqlWordList,'ID')
  #ADD(%SqlWordList,'IDENTIFIED')
  #ADD(%SqlWordList,'IDENTITY_INSERT')                      #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'IDENTITY')
  #ADD(%SqlWordList,'IDENTITYCOL')                          #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'IF')
  #ADD(%SqlWordList,'IFNULL')
  #ADD(%SqlWordList,'IGNORE')
  #ADD(%SqlWordList,'ILIKE')                                #! RAS.2002.11.13 / PostgreSQLv7
  #ADD(%SqlWordList,'IMAGE')
  #ADD(%SqlWordList,'IMMEDIATE')
  #ADD(%SqlWordList,'IMPLEMENTATION')
  #ADD(%SqlWordList,'IN')
  #ADD(%SqlWordList,'INACTIVE')                             #! RAS.2001.10.22
  #ADD(%SqlWordList,'INCREMENT')
  #ADD(%SqlWordList,'INDICATOR')
  #ADD(%SqlWordList,'INDEX')
  #ADD(%SqlWordList,'INET')
  #ADD(%SqlWordList,'INFILE')
  #ADD(%SqlWordList,'INIT')                                 #! RAS.2001.10.22
  #ADD(%SqlWordList,'INITCAP')
  #ADD(%SqlWordList,'INITIAL')                              #! RAS.2002.11.13 / Oracle9i
  #ADD(%SqlWordList,'INITIALIZE')
  #ADD(%SqlWordList,'INITIALLY')
  #ADD(%SqlWordList,'INNER')
  #ADD(%SqlWordList,'INNODB')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'INOUT')
  #ADD(%SqlWordList,'INPUT')
  #ADD(%SqlWordList,'INPUT_TYPE')                           #! RAS.2001.10.22
  #ADD(%SqlWordList,'INSENSITIVE')
  #ADD(%SqlWordList,'INSERT')
  #ADD(%SqlWordList,'INSERT_ID')
  #ADD(%SqlWordList,'INSTALLATION')                         #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'INSTANCE')
  #ADD(%SqlWordList,'INSTANTIABLE')
  #ADD(%SqlWordList,'INTEGRITY')                            #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'INTERNAL')                             #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'INTERFACE')
  #ADD(%SqlWordList,'INSTR')
  #ADD(%SqlWordList,'INSTRB')
  #ADD(%SqlWordList,'INT')
  #ADD(%SqlWordList,'INT1')
  #ADD(%SqlWordList,'INT2')
  #ADD(%SqlWordList,'INT3')
  #ADD(%SqlWordList,'INT4')
  #ADD(%SqlWordList,'INT8')
  #ADD(%SqlWordList,'INTEGER')
  #ADD(%SqlWordList,'INTERNAL')                             #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'INTERSECT')
  #ADD(%SqlWordList,'INTERVAL')
  #ADD(%SqlWordList,'INTO')
  #ADD(%SqlWordList,'INVOKER')
  #ADD(%SqlWordList,'IS')
  #ADD(%SqlWordList,'ISAM')
  #ADD(%SqlWordList,'ISFOREIGNKEY')
  #ADD(%SqlWordList,'ISNULL')                               #! RAS.2002.11.13 / PostgreSQLv7
  #ADD(%SqlWordList,'ISO')                                  #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'ISOBID')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'ISOLATION')
  #ADD(%SqlWordList,'ISQL')                                 #! RAS.2001.10.22
  #ADD(%SqlWordList,'ISRULE')
  #ADD(%SqlWordList,'ISTRIGGER')
  #ADD(%SqlWordList,'ISUSERTABLE')
  #ADD(%SqlWordList,'ISVIEW')
  #ADD(%SqlWordList,'ITERATE')
  #ADD(%SqlWordList,'J')                                    #! 'J'
  #ADD(%SqlWordList,'JAVA')
  #ADD(%SqlWordList,'JIS')                                  #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'JOIN')
  #ADD(%SqlWordList,'K')                                    #! 'K'
  #ADD(%SqlWordList,'KEY')
  #ADD(%SqlWordList,'KEY_MEMBER')
  #ADD(%SqlWordList,'KEY_TYPE')
  #ADD(%SqlWordList,'KEYS')
  #ADD(%SqlWordList,'KILL')
  #ADD(%SqlWordList,'L')                                    #! 'L'
  #ADD(%SqlWordList,'LABEL')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'LANGUAGE')
  #ADD(%SqlWordList,'LARGE')
  #ADD(%SqlWordList,'LAST')
  #ADD(%SqlWordList,'LAST_DAY')
  #ADD(%SqlWordList,'LAST_INSERT_ID')
  #ADD(%SqlWordList,'LATERAL')
  #ADD(%SqlWordList,'LCASE')
  #ADD(%SqlWordList,'LC_CTYPE')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'LC_MESSAGES')                          #! RAS.2001.10.22
  #ADD(%SqlWordList,'LC_TYPE')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'LEADING')
  #ADD(%SqlWordList,'LEAVE')
  #ADD(%SqlWordList,'LEFT')
  #ADD(%SqlWordList,'LENGTH')
  #ADD(%SqlWordList,'LENGTHB')
  #ADD(%SqlWordList,'LESS')
  #ADD(%SqlWordList,'LEV')                                  #! RAS.2001.10.22
  #ADD(%SqlWordList,'LEVEL')
  #ADD(%SqlWordList,'LIKE')
  #ADD(%SqlWordList,'LIMIT')
  #ADD(%SqlWordList,'LIMITED')
  #ADD(%SqlWordList,'LINENO')                               #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'LINES')
  #ADD(%SqlWordList,'LINKTYPE')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'LN')
  #ADD(%SqlWordList,'LOAD')
  #ADD(%SqlWordList,'LOCAL')
  #ADD(%SqlWordList,'LOCALTIME')
  #ADD(%SqlWordList,'LOCALTIMESTAMP')
  #ADD(%SqlWordList,'LOCATE')
  #ADD(%SqlWordList,'LOCATOR')
  #ADD(%SqlWordList,'LOCATORS')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'LOCK')
  #ADD(%SqlWordList,'LOCKSIZE')                             #! RAs.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'LOG')
  #ADD(%SqlWordList,'LOG10')
  #ADD(%SqlWordList,'LOGIN')                                #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'LOGFILE')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'LOG_BUFFER_SIZE')                      #! RAS.2001.10.22
  #ADD(%SqlWordList,'LOG_BUF_SIZE')                         #! RAS.2001.10.22
  #ADD(%SqlWordList,'LOGS')
  #ADD(%SqlWordList,'LOGS')
  #ADD(%SqlWordList,'LOHI')                                 #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'LONG')                                 #! RAs.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'LONGBLOB')
  #ADD(%SqlWordList,'LONGFILE')                             #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'LONGTEXT')
  #ADD(%SqlWordList,'LOOP')
  #ADD(%SqlWordList,'LOWER')
  #ADD(%SqlWordList,'LOW_PRIORITY')
  #ADD(%SqlWordList,'LPAD')
  #ADD(%SqlWordList,'LSEG')
  #ADD(%SqlWordList,'LTRIM')
  #ADD(%SqlWordList,'M')                                    #! 'M'
  #ADD(%SqlWordList,'MACADDR')
  #ADD(%SqlWordList,'MANUAL')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'MAP')
  #ADD(%SqlWordList,'MATCH')
  #ADD(%SqlWordList,'MATCHES')
  #ADD(%SqlWordList,'MASTER_LOG_SEQ')                       #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'MASTER_SERVER_ID')                     #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'MAX')
  #ADD(%SqlWordList,'MAXEXTENTS')                           #! RAS.2002.11.13 / Oracle9i
  #ADD(%SqlWordList,'MAXIMUM')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'MAXIMUM_SEGMENT')                      #! RAS.2001.10.22
  #ADD(%SqlWordList,'MAX_ROWS')
  #ADD(%SqlWordList,'MAX_SEGMENT')                          #! RAS.2001.10.22
  #ADD(%SqlWordList,'MD5')
  #ADD(%SqlWordList,'MDY')
  #ADD(%SqlWordList,'MEDIUMBLOB')
  #ADD(%SqlWordList,'MEDIUMINT')
  #ADD(%SqlWordList,'MEDIUMTEXT')
  #ADD(%SqlWordList,'MEMBER')                               #! RAS.2002.03.08
  #ADD(%SqlWordList,'MERGE')
  #ADD(%SqlWordList,'METHOD')
  #ADD(%SqlWordList,'MESSAGE')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'MESSAGE_LENGTH')
  #ADD(%SqlWordList,'MESSAGE_OCTET_LENGTH')
  #ADD(%SqlWordList,'MESSAGE_TEXT')
  #ADD(%SqlWordList,'MICROSECOND')                          #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'MICROSECONDS')                         #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'MIDDLEINT')
  #ADD(%SqlWordList,'MIN')
  #ADD(%SqlWordList,'MINIMUM')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'MIN_ROWS')
  #ADD(%SqlWordList,'MINUS')
  #ADD(%SqlWordList,'MINUTE')
  #ADD(%SqlWordList,'MINUTE_SECOND')
  #ADD(%SqlWordList,'MINUTES')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'MLSLABEL')
  #ADD(%SqlWordList,'MOD')
  #ADD(%SqlWordList,'MODE')
  #ADD(%SqlWordList,'MODIFIABLE')                           #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'MODIFIES')
  #ADD(%SqlWordList,'MODIFY')
  #ADD(%SqlWordList,'MODULE')
  #ADD(%SqlWordList,'MODULE_NAME')                          #! RAS.2001.10.22
  #ADD(%SqlWordList,'MONEY')
  #ADD(%SqlWordList,'MONTH')
  #ADD(%SqlWordList,'MONTHNAME')
  #ADD(%SqlWordList,'MONTHS')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'MONTHS_BETWEEN')
  #ADD(%SqlWordList,'MORE')
  #ADD(%SqlWordList,'MRG_MYISAM')                           #! RAS.2001.10.27
  #ADD(%SqlWordList,'MYISAM')
  #ADD(%SqlWordList,'MULTISET')                             #! RAS.2002.03.08
  #ADD(%SqlWordList,'MUMPS')
  #ADD(%SqlWordList,'N')                                    #! 'N'
  #ADD(%SqlWordList,'NAME')
  #ADD(%SqlWordList,'NAMED')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'NAMES')
  #ADD(%SqlWordList,'NATIONAL')
  #ADD(%SqlWordList,'NATURAL')
  #ADD(%SqlWordList,'NATURALN')
  #ADD(%SqlWordList,'NCHAR')
  #ADD(%SqlWordList,'NCHARACTER')
  #ADD(%SqlWordList,'NCLOB')
  #ADD(%SqlWordList,'NESTING')
  #ADD(%SqlWordList,'NEW')
  #ADD(%SqlWordList,'NEXT')
  #ADD(%SqlWordList,'NEXTVAL')
  #ADD(%SqlWordList,'NHEADER')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'NO')
  #ADD(%SqlWordList,'NOAUDIT')                              #! RAS.2002.11.13 / Oracle9i
  #ADD(%SqlWordList,'NOAUTO')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'NOCHECK')
  #ADD(%SqlWordList,'NOCOMPRESS')                           #! RAS.2002.11.13 / Oracle9i
  #ADD(%SqlWordList,'NOCOPY')
  #ADD(%SqlWordList,'NODENAME')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'NODENUMBER')                           #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'NONCLUSTERED')
  #ADD(%SqlWordList,'NONE')
  #ADD(%SqlWordList,'NOT')
  #ADD(%SqlWordList,'NOTNULL')                              #! RAS.2002.11.13 / PostgreSQLv7
  #ADD(%SqlWordList,'NOW')
  #ADD(%SqlWordList,'NOWAIT')
  #ADD(%SqlWordList,'NULL')
  #ADD(%SqlWordList,'NULLABLE')
  #ADD(%SqlWordList,'NULLIF')
  #ADD(%SqlWordList,'NULLS')
  #ADD(%SqlWordList,'NUMBER')
  #ADD(%SqlWordList,'NUMBER_BASE')
  #ADD(%SqlWordList,'NUMERIC')
  #ADD(%SqlWordList,'NUMPARTS')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'NUM_LOG_BUFS')                         #! RAS.2001.10.22
  #ADD(%SqlWordList,'NUM_LOG_BUFFERS')                      #! RAS.2001.10.22
  #ADD(%SqlWordList,'NVARCHAR')
  #ADD(%SqlWordList,'NVARCHAR2')
  #ADD(%SqlWordList,'O')                                    #! 'O'
  #ADD(%SqlWordList,'OBID')                                 #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'OBJECT')
  #ADD(%SqlWordList,'OBJECT_ID')
  #ADD(%SqlWordList,'OBJECTPROPERTY')
  #ADD(%SqlWordList,'OCIROWID')
  #ADD(%SqlWordList,'OCTET_LENGTH')
  #ADD(%SqlWordList,'ODBC')
  #ADD(%SqlWordList,'OF')
  #ADD(%SqlWordList,'OFF')
  #ADD(%SqlWordList,'OFFLINE')                              #! RAS.2002.11.13 / Oracle9i
  #ADD(%SqlWordList,'OFFSET')                               #! RAS.2002.11.13 / PostgreSQLv7
  #ADD(%SqlWordList,'OFFSETS')                              #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'OID')
  #ADD(%SqlWordList,'OLD')
  #ADD(%SqlWordList,'ON')
  #ADD(%SqlWordList,'ONLINE')                               #! RAS.2002.11.13 / Oracle9i
  #ADD(%SqlWordList,'ONLY')
  #ADD(%SqlWordList,'OPAQUE')
  #ADD(%SqlWordList,'OPEN')
  #ADD(%SqlWordList,'OPENDATASOURCE')                       #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'OPENQUERY')                            #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'OPENROWSET')                           #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'OPENXML')                              #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'OPERATION')
  #ADD(%SqlWordList,'OPERATOR')
  #ADD(%SqlWordList,'OPERATORS')
  #ADD(%SqlWordList,'OPTIMIZATION')                         #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'OPTIMIZE')
  #ADD(%SqlWordList,'OPTION')
  #ADD(%SqlWordList,'OPTIONS')
  #ADD(%SqlWordList,'OPTIONALLY')
  #ADD(%SqlWordList,'OR')
  #ADD(%SqlWordList,'ORACLE')                               #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'ORDER')
  #ADD(%SqlWordList,'ORDERING')
  #ADD(%SqlWordList,'ORDINALITY')
  #ADD(%SqlWordList,'ORGANIZATION')
  #ADD(%SqlWordList,'OTHERS')
  #ADD(%SqlWordList,'OTHERWISE')                            #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'OUT')
  #ADD(%SqlWordList,'OUTER')
  #ADD(%SqlWordList,'OUTFIELDS')                            #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'OUTFILE')
  #ADD(%SqlWordList,'OUTPUT')
  #ADD(%SqlWordList,'OUTPUT_TYPE')                          #! RAS.2001.10.22
  #ADD(%SqlWordList,'OVER')
  #ADD(%SqlWordList,'OVERFLOW')                             #! RAS.2001.10.22
  #ADD(%SqlWordList,'OVERLAPS')
  #ADD(%SqlWordList,'OVERLAYS')
  #ADD(%SqlWordList,'OVERRIDING')
  #ADD(%SqlWordList,'P')                                    #! 'P'
  #ADD(%SqlWordList,'PACK_KEYS')
  #ADD(%SqlWordList,'PACKAGE')
  #ADD(%SqlWordList,'PAD')
  #ADD(%SqlWordList,'PAGE')
  #ADD(%SqlWordList,'PAGELENGTH')                           #! RAS.2001.10.22
  #ADD(%SqlWordList,'PAGES')                                #! RAS.2001.10.22
  #ADD(%SqlWordList,'PAGE_SIZE')                            #! RAS.2001.10.22
  #ADD(%SqlWordList,'PARAMETER')
  #ADD(%SqlWordList,'PARAMETER_MODE')
  #ADD(%SqlWordList,'PARAMETER_NAME')
  #ADD(%SqlWordList,'PARAMETER_ORDINAL_POSITION')
  #ADD(%SqlWordList,'PARAMETER_SPECIFIC_CATALOG')
  #ADD(%SqlWordList,'PARAMETER_SPECIFIC_NAME')
  #ADD(%SqlWordList,'PARAMETER_SPECIFIC_SCHEMA')
  #ADD(%SqlWordList,'PARAMETERS')
  #ADD(%SqlWordList,'PART')                                 #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'PARTIAL')
  #ADD(%SqlWordList,'PARTITION')
  #ADD(%SqlWordList,'PATH')
  #ADD(%SqlWordList,'PASCAL')
  #ADD(%SqlWordList,'PASSWORD')
  #ADD(%SqlWordList,'PASTE')
  #ADD(%SqlWordList,'PATINDEX')
  #ADD(%SqlWordList,'PATINDEX')
  #ADD(%SqlWordList,'PCTFREE')
  #ADD(%SqlWordList,'PERCENT')                              #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'PERCENTILE_CONT')
  #ADD(%SqlWordList,'PERCENTILE_DISC')
  #ADD(%SqlWordList,'PERCENT_RANK')
  #ADD(%SqlWordList,'PERIOD_ADD')
  #ADD(%SqlWordList,'PERIOD_DIFF')
  #ADD(%SqlWordList,'PI')
  #ADD(%SqlWordList,'PIECESIZE')                            #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'PLACING')
  #ADD(%SqlWordList,'PLAN')                                 #! RAS.2001.10.22
  #ADD(%SqlWordList,'PLI')
  #ADD(%SqlWordList,'PLS_INTEGER')
  #ADD(%SqlWordList,'POINT')
  #ADD(%SqlWordList,'POLYGON')
  #ADD(%SqlWordList,'POS')                                  #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'POSITION')
  #ADD(%SqlWordList,'POSITIVE')
  #ADD(%SqlWordList,'POSITIVEN')
  #ADD(%SqlWordList,'POSTFIX')
  #ADD(%SqlWordList,'POST_EVENT')                           #! RAS.2001.10.22
  #ADD(%SqlWordList,'POW')
  #ADD(%SqlWordList,'POWER')
  #ADD(%SqlWordList,'PRAGMA')
  #ADD(%SqlWordList,'PRECEDING')
  #ADD(%SqlWordList,'PRECISION')
  #ADD(%SqlWordList,'PREFIX')
  #ADD(%SqlWordList,'PREORDER')
  #ADD(%SqlWordList,'PREPARE')
  #ADD(%SqlWordList,'PRESERVE')
  #ADD(%SqlWordList,'PRIMARY')
  #ADD(%SqlWordList,'PRINT')                                #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'PRIOR')
  #ADD(%SqlWordList,'PRIQTY')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'PRIVATE')
  #ADD(%SqlWordList,'PRIVILEGES')
  #ADD(%SqlWordList,'PROC')                                 #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'PROCEDURE')
  #ADD(%SqlWordList,'PROCESS')
  #ADD(%SqlWordList,'PROCESSLIST')
  #ADD(%SqlWordList,'PROGRAM')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'PROTECTED')
  #ADD(%SqlWordList,'PSID')                                 #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'PUBLIC')
  #ADD(%SqlWordList,'PURGE')                                #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'Q')                                    #! 'Q'
  #ADD(%SqlWordList,'QUARTER')
  #ADD(%SqlWordList,'QUIT')                                 #! RAS.2001.10.22
  #ADD(%SqlWordList,'QUOTED')
  #ADD(%SqlWordList,'QUOTED_IDENTIFIER')
  #ADD(%SqlWordList,'QYERYNO')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'R')                                    #! 'R'
  #ADD(%SqlWordList,'RADIANS')
  #ADD(%SqlWordList,'RAID0')                                #! RAS.2001.10.27
  #ADD(%SqlWordList,'RAID_CHUNKS')                          #! RAS.2001.10.27
  #ADD(%SqlWordList,'RAID_CHUNKSIZE')                       #! RAS.2001.10.27
  #ADD(%SqlWordList,'RAID_TYPE')                            #! RAS.2001.10.27
  #ADD(%SqlWordList,'RAISE')
  #ADD(%SqlWordList,'RAISERROR')
  #ADD(%SqlWordList,'RAND')
  #ADD(%SqlWordList,'RANGE')
  #ADD(%SqlWordList,'RANK')
  #ADD(%SqlWordList,'RAW')
  #ADD(%SqlWordList,'RAW_PARTITIONS')                       #! RAS.2001.10.22
  #ADD(%SqlWordList,'RDB$DB_KEY')                           #! RAS.2001.10.22
  #ADD(%SqlWordList,'READ')
  #ADD(%SqlWordList,'READS')
  #ADD(%SqlWordList,'READTEXT')                             #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'REAL')
  #ADD(%SqlWordList,'RECONFIGURE')                          #! RAs.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'RECORD')
  #ADD(%SqlWordList,'RECORD_VERSION')                       #! RAS.2001.10.22
  #ADD(%SqlWordList,'RECOVERY')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'RECURSIVE')
  #ADD(%SqlWordList,'REF')
  #ADD(%SqlWordList,'REFERENCES')
  #ADD(%SqlWordList,'REFERENCING')
  #ADD(%SqlWordList,'REGEXP')
  #ADD(%SqlWordList,'REGR_AVGX')
  #ADD(%SqlWordList,'REGR_AVGY')
  #ADD(%SqlWordList,'REGR_COUNT')
  #ADD(%SqlWordList,'REGR_INTERCEPT')
  #ADD(%SqlWordList,'REGR_R2')
  #ADD(%SqlWordList,'REGR_SLOPE')
  #ADD(%SqlWordList,'REGR_SXX')
  #ADD(%SqlWordList,'REGR_SXY')
  #ADD(%SqlWordList,'REGR_SYY')
  #ADD(%SqlWordList,'REJECT')                               #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'RELATE')
  #ADD(%SqlWordList,'RELATIVE')
  #ADD(%SqlWordList,'RELEASE')
  #ADD(%SqlWordList,'RELOAD')
  #ADD(%SqlWordList,'RELOAD')
  #ADD(%SqlWordList,'RELTIME')
  #ADD(%SqlWordList,'RENAME')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'REPEAT')
  #ADD(%SqlWordList,'REPEATABLE')
  #ADD(%SqlWordList,'REPLACE')
  #ADD(%SqlWordList,'REPLICATE')
  #ADD(%SqlWordList,'REPLICATION')                          #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'REQUIRE')                              #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'RESERV')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'RESERVING')                            #! RAS.2001.10.22
  #ADD(%SqlWordList,'RESET')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'RESIGNAL')
  #ADD(%SqlWordList,'RESOURCE')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'RESTORE')                              #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'RESTRICT')
  #ADD(%SqlWordList,'RESULT')
  #ADD(%SqlWordList,'RETAIN')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'RETURN')
  #ADD(%SqlWordList,'RETURNS')                              #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'RETURNED_CARDINALITY')
  #ADD(%SqlWordList,'RETURNED_LENGTH')
  #ADD(%SqlWordList,'RETURNED_OCTET_LENGTH')
  #ADD(%SqlWordList,'RETURNED_SQLSTATE')
  #ADD(%SqlWordList,'RETURNING_VALUES')                     #! RAS.2001.10.22
  #ADD(%SqlWordList,'RETURNS')
  #ADD(%SqlWordList,'REVIEW')
  #ADD(%SqlWordList,'REVOKE')
  #ADD(%SqlWordList,'REVERSE')
  #ADD(%SqlWordList,'RIGHT')
  #ADD(%SqlWordList,'RLIKE')
  #ADD(%SqlWordList,'ROLE')
  #ADD(%SqlWordList,'ROLLBACK')
  #ADD(%SqlWordList,'ROLLUP')
  #ADD(%SqlWordList,'ROOT')
  #ADD(%SqlWordList,'ROQ')                                  #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'ROUND')
  #ADD(%SqlWordList,'ROUTINE')
  #ADD(%SqlWordList,'ROUTINE_CATALOG')
  #ADD(%SqlWordList,'ROUTINE_NAME')
  #ADD(%SqlWordList,'ROUTINE_SCHEMA')
  #ADD(%SqlWordList,'ROW')
  #ADD(%SqlWordList,'ROW_COUNT')
  #ADD(%SqlWordList,'ROW_NUMBER')
  #ADD(%SqlWordList,'ROWCOUNT')                             #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'ROWGUIDCOL')                           #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'ROWID')
  #ADD(%SqlWordList,'ROWNUM')
  #ADD(%SqlWordList,'ROWTYPE')
  #ADD(%SqlWordList,'ROWS')
  #ADD(%SqlWordList,'RRN')                                  #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'RPAD')
  #ADD(%SqlWordList,'RTRIM')
  #ADD(%SqlWordList,'RULE')
  #ADD(%SqlWordList,'RUN')                                  #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'RUNTIME')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'S')                                    #! 'S'
  #ADD(%SqlWordList,'SAVE')                                 #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'SAVEPOINT')
  #ADD(%SqlWordList,'SCALE')
  #ADD(%SqlWordList,'SCAN')
  #ADD(%SqlWordList,'SCHEDULE')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'SCHEMA')
  #ADD(%SqlWordList,'SCHEMA_NAME')
  #ADD(%SqlWordList,'SCOPE')
  #ADD(%SqlWordList,'SCOPE_CATALOG')
  #ADD(%SqlWordList,'SCOPE_NAME')
  #ADD(%SqlWordList,'SCOPE_SCHEMA')
  #ADD(%SqlWordList,'SCRATCHPAD')                           #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'SCROLL')
  #ADD(%SqlWordList,'SEARCH')
  #ADD(%SqlWordList,'SEC_TO_TIME')
  #ADD(%SqlWordList,'SECOND')
  #ADD(%SqlWordList,'SECONDS')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'SECQTY')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'SECTION')
  #ADD(%SqlWordList,'SECURITY')
  #ADD(%SqlWordList,'SEGMENT')                              #! RAS.2001.10.21
  #ADD(%SqlWordList,'SELECT')
  #ADD(%SqlWordList,'SELF')
  #ADD(%SqlWordList,'SENSITIVE')
  #ADD(%SqlWordList,'SEPARATE')
  #ADD(%SqlWordList,'SEPARATOR')                            #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'SEQNO')                                #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'SEQUENCE')
  #ADD(%SqlWordList,'SERIAL')
  #ADD(%SqlWordList,'SERIALIZABLE')
  #ADD(%SqlWordList,'SERVERDB')                             #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'SERVER_NAME')
  #ADD(%SqlWordList,'SESSION')
  #ADD(%SqlWordList,'SESSION_USER')
  #ADD(%SqlWordList,'SET')
  #ADD(%SqlWordList,'SETS')
  #ADD(%SqlWordList,'SETUSER')
  #ADD(%SqlWordList,'SHADOW')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'SHARE')
  #ADD(%SqlWordList,'SHARED')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'SHELL')                                #! RAS.2001.10.22
  #ADD(%SqlWordList,'SHOW')
  #ADD(%SqlWordList,'SHUTDOWN')
  #ADD(%SqlWordList,'SIGNAL')
  #ADD(%SqlWordList,'SIMILAR')
  #ADD(%SqlWordList,'SIMPLE')
  #ADD(%SqlWordList,'SIN')
  #ADD(%SqlWordList,'SINGLE')
  #ADD(%SqlWordList,'SINGULAR')                             #! RAS.2001.10.22
  #ADD(%SqlWordList,'SINH')
  #ADD(%SqlWordList,'SIZE')
  #ADD(%SqlWordList,'SMALLDATETIME')
  #ADD(%SqlWordList,'SMALLFLOAT')
  #ADD(%SqlWordList,'SMALLINT')
  #ADD(%SqlWordList,'SMALLMONEY')
  #ADD(%SqlWordList,'SNAPSHOT')                             #! RAS.2001.10.22
  #ADD(%SqlWordList,'SOME')
  #ADD(%SqlWordList,'SONAME')
  #ADD(%SqlWordList,'SORT')
  #ADD(%SqlWordList,'SOUNDEX')
  #ADD(%SqlWordList,'SOURCE')
  #ADD(%SqlWordList,'SP_BINDRULE')
  #ADD(%SqlWordList,'SP_DBOPTION')
  #ADD(%SqlWordList,'SPACE')
  #ADD(%SqlWordList,'SPECIFIC')
  #ADD(%SqlWordList,'SPECIFICTYPE')
  #ADD(%SqlWordList,'SPECIFIC_NAME')
  #ADD(%SqlWordList,'SQL')
  #ADD(%SqlWordList,'SQLCODE')
  #ADD(%SqlWordList,'SQLERRM')
  #ADD(%SqlWordList,'SQLERROR')
  #ADD(%SqlWordList,'SQLEXCEPTION')
  #ADD(%SqlWordList,'SQLID')                                #! RAS.2002.05.28 / SAP
  #ADD(%SqlWordList,'SQLMODE')                              #! RAS.2002.05.28 / SAP
  #ADD(%SqlWordList,'SQLSTATE')
  #ADD(%SqlWordList,'SQLWARNING')
  #ADD(%SqlWordList,'SQL_AUTO_IS_NULL')                     #! RAS.2001.10.27
  #ADD(%SqlWordList,'SQL_BIG_RESULT')                       #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'SQL_BIG_SELECTS')
  #ADD(%SqlWordList,'SQL_BIG_TABLES')
  #ADD(%SqlWordList,'SQL_BUFFER_RESULT')                    #! RAS.2001.10.27
  #ADD(%SqlWordList,'SQL_CALC_FOUND_ROWS')                  #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'SQL_LOG_BIN')                          #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'SQL_LOG_OFF')
  #ADD(%SqlWordList,'SQL_LOG_UPDATE')
  #ADD(%SqlWordList,'SQL_LOW_PRIORITY_UPDATES')
  #ADD(%SqlWordList,'SQL_MAX_JOIN_SIZE')                    #! RAS.2001.10.27
  #ADD(%SqlWordList,'SQL_QUOTE_SHOW_CREATE')                #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'SQL_SAFE_UPDATES')                     #! RAS.2001.10.27
  #ADD(%SqlWordList,'SQL_SELECT_LIMIT')
  #ADD(%SqlWordList,'SQL_SLAVE_SKIP_COUNTER')               #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'SQL_SMALL_RESULT')
  #ADD(%SqlWordList,'SQL_BIG_RESULT')
  #ADD(%SqlWordList,'SQL_WARNINGS')
  #ADD(%SqlWordList,'SQRT')
  #ADD(%SqlWordList,'SSL')                                  #! RAS.2002.11.13 / MySQLv4
  #ADD(%SqlWordList,'SSP_EXPRE')                            #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'SSP_PRED')                             #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'STABILITY')                            #! RAS.2001.10.22
  #ADD(%SqlWordList,'STAMP')                                #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'STANDARD')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'START')
  #ADD(%SqlWordList,'STARTING')
  #ADD(%SqlWordList,'STARTS')                               #! RAS.2001.10.22
  #ADD(%SqlWordList,'STATE')
  #ADD(%SqlWordList,'STATEMENT')
  #ADD(%SqlWordList,'STATIC')
  #ADD(%SqlWordList,'STATISTICS')
  #ADD(%SqlWordList,'STATUS')
  #ADD(%SqlWordList,'STAY')                                 #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'STD')
  #ADD(%SqlWordList,'STDDEV')
  #ADD(%SqlWordList,'STDDEV_POP')
  #ADD(%SqlWordList,'STDDEV_SAMP')
  #ADD(%SqlWordList,'STOGROUP')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'STOP')
  #ADD(%SqlWordList,'STORES')                               #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'STORPOOL')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'STRAIGHT_JOIN')
  #ADD(%SqlWordList,'STR')
  #ADD(%SqlWordList,'STRCMP')
  #ADD(%SqlWordList,'STRING')
  #ADD(%SqlWordList,'STRIPED')                              #! RAS.2001.01.27
  #ADD(%SqlWordList,'STRUCTURE')
  #ADD(%SqlWordList,'STUFF')
  #ADD(%SqlWordList,'STYLE')
  #ADD(%SqlWordList,'SUBCLASS_ORIGIN')
  #ADD(%SqlWordList,'SUBMULTISET')                          #! RAS.2002.03.08
  #ADD(%SqlWordList,'SUBPAGES')                             #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'SUBSTR')
  #ADD(%SqlWordList,'SUBSTRING')
  #ADD(%SqlWordList,'SUBSTRING_INDEX')
  #ADD(%SqlWordList,'SUB_TYPE')                             #! RAS.2001.10.21
  #ADD(%SqlWordList,'SUBTYPE')
  #ADD(%SqlWordList,'SUCESSFULL')
  #ADD(%SqlWordList,'SUM')
  #ADD(%SqlWordList,'SUSPEND')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'SVBEGIN')                              #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'SVEND')                                #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'SYMMETRIC')
  #ADD(%SqlWordList,'SYNONYM')
  #ADD(%SqlWordList,'SYSDATE')
  #ADD(%SqlWordList,'SYSTEM')
  #ADD(%SqlWordList,'SYSTEM_USER')
  #ADD(%SqlWordList,'T')                                    #! 'T'
  #ADD(%SqlWordList,'TABLE')
  #ADD(%SqlWordList,'TABLEEXTRACT')                         #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'TABLELOAD')                            #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'TABLES')
  #ADD(%SqlWordList,'TABLESPACE')                           #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'TABLEUNLOAD')                          #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'TABLEUPDATE')                          #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'TABLE_NAME')
  #ADD(%SqlWordList,'TAIL')
  #ADD(%SqlWordList,'TAN')
  #ADD(%SqlWordList,'TANH')
  #ADD(%SqlWordList,'TEMPORARY')
  #ADD(%SqlWordList,'TERM')                                 #! RAS.2001.10.21
  #ADD(%SqlWordList,'TERMCHARSET')                          #! RAS.2002.06.28 / SAP
  #ADD(%SqlWordList,'TERMINATE')
  #ADD(%SqlWordList,'TERMINATED')
  #ADD(%SqlWordList,'TERMINATOR')                           #! RAS.2001.10.22
  #ADD(%SqlWordList,'TEST')
  #ADD(%SqlWordList,'TEXT')
  #ADD(%SqlWordList,'TEXTSIZE')                             #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'THAN')
  #ADD(%SqlWordList,'THEN')
  #ADD(%SqlWordList,'THERE')
  #ADD(%SqlWordList,'TIES')
  #ADD(%SqlWordList,'TIME')
  #ADD(%SqlWordList,'TIME_TO_SEC')
  #ADD(%SqlWordList,'TIMESPAN')
  #ADD(%SqlWordList,'TIMESTAMP')
  #ADD(%SqlWordList,'TIMESTAMPADD')
  #ADD(%SqlWordList,'TIMESTAMPDIF')
  #ADD(%SqlWordList,'TIMEZONE_HOUR')
  #ADD(%SqlWordList,'TIMEZONE_MINUTE')
  #ADD(%SqlWordList,'TINYBLOB')
  #ADD(%SqlWordList,'TINYINT')
  #ADD(%SqlWordList,'TINYTEXT')
  #ADD(%SqlWordList,'TO')
  #ADD(%SqlWordList,'TO_DAYS')
  #ADD(%SqlWordList,'TOP')                                  #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'TOP_LEVEL_COUNT')
  #ADD(%SqlWordList,'TORN')
  #ADD(%SqlWordList,'TRAILING')
  #ADD(%SqlWordList,'TRAN')                                 #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'TRANSACTION')
  #ADD(%SqlWordList,'TRANSACTION_ACTIVE')
  #ADD(%SqlWordList,'TRANSACTIONS_COMMITED')
  #ADD(%SqlWordList,'TRANSACTIONS_ROLLED_BACK')
  #ADD(%SqlWordList,'TRANSFORM')
  #ADD(%SqlWordList,'TRANSFORMS')
  #ADD(%SqlWordList,'TRANSLATE')
  #ADD(%SqlWordList,'TRANSLATION')
  #ADD(%SqlWordList,'TREAT')
  #ADD(%SqlWordList,'TRIGGER')
  #ADD(%SqlWordList,'TRIGGER_CATALOG')
  #ADD(%SqlWordList,'TRIGGER_SCHEMA')
  #ADD(%SqlWordList,'TRIGGER_NAME')
  #ADD(%SqlWordList,'TRIGGERS')
  #ADD(%SqlWordList,'TRIM')
  #ADD(%SqlWordList,'TRUE')
  #ADD(%SqlWordList,'TRUNC')
  #ADD(%SqlWordList,'TRUNCATE')                             #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'TS')                                   #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'TSEQUAL')                              #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'TYPE')
  #ADD(%SqlWordList,'U')                                    #! 'U'
  #ADD(%SqlWordList,'UCASE')
  #ADD(%SqlWordList,'UID')
  #ADD(%SqlWordList,'UINT')
  #ADD(%SqlWordList,'UNBOUNDED')
  #ADD(%SqlWordList,'UNCOMMITED')
  #ADD(%SqlWordList,'UNDER')
  #ADD(%SqlWordList,'UNDO')                                 #! RAS.2002.03.08
  #ADD(%SqlWordList,'UNION')
  #ADD(%SqlWordList,'UNIQUE')
  #ADD(%SqlWordList,'UNIX_TIMESTAMP')
  #ADD(%SqlWordList,'UNKNOWN')
  #ADD(%SqlWordList,'UNLOCK')
  #ADD(%SqlWordList,'UNNAMED')
  #ADD(%SqlWordList,'UNNEST')
  #ADD(%SqlWordList,'UNSIGNED')
  #ADD(%SqlWordList,'UNTIL')                                #! LMS.2001.12.30 / PSQL
  #ADD(%SqlWordList,'UPDATE')
  #ADD(%SqlWordList,'UPDATETEXT')                           #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'UPPER')
  #ADD(%SqlWordList,'USAGE')
  #ADD(%SqlWordList,'USE')
  #ADD(%SqlWordList,'USER')
  #ADD(%SqlWordList,'USERENV')
  #ADD(%SqlWordList,'USER_DEFINED_TYPE_CATALOG')
  #ADD(%SqlWordList,'USER_DEFINED_TYPE_NAME')
  #ADD(%SqlWordList,'USER_DEFINED_TYPE_SCHEMA')
  #ADD(%SqlWordList,'USING')
  #ADD(%SqlWordList,'V')                                    #! 'V'
  #ADD(%SqlWordList,'VALIDATE')
  #ADD(%SqlWordList,'VALIDPROC')                            #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'VALUE')
  #ADD(%SqlWordList,'VALUES')
  #ADD(%SqlWordList,'VAR_POP')
  #ADD(%SqlWordList,'VAR_SAMP')
  #ADD(%SqlWordList,'VARBINARY')
  #ADD(%SqlWordList,'VARCHAR')
  #ADD(%SqlWordList,'VARCHAR2')
  #ADD(%SqlWordList,'VARCHARACTER')
  #ADD(%SqlWordList,'VARIABLE')
  #ADD(%SqlWordList,'VARIABLES')
  #ADD(%SqlWordList,'VARIANCE')
  #ADD(%SqlWordList,'VARIANT')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'VARYING')
  #ADD(%SqlWordList,'VCAT')                                 #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'VERBOSE')                              #! RAS.2002.11.13 / PostgreSQLv7
  #ADD(%SqlWordList,'VERSION')
  #ADD(%SqlWordList,'VIEW')
  #ADD(%SqlWordList,'VIRTUAL')
  #ADD(%SqlWordList,'VISIBLE')
  #ADD(%SqlWordList,'VOLUMES')                              #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'W')                                    #! 'W'
  #ADD(%SqlWordList,'WAIT')
  #ADD(%SqlWordList,'WAITFOR')                              #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'WARNINGS')
  #ADD(%SqlWordList,'WEEK')
  #ADD(%SqlWordList,'WEEKDAY')
  #ADD(%SqlWordList,'WHEN')
  #ADD(%SqlWordList,'WHENEVER')
  #ADD(%SqlWordList,'WHERE')
  #ADD(%SqlWordList,'WHILE')
  #ADD(%SqlWordList,'WIDTH_BUCKET')
  #ADD(%SqlWordList,'WINDOW')
  #ADD(%SqlWordList,'WITH')
  #ADD(%SqlWordList,'WITHIN')
  #ADD(%SqlWordList,'WITHOUT')
  #ADD(%SqlWordList,'WLM')                                  #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'WORK')
  #ADD(%SqlWordList,'WRITE')
  #ADD(%SqlWordList,'WRITETEXT')                            #! RAS.2002.11.13 / SQL2000
  #ADD(%SqlWordList,'X')                                    #! 'X'
  #ADD(%SqlWordList,'Y')                                    #! 'Y'
  #ADD(%SqlWordList,'YEAR')
  #ADD(%SqlWordList,'YEAR_MONTH')
  #ADD(%SqlWordList,'YEARDAY')                              #! RAS.2001.10.22
  #ADD(%SqlWordList,'YEARS')                                #! RAS.2002.11.13 / DB2v7
  #ADD(%SqlWordList,'YIELDS')
  #ADD(%SqlWordList,'Z')                                    #! 'Z'
  #ADD(%SqlWordList,'ZEROFILL')
  #ADD(%SqlWordList,'ZONE')
  #SET(%SqlWordCount,ITEMS(%SqlWordList))                   #! How many are there?
#GROUP(%SqlReservedWordsEnd)

#!--------------------------------------------------------------------!
#! 2001.01.21.SUN - Roberto Artigas Jr          IMPORTANT PLEASE READ !
#!--------------------------------------------------------------------!
#! This group contains the code necessary to build a searchable list  !
#! of Clarion reserved words. This is used to make sure field, key,   !
#! and table names are not in conflict with reserved words.           !
#!--------------------------------------------------------------------!
#! ALSO: I am a realist. I can pretty much say with a great amount of !
#! certainty, that once having seen this list, most individuals are   !
#! not going to type in their own to achieve the same functionality.  !
#! If you use this list at least have the courtesy of giving credit   !
#! to Roberto Artigas Jr for having typed all of this in. Leave this  !
#! documentation block intact and give credit where credit is due.    !
#!--------------------------------------------------------------------!
#GROUP(%ClarionReservedWords)
  #DECLARE(%ClarionWordCount)
  #DECLARE(%ClarionWordItem)
  #DECLARE(%ClarionWordList),MULTI,UNIQUE
  #ADD(%ClarionWordList,'PROGRAM')                          #! Program Format
  #ADD(%ClarionWordList,'MEMBER')
  #ADD(%ClarionWordList,'MAP')
  #ADD(%ClarionWordList,'MODULE')
  #ADD(%ClarionWordList,'PROCEDURE')
  #ADD(%ClarionWordList,'CODE')
  #ADD(%ClarionWordList,'DATA')
  #ADD(%ClarionWordList,'ROUTINE')
  #ADD(%ClarionWordList,'END')
  #ADD(%ClarionWordList,'C')                                #! Prototype Attributes
  #ADD(%ClarionWordList,'PASCAL')
  #ADD(%ClarionWordList,'DLL')
  #ADD(%ClarionWordList,'NAME')
  #ADD(%ClarionWordList,'PRIVATE')
  #ADD(%ClarionWordList,'PROC')
  #ADD(%ClarionWordList,'PROTECTED')
  #ADD(%ClarionWordList,'RAW')
  #ADD(%ClarionWordList,'REPLACE')
  #ADD(%ClarionWordList,'TYPE')
  #ADD(%ClarionWordList,'VIRTUAL')
  #ADD(%ClarionWordList,'DERIVED')
  #ADD(%ClarionWordList,'_PROC')
  #ADD(%ClarionWordList,'_PROC1')
  #ADD(%ClarionWordList,'_PROC2')
  #ADD(%ClarionWordList,'_PROC3')
  #ADD(%ClarionWordList,'ACCEPT')                           #! Compiler directives
  #ADD(%ClarionWordList,'BEGIN')
  #ADD(%ClarionWordList,'COMPILE')
  #ADD(%ClarionWordList,'INCLUDE')
  #ADD(%ClarionWordList,'EQUATE')
  #ADD(%ClarionWordList,'ITEMIZE')
  #ADD(%ClarionWordList,'OMIT')
  #ADD(%ClarionWordList,'SECTION')
  #ADD(%ClarionWordList,'SIZE')
  #ADD(%ClarionWordList,'ONCE')
  #ADD(%ClarionWordList,'BYTE')                             #! Simple data types
  #ADD(%ClarionWordList,'SHORT')
  #ADD(%ClarionWordList,'USHORT')
  #ADD(%ClarionWordList,'LONG')
  #ADD(%ClarionWordList,'ULONG')
  #ADD(%ClarionWordList,'SIGNED')
  #ADD(%ClarionWordList,'UNSIGNED')
  #ADD(%ClarionWordList,'SREAL')
  #ADD(%ClarionWordList,'REAL')
  #ADD(%ClarionWordList,'BFLOAT4')
  #ADD(%ClarionWordList,'BFLOAT8')
  #ADD(%ClarionWordList,'DECIMAL')
  #ADD(%ClarionWordList,'PDECIMAL')
  #ADD(%ClarionWordList,'STRING')
  #ADD(%ClarionWordList,'CSTRING')
  #ADD(%ClarionWordList,'PSTRING')
  #ADD(%ClarionWordList,'DATE')
  #ADD(%ClarionWordList,'TIME')
  #ADD(%ClarionWordList,'ASTRING')
  #ADD(%ClarionWordList,'BSTRING')
  #ADD(%ClarionWordList,'ANY')                              #! Special data types
  #ADD(%ClarionWordList,'LIKE')
  #ADD(%ClarionWordList,'NEW')                              #! Memory allocation
  #ADD(%ClarionWordList,'DISPOSE')
  #ADD(%ClarionWordList,'GROUP')                            #! Complex data structures
  #ADD(%ClarionWordList,'CLASS')
  #ADD(%ClarionWordList,'FILE')                             #! File Structures
  #ADD(%ClarionWordList,'INDEX')
  #ADD(%ClarionWordList,'KEY')
  #ADD(%ClarionWordList,'MEMO')
  #ADD(%ClarionWordList,'BLOB')
  #ADD(%ClarionWordList,'RECORD')
  #ADD(%ClarionWordList,'VIEW')                             #! View structures
  #ADD(%ClarionWordList,'PROJECT')
  #ADD(%ClarionWordList,'JOIN')
  #ADD(%ClarionWordList,'QUEUE')                            #! Queue structures
  #ADD(%ClarionWordList,'AUTO')                             #! Variable/Entity Attributes
  #ADD(%ClarionWordList,'BINARY')
  #ADD(%ClarionWordList,'BINDABLE')
  #ADD(%ClarionWordList,'CREATE')
  #ADD(%ClarionWordList,'DIM')
  #ADD(%ClarionWordList,'DLL')
  #ADD(%ClarionWordList,'DRIVER')
  #ADD(%ClarionWordList,'DUP')
  #ADD(%ClarionWordList,'ENCRYPT')
  #ADD(%ClarionWordList,'EXTERNAL')
  #ADD(%ClarionWordList,'FILTER')
  #ADD(%ClarionWordList,'INNER')
  #ADD(%ClarionWordList,'LINK')
  #ADD(%ClarionWordList,'MODULE')
  #ADD(%ClarionWordList,'NAME')
  #ADD(%ClarionWordList,'NOCASE')
  #ADD(%ClarionWordList,'OEM')
  #ADD(%ClarionWordList,'OPT')
  #ADD(%ClarionWordList,'ORDER')
  #ADD(%ClarionWordList,'OVER')
  #ADD(%ClarionWordList,'OWNER')
  #ADD(%ClarionWordList,'PRE')
  #ADD(%ClarionWordList,'PRIMARY')
  #ADD(%ClarionWordList,'PRIVATE')
  #ADD(%ClarionWordList,'PROTECTED')
  #ADD(%ClarionWordList,'RECLAIM')
  #ADD(%ClarionWordList,'STATIC')
  #ADD(%ClarionWordList,'THREAD')
  #ADD(%ClarionWordList,'TYPE')
  #ADD(%ClarionWordList,'APPLICATION')                      #! Window structures
  #ADD(%ClarionWordList,'WINDOW')
  #ADD(%ClarionWordList,'MENUBAR')
  #ADD(%ClarionWordList,'TOOLBAR')
  #ADD(%ClarionWordList,'REPORT')                           #! Report structures
  #ADD(%ClarionWordList,'BREAK')
  #ADD(%ClarionWordList,'DETAIL')
  #ADD(%ClarionWordList,'FOOTER')
  #ADD(%ClarionWordList,'FORM')
  #ADD(%ClarionWordList,'HEADER')
  #ADD(%ClarionWordList,'BOX')                              #! Control declarations
  #ADD(%ClarionWordList,'BUTTON')
  #ADD(%ClarionWordList,'CHECK')
  #ADD(%ClarionWordList,'COMBO')
  #ADD(%ClarionWordList,'ELIPSE')
  #ADD(%ClarionWordList,'ENTRY')
  #ADD(%ClarionWordList,'GROUP')
  #ADD(%ClarionWordList,'IMAGE')
  #ADD(%ClarionWordList,'ITEM')
  #ADD(%ClarionWordList,'LINE')
  #ADD(%ClarionWordList,'LIST')
  #ADD(%ClarionWordList,'MENU')
  #ADD(%ClarionWordList,'OLE')
  #ADD(%ClarionWordList,'OPTION')
  #ADD(%ClarionWordList,'PANEL')
  #ADD(%ClarionWordList,'PROMPT')
  #ADD(%ClarionWordList,'PROGRESS')
  #ADD(%ClarionWordList,'RADIO')
  #ADD(%ClarionWordList,'REGION')
  #ADD(%ClarionWordList,'SHEET')
  #ADD(%ClarionWordList,'SPIN')
  #ADD(%ClarionWordList,'STRING')
  #ADD(%ClarionWordList,'TAB')
  #ADD(%ClarionWordList,'TEXT')
  #ADD(%ClarionWordList,'VBX')
  #ADD(%ClarionWordList,'ABSOLUTE')                         #! Window/Report Attributes
  #ADD(%ClarionWordList,'ALONE')
  #ADD(%ClarionWordList,'ALRT')
  #ADD(%ClarionWordList,'ANGLE')
  #ADD(%ClarionWordList,'AT')
  #ADD(%ClarionWordList,'AUTO')
  #ADD(%ClarionWordList,'AUTOSIZE')
  #ADD(%ClarionWordList,'AVE')
  #ADD(%ClarionWordList,'BEVEL')
  #ADD(%ClarionWordList,'BOXED')
  #ADD(%ClarionWordList,'CAP')
  #ADD(%ClarionWordList,'UPR')
  #ADD(%ClarionWordList,'CENTER')
  #ADD(%ClarionWordList,'CENTERED')
  #ADD(%ClarionWordList,'CHECK')
  #ADD(%ClarionWordList,'CLASS')
  #ADD(%ClarionWordList,'CLIP')
  #ADD(%ClarionWordList,'CNT')
  #ADD(%ClarionWordList,'COLOR')
  #ADD(%ClarionWordList,'COLUMN')
  #ADD(%ClarionWordList,'COMPATABILITY')
  #ADD(%ClarionWordList,'CREATE')
  #ADD(%ClarionWordList,'CURSOR')
  #ADD(%ClarionWordList,'DEFAULT')
  #ADD(%ClarionWordList,'DELAY')
  #ADD(%ClarionWordList,'DISABLE')
  #ADD(%ClarionWordList,'DOCK')
  #ADD(%ClarionWordList,'DOCKED')
  #ADD(%ClarionWordList,'DOCUMENT')
  #ADD(%ClarionWordList,'DOUBLE')
  #ADD(%ClarionWordList,'NOFRAME')
  #ADD(%ClarionWordList,'RESIZE')
  #ADD(%ClarionWordList,'DRAGID')
  #ADD(%ClarionWordList,'DROP')
  #ADD(%ClarionWordList,'DROPID')
  #ADD(%ClarionWordList,'FILL')
  #ADD(%ClarionWordList,'FIRST')
  #ADD(%ClarionWordList,'LAST')
  #ADD(%ClarionWordList,'FLAT')
  #ADD(%ClarionWordList,'FONT')
  #ADD(%ClarionWordList,'FORMAT')
  #ADD(%ClarionWordList,'FROM')
  #ADD(%ClarionWordList,'FULL')
  #ADD(%ClarionWordList,'GRAY')
  #ADD(%ClarionWordList,'GRID')
  #ADD(%ClarionWordList,'HIDE')
  #ADD(%ClarionWordList,'HELP')
  #ADD(%ClarionWordList,'HSCROLL')
  #ADD(%ClarionWordList,'VSCROLL')
  #ADD(%ClarionWordList,'HVSCROLL')
  #ADD(%ClarionWordList,'ICON')
  #ADD(%ClarionWordList,'ICONIZE')
  #ADD(%ClarionWordList,'IMM')
  #ADD(%ClarionWordList,'INS')
  #ADD(%ClarionWordList,'OVR')
  #ADD(%ClarionWordList,'JOIN')
  #ADD(%ClarionWordList,'KEY')
  #ADD(%ClarionWordList,'LANDSCAPE')
  #ADD(%ClarionWordList,'LEFT')
  #ADD(%ClarionWordList,'RIGHT')
  #ADD(%ClarionWordList,'ABOVE')
  #ADD(%ClarionWordList,'BELOW')
  #ADD(%ClarionWordList,'LEFT')
  #ADD(%ClarionWordList,'RIGHT')
  #ADD(%ClarionWordList,'CENTER')
  #ADD(%ClarionWordList,'DECIMAL')
  #ADD(%ClarionWordList,'LINEWIDTH')
  #ADD(%ClarionWordList,'LINK')
  #ADD(%ClarionWordList,'MARK')
  #ADD(%ClarionWordList,'MASK')
  #ADD(%ClarionWordList,'MAX')
  #ADD(%ClarionWordList,'MAXIMIZE')
  #ADD(%ClarionWordList,'MDI')
  #ADD(%ClarionWordList,'META')
  #ADD(%ClarionWordList,'MIN')
  #ADD(%ClarionWordList,'MODAL')
  #ADD(%ClarionWordList,'MSG')
  #ADD(%ClarionWordList,'NOBAR')
  #ADD(%ClarionWordList,'NOCASE')
  #ADD(%ClarionWordList,'NOMERGE')
  #ADD(%ClarionWordList,'NOSHEET')
  #ADD(%ClarionWordList,'OPEN')
  #ADD(%ClarionWordList,'PAGE')
  #ADD(%ClarionWordList,'PAGEAFTER')
  #ADD(%ClarionWordList,'PAGEBEFORE')
  #ADD(%ClarionWordList,'PAGENO')
  #ADD(%ClarionWordList,'PALETTE')
  #ADD(%ClarionWordList,'PAPER')
  #ADD(%ClarionWordList,'PASSWORD')
  #ADD(%ClarionWordList,'PREVIEW')
  #ADD(%ClarionWordList,'RANGE')
  #ADD(%ClarionWordList,'READONLY')
  #ADD(%ClarionWordList,'REPEAT')
  #ADD(%ClarionWordList,'REQ')
  #ADD(%ClarionWordList,'RESET')
  #ADD(%ClarionWordList,'RESIZE')
  #ADD(%ClarionWordList,'RIGHT')
  #ADD(%ClarionWordList,'ROUND')
  #ADD(%ClarionWordList,'SCROLL')
  #ADD(%ClarionWordList,'SEPARATOR')
  #ADD(%ClarionWordList,'SINGLE')
  #ADD(%ClarionWordList,'SKIP')
  #ADD(%ClarionWordList,'SPREAD')
  #ADD(%ClarionWordList,'STATUS')
  #ADD(%ClarionWordList,'STD')
  #ADD(%ClarionWordList,'STEP')
  #ADD(%ClarionWordList,'STRETCH')
  #ADD(%ClarionWordList,'SUM')
  #ADD(%ClarionWordList,'SYSTEM')
  #ADD(%ClarionWordList,'TALLY')
  #ADD(%ClarionWordList,'THOUS')
  #ADD(%ClarionWordList,'MM')
  #ADD(%ClarionWordList,'POINTS')
  #ADD(%ClarionWordList,'TILED')
  #ADD(%ClarionWordList,'TIMER')
  #ADD(%ClarionWordList,'TIP')
  #ADD(%ClarionWordList,'TOOLBOX')
  #ADD(%ClarionWordList,'TRN')
  #ADD(%ClarionWordList,'UP')
  #ADD(%ClarionWordList,'DOWN')
  #ADD(%ClarionWordList,'USE')
  #ADD(%ClarionWordList,'VALUE')
  #ADD(%ClarionWordList,'VCR')
  #ADD(%ClarionWordList,'WALLPAPER')
  #ADD(%ClarionWordList,'WITHNEXT')
  #ADD(%ClarionWordList,'WITHPRIOR')
  #ADD(%ClarionWordList,'WIZARD')
  #ADD(%ClarionWordList,'ZOOM')
  #ADD(%ClarionWordList,'BIND')                             #! Expresion evaluation
  #ADD(%ClarionWordList,'EVALUATE')
  #ADD(%ClarionWordList,'POPBIND')
  #ADD(%ClarionWordList,'PUSHBIND')
  #ADD(%ClarionWordList,'UNBIND')
  #ADD(%ClarionWordList,'CLEAR')                            #! Assignments
  #ADD(%ClarionWordList,'ACCEPT')                           #! Control structures
  #ADD(%ClarionWordList,'CASE')
  #ADD(%ClarionWordList,'EXECUTE')
  #ADD(%ClarionWordList,'IF')
  #ADD(%ClarionWordList,'LOOP')
  #ADD(%ClarionWordList,'BREAK')                            #! Execution control
  #ADD(%ClarionWordList,'CYCLE')
  #ADD(%ClarionWordList,'DO')
  #ADD(%ClarionWordList,'EXIT')
  #ADD(%ClarionWordList,'GOTO')
  #ADD(%ClarionWordList,'RETURN')
  #ADD(%ClarionWordList,'ABS')                              #! Built in procedures
  #ADD(%ClarionWordList,'ACCEPTED')
  #ADD(%ClarionWordList,'ACOS')
  #ADD(%ClarionWordList,'ADD')
  #ADD(%ClarionWordList,'ADDRESS')
  #ADD(%ClarionWordList,'AGE')
  #ADD(%ClarionWordList,'ALERT')
  #ADD(%ClarionWordList,'ALIAS')
  #ADD(%ClarionWordList,'ALL')
  #ADD(%ClarionWordList,'APPEND')
  #ADD(%ClarionWordList,'ARC')
  #ADD(%ClarionWordList,'ASK')
  #ADD(%ClarionWordList,'ASIN')
  #ADD(%ClarionWordList,'ATAN')
  #ADD(%ClarionWordList,'BAND')
  #ADD(%ClarionWordList,'BEEP')
  #ADD(%ClarionWordList,'BLANK')
  #ADD(%ClarionWordList,'BOR')
  #ADD(%ClarionWordList,'BOX')
  #ADD(%ClarionWordList,'BSHIFT')
  #ADD(%ClarionWordList,'BUFFER')
  #ADD(%ClarionWordList,'BUILD')
  #ADD(%ClarionWordList,'BXOR')
  #ADD(%ClarionWordList,'BYTES')
  #ADD(%ClarionWordList,'CALL')
  #ADD(%ClarionWordList,'CENTER')
  #ADD(%ClarionWordList,'CHAIN')
  #ADD(%ClarionWordList,'CHANGE')
  #ADD(%ClarionWordList,'CHANGES')
  #ADD(%ClarionWordList,'CHOICE')
  #ADD(%ClarionWordList,'CHOOSE')
  #ADD(%ClarionWordList,'CHORD')
  #ADD(%ClarionWordList,'CHR')
  #ADD(%ClarionWordList,'CLIP')
  #ADD(%ClarionWordList,'CLIPBOARD')
  #ADD(%ClarionWordList,'CLOCK')
  #ADD(%ClarionWordList,'CLOSE')
  #ADD(%ClarionWordList,'COLORDIALOG')
  #ADD(%ClarionWordList,'COMMAND')
  #ADD(%ClarionWordList,'COMMIT')
  #ADD(%ClarionWordList,'CONTENTS')
  #ADD(%ClarionWordList,'CONVERTANSITOEOM')
  #ADD(%ClarionWordList,'CONVERTEOMTOANSI')
  #ADD(%ClarionWordList,'COPY')
  #ADD(%ClarionWordList,'COS')
  #ADD(%ClarionWordList,'CREATE')
  #ADD(%ClarionWordList,'CREATE')
  #ADD(%ClarionWordList,'DATE')
  #ADD(%ClarionWordList,'DAY')
  #ADD(%ClarionWordList,'DEFORMAT')
  #ADD(%ClarionWordList,'DELETE')
  #ADD(%ClarionWordList,'DESTROY')
  #ADD(%ClarionWordList,'DIRECTORY')
  #ADD(%ClarionWordList,'DISABLE')
  #ADD(%ClarionWordList,'DISPLAY')
  #ADD(%ClarionWordList,'DRAGID')
  #ADD(%ClarionWordList,'DROPID')
  #ADD(%ClarionWordList,'DUPLICATE')
  #ADD(%ClarionWordList,'ELLIPSE')
  #ADD(%ClarionWordList,'EMPTY')
  #ADD(%ClarionWordList,'ENABLE')
  #ADD(%ClarionWordList,'ENDPAGE')
  #ADD(%ClarionWordList,'ERASE')
  #ADD(%ClarionWordList,'ERROR')
  #ADD(%ClarionWordList,'ERRORCODE')
  #ADD(%ClarionWordList,'ERRORFILE')
  #ADD(%ClarionWordList,'EVENTS')
  #ADD(%ClarionWordList,'EXISTS')
  #ADD(%ClarionWordList,'FIELD')
  #ADD(%ClarionWordList,'FILEDIALOG')
  #ADD(%ClarionWordList,'FILEERROR')
  #ADD(%ClarionWordList,'FILEERRORCODE')
  #ADD(%ClarionWordList,'FIRSTFIELD')
  #ADD(%ClarionWordList,'FLUSH')
  #ADD(%ClarionWordList,'FOCUS')
  #ADD(%ClarionWordList,'FONTDIALOG')
  #ADD(%ClarionWordList,'FORMAT')
  #ADD(%ClarionWordList,'FREE')
  #ADD(%ClarionWordList,'GET')
  #ADD(%ClarionWordList,'GETFONT')
  #ADD(%ClarionWordList,'GETINI')
  #ADD(%ClarionWordList,'GETPOSITION')
  #ADD(%ClarionWordList,'HALT')
  #ADD(%ClarionWordList,'HELP')
  #ADD(%ClarionWordList,'HIDE')
  #ADD(%ClarionWordList,'HOLD')
  #ADD(%ClarionWordList,'IDLE')
  #ADD(%ClarionWordList,'IMAGE')
  #ADD(%ClarionWordList,'INCOMPLETE')
  #ADD(%ClarionWordList,'INLIST')
  #ADD(%ClarionWordList,'INRANGE')
  #ADD(%ClarionWordList,'INSTRING')
  #ADD(%ClarionWordList,'INT')
  #ADD(%ClarionWordList,'ISALPHA')
  #ADD(%ClarionWordList,'ISLOWER')
  #ADD(%ClarionWordList,'ISSTRING')
  #ADD(%ClarionWordList,'ISUPPER')
  #ADD(%ClarionWordList,'KEYBOARD')
  #ADD(%ClarionWordList,'KEYCHAR')
  #ADD(%ClarionWordList,'KEYCODE')
  #ADD(%ClarionWordList,'KEYSTATE')
  #ADD(%ClarionWordList,'LASTFIELD')
  #ADD(%ClarionWordList,'LEFT')
  #ADD(%ClarionWordList,'LEN')
  #ADD(%ClarionWordList,'LINE')
  #ADD(%ClarionWordList,'LOCALE')
  #ADD(%ClarionWordList,'LOCK')
  #ADD(%ClarionWordList,'LOCKTHREAD')
  #ADD(%ClarionWordList,'LOG10')
  #ADD(%ClarionWordList,'LOGE')
  #ADD(%ClarionWordList,'LOGOUT')
  #ADD(%ClarionWordList,'LONGPATH')
  #ADD(%ClarionWordList,'LOWER')
  #ADD(%ClarionWordList,'MATCH')
  #ADD(%ClarionWordList,'MAXIMUM')
  #ADD(%ClarionWordList,'MESSAGE')
  #ADD(%ClarionWordList,'MONTH')
  #ADD(%ClarionWordList,'MOUSEX')
  #ADD(%ClarionWordList,'MOUSEY')
  #ADD(%ClarionWordList,'NAME')
  #ADD(%ClarionWordList,'NEXT')
  #ADD(%ClarionWordList,'NOMEMO')
  #ADD(%ClarionWordList,'NULL')
  #ADD(%ClarionWordList,'NUMERIC')
  #ADD(%ClarionWordList,'OMITTED')
  #ADD(%ClarionWordList,'OPEN')
  #ADD(%ClarionWordList,'PACK')
  #ADD(%ClarionWordList,'PATH')
  #ADD(%ClarionWordList,'PEEK')
  #ADD(%ClarionWordList,'PENCOLOR')
  #ADD(%ClarionWordList,'PENSTYLE')
  #ADD(%ClarionWordList,'PENWIDTH')
  #ADD(%ClarionWordList,'PIE')
  #ADD(%ClarionWordList,'POINTER')
  #ADD(%ClarionWordList,'POKE')
  #ADD(%ClarionWordList,'POLYGON')
  #ADD(%ClarionWordList,'POPUP')
  #ADD(%ClarionWordList,'POSITION')
  #ADD(%ClarionWordList,'POST')
  #ADD(%ClarionWordList,'PRESS')
  #ADD(%ClarionWordList,'PRESSKEY')
  #ADD(%ClarionWordList,'PREVIOUS')
  #ADD(%ClarionWordList,'PRINT')
  #ADD(%ClarionWordList,'PRINTERDIALOG')
  #ADD(%ClarionWordList,'PUT')
  #ADD(%ClarionWordList,'PUTINI')
  #ADD(%ClarionWordList,'RANDOM')
  #ADD(%ClarionWordList,'RECORDS')
  #ADD(%ClarionWordList,'REGISTER')
  #ADD(%ClarionWordList,'REJECTCODE')
  #ADD(%ClarionWordList,'REGET')
  #ADD(%ClarionWordList,'RELEASE')
  #ADD(%ClarionWordList,'REMOVE')
  #ADD(%ClarionWordList,'RENAME')
  #ADD(%ClarionWordList,'RESET')
  #ADD(%ClarionWordList,'RIGHT')
  #ADD(%ClarionWordList,'ROLLBACK')
  #ADD(%ClarionWordList,'ROUND')
  #ADD(%ClarionWordList,'ROUNDBOX')
  #ADD(%ClarionWordList,'RUN')
  #ADD(%ClarionWordList,'RUNCODE')
  #ADD(%ClarionWordList,'SELECT')
  #ADD(%ClarionWordList,'SELECTED')
  #ADD(%ClarionWordList,'SEND')
  #ADD(%ClarionWordList,'SET')
  #ADD(%ClarionWordList,'SET3DLOOK')
  #ADD(%ClarionWordList,'SETCLIPBOARD')
  #ADD(%ClarionWordList,'SETCLOCK')
  #ADD(%ClarionWordList,'SETCOMMAND')
  #ADD(%ClarionWordList,'SETCURSOR')
  #ADD(%ClarionWordList,'SETDROPID')
  #ADD(%ClarionWordList,'SETFONT')
  #ADD(%ClarionWordList,'SETKEYCHAR')
  #ADD(%ClarionWordList,'SETKEYCODE')
  #ADD(%ClarionWordList,'SETNONULL')
  #ADD(%ClarionWordList,'SETNULL')
  #ADD(%ClarionWordList,'SETPATH')
  #ADD(%ClarionWordList,'SETPENCOLOR')
  #ADD(%ClarionWordList,'SETPENSTYLE')
  #ADD(%ClarionWordList,'SETPENWIDTH')
  #ADD(%ClarionWordList,'SETPOSITION')
  #ADD(%ClarionWordList,'SETTARGET')
  #ADD(%ClarionWordList,'SETTODAY')
  #ADD(%ClarionWordList,'SHORTPATH')
  #ADD(%ClarionWordList,'SHOW')
  #ADD(%ClarionWordList,'SHUTDOWN')
  #ADD(%ClarionWordList,'SIN')
  #ADD(%ClarionWordList,'SKIP')
  #ADD(%ClarionWordList,'SORT')
  #ADD(%ClarionWordList,'SQRT')
  #ADD(%ClarionWordList,'START')
  #ADD(%ClarionWordList,'STATUS')
  #ADD(%ClarionWordList,'STOP')
  #ADD(%ClarionWordList,'STREAM')
  #ADD(%ClarionWordList,'SUB')
  #ADD(%ClarionWordList,'TAN')
  #ADD(%ClarionWordList,'THREAD')
  #ADD(%ClarionWordList,'THREADLOCKED')
  #ADD(%ClarionWordList,'TODAY')
  #ADD(%ClarionWordList,'TYPE')
  #ADD(%ClarionWordList,'UNHIDE')
  #ADD(%ClarionWordList,'UNLOAD')
  #ADD(%ClarionWordList,'UNLOCK')
  #ADD(%ClarionWordList,'UNLOCKTHREAD')
  #ADD(%ClarionWordList,'UNREGISTER')
  #ADD(%ClarionWordList,'UPDATE')
  #ADD(%ClarionWordList,'UPPER')
  #ADD(%ClarionWordList,'VAL')
  #ADD(%ClarionWordList,'WATCH')
  #ADD(%ClarionWordList,'WHAT')
  #ADD(%ClarionWordList,'WHERE')
  #ADD(%ClarionWordList,'WHO')
  #ADD(%ClarionWordList,'YEAR')
  #ADD(%ClarionWordList,'YIELD')
  #ADD(%ClarionWordList,'DDEACKNOWLEDGE')                   #! DDE procedures
  #ADD(%ClarionWordList,'DDEAPP')
  #ADD(%ClarionWordList,'DDECHANNEL')
  #ADD(%ClarionWordList,'DDECLIENT')
  #ADD(%ClarionWordList,'DDECLOSE')
  #ADD(%ClarionWordList,'DDEEXECUTE')
  #ADD(%ClarionWordList,'DDEITEM')
  #ADD(%ClarionWordList,'DDEPOKE')
  #ADD(%ClarionWordList,'DDEQUERY')
  #ADD(%ClarionWordList,'DDEREAD')
  #ADD(%ClarionWordList,'DDESERVER')
  #ADD(%ClarionWordList,'DDETOPIC')
  #ADD(%ClarionWordList,'DDEVALUE')
  #ADD(%ClarionWordList,'DDEWRITE')
  #ADD(%ClarionWordList,'OLEDIRECTORY')                     #! OLE
  #ADD(%ClarionWordList,'OCXREGISTERPROPEDIT')              #! OCX
  #ADD(%ClarionWordList,'OCXREGISTERPROPCHANGE')
  #ADD(%ClarionWordList,'OCXREGISTEREVENTPROC')
  #ADD(%ClarionWordList,'OCXUNREGISTERPROPEDIT')
  #ADD(%ClarionWordList,'OCXUNREGISTERPROPCHANGE')
  #ADD(%ClarionWordList,'OCXUNREGISTEREVENTPROC')
  #ADD(%ClarionWordList,'OCXGETPARAMCOUNT')
  #ADD(%ClarionWordList,'OCXGETPARAM')
  #ADD(%ClarionWordList,'OCXSETPARAM')
  #ADD(%ClarionWordList,'OCXLOADIMAGE')
  #ADD(%ClarionWordList,'BOF')                              #! Legacy statements
  #ADD(%ClarionWordList,'EOF')
  #ADD(%ClarionWordList,'FUNCTION')
  #ADD(%ClarionWordList,'POINTER')
  #ADD(%ClarionWordList,'SHARE')
  #ADD(%ClarionWordList,'#TEMPLATE')                        #! Template Sections
  #ADD(%ClarionWordList,'#SYSTEM')
  #ADD(%ClarionWordList,'#APPLICATION')
  #ADD(%ClarionWordList,'#PROGRAM')
  #ADD(%ClarionWordList,'#MODULE')
  #ADD(%ClarionWordList,'#PROCEDURE')
  #ADD(%ClarionWordList,'#GROUP')
  #ADD(%ClarionWordList,'#UTILITY')
  #ADD(%ClarionWordList,'#CODE')
  #ADD(%ClarionWordList,'#CONTROL')
  #ADD(%ClarionWordList,'#EXTENSION')
  #ADD(%ClarionWordList,'#EMBED')                           #! Embed points
  #ADD(%ClarionWordList,'#AT')
  #ADD(%ClarionWordList,'#ENDAT')
  #ADD(%ClarionWordList,'#PRIORITY')
  #ADD(%ClarionWordList,'#ATSTART')
  #ADD(%ClarionWordList,'#ATEND')
  #ADD(%ClarionWordList,'#CONTEXT')
  #ADD(%ClarionWordList,'#ENDCONTEXT')
  #ADD(%ClarionWordList,'#EMPTYEMBED')
  #ADD(%ClarionWordList,'#POSTEMBED')
  #ADD(%ClarionWordList,'#PREEMBED')
  #ADD(%ClarionWordList,'#WHERE')                           #! Section constraints
  #ADD(%ClarionWordList,'#RESTRICT')
  #ADD(%ClarionWordList,'#ACCEPT')
  #ADD(%ClarionWordList,'#REJECT')
  #ADD(%ClarionWordList,'#WINDOWS')                         #! Default Data/Code
  #ADD(%ClarionWordList,'#REPORTS')
  #ADD(%ClarionWordList,'#LOCALDATA')
  #ADD(%ClarionWordList,'#GLOBALDATA')
  #ADD(%ClarionWordList,'#DEFAULT')
  #ADD(%ClarionWordList,'#DECLARE')                         #! Symbol management
  #ADD(%ClarionWordList,'#ALIAS')
  #ADD(%ClarionWordList,'#EQUATE')
  #ADD(%ClarionWordList,'#ADD')
  #ADD(%ClarionWordList,'#DELETE')
  #ADD(%ClarionWordList,'#DELETEALL')
  #ADD(%ClarionWordList,'#PURGE')
  #ADD(%ClarionWordList,'#CLEAR')
  #ADD(%ClarionWordList,'#FREE')
  #ADD(%ClarionWordList,'#FIX')
  #ADD(%ClarionWordList,'#FIND')
  #ADD(%ClarionWordList,'#SELECT')
  #ADD(%ClarionWordList,'#POP')
  #ADD(%ClarionWordList,'#SET')
  #ADD(%ClarionWordList,'#UNFIX')
  #ADD(%ClarionWordList,'#PROMPT')                          #! Prompt and Validation
  #ADD(%ClarionWordList,'#VALIDATE')
  #ADD(%ClarionWordList,'#ENABLE')
  #ADD(%ClarionWordList,'#BUTTON')
  #ADD(%ClarionWordList,'#WITH')
  #ADD(%ClarionWordList,'#FIELD')
  #ADD(%ClarionWordList,'#PREPARE')
  #ADD(%ClarionWordList,'#ENDPREPARE')
  #ADD(%ClarionWordList,'CHECK')                            #! #PROMPT Entry Types
  #ADD(%ClarionWordList,'COLOR')
  #ADD(%ClarionWordList,'COMPONENT')
  #ADD(%ClarionWordList,'CONTROL')
  #ADD(%ClarionWordList,'DROP')
  #ADD(%ClarionWordList,'EMBED')
  #ADD(%ClarionWordList,'EXPR')
  #ADD(%ClarionWordList,'FIELD')
  #ADD(%ClarionWordList,'FILE')
  #ADD(%ClarionWordList,'FORMAT')
  #ADD(%ClarionWordList,'FROM')
  #ADD(%ClarionWordList,'KEY')
  #ADD(%ClarionWordList,'KEYCODE')
  #ADD(%ClarionWordList,'OPENDIALOG')
  #ADD(%ClarionWordList,'OPTFIELD')
  #ADD(%ClarionWordList,'OPTION')
  #ADD(%ClarionWordList,'PICTURE')
  #ADD(%ClarionWordList,'PROCEDURE')
  #ADD(%ClarionWordList,'RADIO')
  #ADD(%ClarionWordList,'SAVEDIALOG')
  #ADD(%ClarionWordList,'SPIN')
  #ADD(%ClarionWordList,'TEXT')
  #ADD(%ClarionWordList,'#BOXED')                           #! Display and Formating
  #ADD(%ClarionWordList,'#ENDBOXED')
  #ADD(%ClarionWordList,'#DISPLAY')
  #ADD(%ClarionWordList,'#IMAGE')
  #ADD(%ClarionWordList,'#SHEET')
  #ADD(%ClarionWordList,'#ENDSHEET')
  #ADD(%ClarionWordList,'#TAB')
  #ADD(%ClarionWordList,'#ENDTAB')
  #ADD(%ClarionWordList,'#FOR')                             #! Logic control
  #ADD(%ClarionWordList,'#ENDFOR')
  #ADD(%ClarionWordList,'#LOOP')
  #ADD(%ClarionWordList,'#ENDLOOP')
  #ADD(%ClarionWordList,'#BREAK')
  #ADD(%ClarionWordList,'#CYCLE')
  #ADD(%ClarionWordList,'#CASE')
  #ADD(%ClarionWordList,'#ENDCASE')
  #ADD(%ClarionWordList,'#INDENT')
  #ADD(%ClarionWordList,'#INSERT')
  #ADD(%ClarionWordList,'#CALL')
  #ADD(%ClarionWordList,'#INVOKE')
  #ADD(%ClarionWordList,'#RETURN')
  #ADD(%ClarionWordList,'#CREATE')                          #! File Management
  #ADD(%ClarionWordList,'#OPEN')
  #ADD(%ClarionWordList,'#CLOSE')
  #ADD(%ClarionWordList,'#READ')
  #ADD(%ClarionWordList,'#REDIRECT')
  #ADD(%ClarionWordList,'#APPEND')
  #ADD(%ClarionWordList,'#SECTION')
  #ADD(%ClarionWordList,'#REMOVE')
  #ADD(%ClarionWordList,'#REPLACE')
  #ADD(%ClarionWordList,'#PRINT')
  #ADD(%ClarionWordList,'#GENERATE')                        #! Generation
  #ADD(%ClarionWordList,'#ABORT')
  #ADD(%ClarionWordList,'#SUSPEND')
  #ADD(%ClarionWordList,'#RELEASE')
  #ADD(%ClarionWordList,'#RESUME')
  #ADD(%ClarionWordList,'#?')
  #ADD(%ClarionWordList,'#QUERY')
  #ADD(%ClarionWordList,'#RUN')                             #! External Execution
  #ADD(%ClarionWordList,'#SERVICE')
  #ADD(%ClarionWordList,'#RUNDLL')
  #ADD(%ClarionWordList,'#!')                               #! Miscellaneous
  #ADD(%ClarionWordList,'#<')
  #ADD(%ClarionWordList,'#ASSERT')
  #ADD(%ClarionWordList,'#CLASS')
  #ADD(%ClarionWordList,'#COMMENT')
  #ADD(%ClarionWordList,'#DEBUG')
  #ADD(%ClarionWordList,'#ERROR')
  #ADD(%ClarionWordList,'#EXPORT')
  #ADD(%ClarionWordList,'#HELP')
  #ADD(%ClarionWordList,'#INCLUDE')
  #ADD(%ClarionWordList,'#IMPORT')
  #ADD(%ClarionWordList,'#MESSAGE')
  #ADD(%ClarionWordList,'#PROTOTYPE')
  #ADD(%ClarionWordList,'#PROJECT')
  #ADD(%ClarionWordList,'CALL')                             #! Built in procedures
  #ADD(%ClarionWordList,'EXTRACT')
  #ADD(%ClarionWordList,'EXISTS')
  #ADD(%ClarionWordList,'FILEEXISTS')
  #ADD(%ClarionWordList,'FULLNAME')
  #ADD(%ClarionWordList,'INLIST')
  #ADD(%ClarionWordList,'INSTANCE')
  #ADD(%ClarionWordList,'INVOKE')
  #ADD(%ClarionWordList,'ITEMS')
  #ADD(%ClarionWordList,'LINKNAME')
  #ADD(%ClarionWordList,'QUOTE')
  #ADD(%ClarionWordList,'REGISTERED')
  #ADD(%ClarionWordList,'REPLACE')
  #ADD(%ClarionWordList,'SEPARATOR')
  #ADD(%ClarionWordList,'SLICE')
  #ADD(%ClarionWordList,'UNQUOTE')
  #ADD(%ClarionWordList,'VAREXISTS')
  #ADD(%ClarionWordList,'%APPLICATION')                     #! %APPLICATION
  #ADD(%ClarionWordList,'%APPLICATIONDEBUG')
  #ADD(%ClarionWordList,'%APPLICATIONLOCALLIBRARY')
  #ADD(%ClarionWordList,'%APPLICATIONTEMPLATE')
  #ADD(%ClarionWordList,'%APPLICATIONTEMPLATEINSTANCE')
  #ADD(%ClarionWordList,'%APPLICATIONTEMPLATEPARENTINSTANCE')
  #ADD(%ClarionWordList,'%PROJECTTARGET')
  #ADD(%ClarionWordList,'%TARGET32')
  #ADD(%ClarionWordList,'%DICTIONARYCHANGED')
  #ADD(%ClarionWordList,'%REGISTRYCHANGED')
  #ADD(%ClarionWordList,'%PROGRAMDATECREATED')
  #ADD(%ClarionWordList,'%PROGRAMDATECHANGED')
  #ADD(%ClarionWordList,'%PROGRAMTIMECREATED')
  #ADD(%ClarionWordList,'%PROGRAMTIMECHANGED')
  #ADD(%ClarionWordList,'%FIRSTPROCEDURE')
  #ADD(%ClarionWordList,'%HELPFILE')
  #ADD(%ClarionWordList,'%PROGRAMEXTENSION')                #! EXE,DLL,LIB
  #ADD(%ClarionWordList,'%DICTIONARYFILE')
  #ADD(%ClarionWordList,'%DICTIONARYTOOLOPTIONS')
  #ADD(%ClarionWordList,'%FILE')
  #ADD(%ClarionWordList,'%PROGRAM')
  #ADD(%ClarionWordList,'%GLOBALDATA')
  #ADD(%ClarionWordList,'%GLOBALDATASTATEMENT')
  #ADD(%ClarionWordList,'%GLOBALDATALEVEL')
  #ADD(%ClarionWordList,'%MODULE')
  #ADD(%ClarionWordList,'%CREATELOCALMAP')
  #ADD(%ClarionWordList,'%QUICKPROCEDURE')
  #ADD(%ClarionWordList,'%EDITPROCEDURE')
  #ADD(%ClarionWordList,'%EDITFILENAME')
  #ADD(%ClarionWordList,'%PROCEDURE')
  #ADD(%ClarionWordList,'%FILE')                            #! %FILE
  #ADD(%ClarionWordList,'%FILEIDENT')
  #ADD(%ClarionWordList,'%FILEPREFIX')
  #ADD(%ClarionWordList,'%FILEDESCRIPTION')
  #ADD(%ClarionWordList,'%FILETYPE')                        #! FILE,VIEW,ALIAS
  #ADD(%ClarionWordList,'%FILEUSAGE')                       #! FILE,GLOBAL,POOL
  #ADD(%ClarionWordList,'%GLOBALDATALAST')
  #ADD(%ClarionWordList,'%FILEDRIVER')
  #ADD(%ClarionWordList,'%FILEDRIVERPARAMETER')
  #ADD(%ClarionWordList,'%FILENAME')
  #ADD(%ClarionWordList,'%FILEOWNER')
  #ADD(%ClarionWordList,'%FILECREATE')
  #ADD(%ClarionWordList,'%FILERECLAIM')
  #ADD(%ClarionWordList,'%FILEENCRYPT')
  #ADD(%ClarionWordList,'%FILEBINDABLE')
  #ADD(%ClarionWordList,'%FILELONGDESC')
  #ADD(%ClarionWordList,'%FILE32BITONLY')
  #ADD(%ClarionWordList,'%FILESTRUCT')
  #ADD(%ClarionWordList,'%FILESTRUCTEND')
  #ADD(%ClarionWordList,'%FILESTRUCTREC')
  #ADD(%ClarionWordList,'%FILESTRUCTRECEND')
  #ADD(%ClarionWordList,'%FILESTATEMENT')
  #ADD(%ClarionWordList,'%FILETHREADED')
  #ADD(%ClarionWordList,'%FILEEXTERNAL')
  #ADD(%ClarionWordList,'%FILEEXTERNALMODULE')
  #ADD(%ClarionWordList,'%FILEPRIMARYKEY')
  #ADD(%ClarionWordList,'%FILEQUICKOPTIONS')
  #ADD(%ClarionWordList,'%FILEUSEROPTIONS')
  #ADD(%ClarionWordList,'%FILETOOLOPTIONS')
  #ADD(%ClarionWordList,'%VIEWFILTER')
  #ADD(%ClarionWordList,'%VIEWSTRUCT')
  #ADD(%ClarionWordList,'%VIEWSTRUCTEND')
  #ADD(%ClarionWordList,'%VIEWSTATEMENT')
  #ADD(%ClarionWordList,'%VIEWPRIMARY')
  #ADD(%ClarionWordList,'%VIEWPRIMARYFIELD')
  #ADD(%ClarionWordList,'%VIEWFILES')
  #ADD(%ClarionWordList,'%ALIASFILE')
  #ADD(%ClarionWordList,'%FIELD')
  #ADD(%ClarionWordList,'%KEY')
  #ADD(%ClarionWordList,'%KEYORDER')
  #ADD(%ClarionWordList,'%RELATION')
  #ADD(%ClarionWordList,'%VIEWFILES')                       #! %VIEWFILES
  #ADD(%ClarionWordList,'%VIEWFILESTRUCT')
  #ADD(%ClarionWordList,'%VIEWFILESTRUCTEND')
  #ADD(%ClarionWordList,'%VIEWFILE')
  #ADD(%ClarionWordList,'%VIEWJOINTO')
  #ADD(%ClarionWordList,'%VIEWFILEFIELDS')
  #ADD(%ClarionWordList,'%VIEWFILEFIELD')
  #ADD(%ClarionWordList,'%FIELD')                           #! %FIELD
  #ADD(%ClarionWordList,'%FIELDIDENT')
  #ADD(%ClarionWordList,'%FIELDDERIVEDFROM')
  #ADD(%ClarionWordList,'%FIELDDESCRIPTION')
  #ADD(%ClarionWordList,'%FIELDLONGDESC')
  #ADD(%ClarionWordList,'%FIELDFILE')
  #ADD(%ClarionWordList,'%FIELDID')
  #ADD(%ClarionWordList,'%FIELDDISPLAYPICTURE')
  #ADD(%ClarionWordList,'%FIELDRECORDPICTURE')
  #ADD(%ClarionWordList,'%FIELDDIMENSION1')
  #ADD(%ClarionWordList,'%FIELDDIMENSION2')
  #ADD(%ClarionWordList,'%FIELDDIMENSION3')
  #ADD(%ClarionWordList,'%FIELDDIMENSION4')
  #ADD(%ClarionWordList,'%FIELDHELPID')
  #ADD(%ClarionWordList,'%FIELDNAME')
  #ADD(%ClarionWordList,'%FIELDRANGELOW')
  #ADD(%ClarionWordList,'%FIELDRANGEHIGH')
  #ADD(%ClarionWordList,'%FIELDTYPE')
  #ADD(%ClarionWordList,'%FIELDPLACES')
  #ADD(%ClarionWordList,'%FIELDMEMOSIZE')
  #ADD(%ClarionWordList,'%FIELDMEMOIMAGE')
  #ADD(%ClarionWordList,'%FIELDINITIAL')
  #ADD(%ClarionWordList,'%FIELDLOOKUP')
  #ADD(%ClarionWordList,'%FIELDSTRUCT')
  #ADD(%ClarionWordList,'%FIELDSTATEMENT')
  #ADD(%ClarionWordList,'%FIELDHEADER')
  #ADD(%ClarionWordList,'%FIELDPICTURE')
  #ADD(%ClarionWordList,'%FIELDJUSTTYPE')                   #! L,R,C,D
  #ADD(%ClarionWordList,'%FIELDJUSTINDENT')
  #ADD(%ClarionWordList,'%FIELDFORMATWIDTH')
  #ADD(%ClarionWordList,'%FIELDSCREENCONTROL')
  #ADD(%ClarionWordList,'%FIELDSCREENCONTROLWIDTH')
  #ADD(%ClarionWordList,'%FIELDSCREENCONTROLHEIGHT')
  #ADD(%ClarionWordList,'%FIELDREPORTCONTROL')
  #ADD(%ClarionWordList,'%FIELDREPORTCONTROLWIDTH')
  #ADD(%ClarionWordList,'%FIELDREPORTCONTROLHEIGHT')
  #ADD(%ClarionWordList,'%FIELDVALIDATION')         #! NONZERO,INRANGE,BOOLEAN,INFILE,INLIST
  #ADD(%ClarionWordList,'%FIELDCHOICES')
  #ADD(%ClarionWordList,'%FIELDVALUES')
  #ADD(%ClarionWordList,'%FIELDTRUEVALUE')
  #ADD(%ClarionWordList,'%FIELDFALSEVALUE')
  #ADD(%ClarionWordList,'%FIELDDISPLAYCHOICES')
  #ADD(%ClarionWordList,'%FIELDQUICKOPTIONS')
  #ADD(%ClarionWordList,'%FIELDUSEROPTIONS')
  #ADD(%ClarionWordList,'%FIELDTOOLOPTIONS')
  #ADD(%ClarionWordList,'%KEY')                             #! %KEY / %KEYORDER
  #ADD(%ClarionWordList,'%KEYIDENT')
  #ADD(%ClarionWordList,'%KEYDESCRIPTION')
  #ADD(%ClarionWordList,'%KEYLONGDESC')
  #ADD(%ClarionWordList,'%KEYFILE')
  #ADD(%ClarionWordList,'%KEYID')
  #ADD(%ClarionWordList,'%KEYINDEX')                        #! KEY,INDEX,DYNAMIC
  #ADD(%ClarionWordList,'%KEYNAME')
  #ADD(%ClarionWordList,'%KEYAUTO')
  #ADD(%ClarionWordList,'%KEYDUPLICATE')
  #ADD(%ClarionWordList,'%KEYEXCLUDENULLS')
  #ADD(%ClarionWordList,'%KEYNOCASE')
  #ADD(%ClarionWordList,'%KEYPRIMARY')
  #ADD(%ClarionWordList,'%KEYSTRUCT')
  #ADD(%ClarionWordList,'%KEYSTATEMENT')
  #ADD(%ClarionWordList,'%KEYFIELD')
  #ADD(%ClarionWordList,'%KEYFIELDSEQUENCE')
  #ADD(%ClarionWordList,'%KEYQUICKOPTIONS')
  #ADD(%ClarionWordList,'%KEYUSEROPTIONS')
  #ADD(%ClarionWordList,'%KEYTOOLOPTIONS')
  #ADD(%ClarionWordList,'%KEYORDER')
  #ADD(%ClarionWordList,'%KEYORDERIDENT')
  #ADD(%ClarionWordList,'%KEYORDERDESCRIPTION')
  #ADD(%ClarionWordList,'%KEYORDERLONGDESC')
  #ADD(%ClarionWordList,'%KEYORDERFILE')
  #ADD(%ClarionWordList,'%KEYORDERID')
  #ADD(%ClarionWordList,'%KEYORDERINDEX')                   #! KEY,INDEX,DYNAMIC
  #ADD(%ClarionWordList,'%KEYORDERNAME')
  #ADD(%ClarionWordList,'%KEYORDERAUTO')
  #ADD(%ClarionWordList,'%KEYORDERDUPLICATE')
  #ADD(%ClarionWordList,'%KEYORDEREXCLUDENULLS')
  #ADD(%ClarionWordList,'%KEYORDERNOCASE')
  #ADD(%ClarionWordList,'%KEYORDERPRIMARY')
  #ADD(%ClarionWordList,'%KEYORDERSTRUCT')
  #ADD(%ClarionWordList,'%KEYORDERSTATEMENT')
  #ADD(%ClarionWordList,'%KEYORDERQUICKOPTIONS')
  #ADD(%ClarionWordList,'%KEYORDERUSEROPTIONS')
  #ADD(%ClarionWordList,'%KEYORDERTOOLOPTIONS')
  #ADD(%ClarionWordList,'%RELATION')                        #! %RELATION
  #ADD(%ClarionWordList,'%RELATIONPREFIX')
  #ADD(%ClarionWordList,'%RELATIONALIAS')
  #ADD(%ClarionWordList,'%FILERELATIONTYPE')                #! 1:MANY,MANY:1
  #ADD(%ClarionWordList,'%RELATIONKEY')
  #ADD(%ClarionWordList,'%FILEKEY')
  #ADD(%ClarionWordList,'%RELATIONCONSTRAINTDELETE')
  #ADD(%ClarionWordList,'%RELATIONCONSTRAINTUPDATE')
  #ADD(%ClarionWordList,'%RELATIONKEYFIELD')
  #ADD(%ClarionWordList,'%RELATIONKEYFIELDLINK')
  #ADD(%ClarionWordList,'%FILEKEYFIELD')
  #ADD(%ClarionWordList,'%FILEKEYFIELDLINK')
  #ADD(%ClarionWordList,'%RELATIONQUICKOPTIONS')
  #ADD(%ClarionWordList,'%RELATIONUSEROPTIONS')
  #ADD(%ClarionWordList,'%RELATIONTOOLOPTIONS')
  #ADD(%ClarionWordList,'%MODULE')                          #! %MODULE
  #ADD(%ClarionWordList,'%MODULELANGUAGE')
  #ADD(%ClarionWordList,'%MODULETEMPLATE')
  #ADD(%ClarionWordList,'%MODULECHANGED')
  #ADD(%ClarionWordList,'%MODULEEXTERNAL')
  #ADD(%ClarionWordList,'%MODULEREADONLY')
  #ADD(%ClarionWordList,'%MODULEEXTENSION')
  #ADD(%ClarionWordList,'%MODULEBASE')
  #ADD(%ClarionWordList,'%MODULEINCLUDE')
  #ADD(%ClarionWordList,'%MODULEPROCEDURE')
  #ADD(%ClarionWordList,'%MODULEDATA')
  #ADD(%ClarionWordList,'%MODULEDATASTATEMENT')
  #ADD(%ClarionWordList,'%PROCEDURE')                       #! %PROCEDURE
  #ADD(%ClarionWordList,'%PROCEDURETODO')
  #ADD(%ClarionWordList,'%PROCEDURETYPE')                   #! PROCEDURE,FUNCTION
  #ADD(%ClarionWordList,'%PROCEDURERETURNTYPE')
  #ADD(%ClarionWordList,'%PROCEDUREDATECREATED')
  #ADD(%ClarionWordList,'%PROCEDUREDATECHANGED')
  #ADD(%ClarionWordList,'%PROCEDURETIMECREATED')
  #ADD(%ClarionWordList,'%PROCEDURETIMECHANGED')
  #ADD(%ClarionWordList,'%PROCEDUREREADONLY')
  #ADD(%ClarionWordList,'%PROCEDUREISGLOBAL')
  #ADD(%ClarionWordList,'%PROTOTYPE')
  #ADD(%ClarionWordList,'%PROCEDURETEMPLATE')
  #ADD(%ClarionWordList,'%PROCEDUREDESCRIPTION')
  #ADD(%ClarionWordList,'%PROCEDUREEXPORTED')
  #ADD(%ClarionWordList,'%PROCEDURELONGDESCRIPTION')
  #ADD(%ClarionWordList,'%PROCEDURECALLED')
  #ADD(%ClarionWordList,'%LOCALDATA')
  #ADD(%ClarionWordList,'%LOCALDATASTATEMENT')
  #ADD(%ClarionWordList,'%LOCALDATADESCRIPTION')
  #ADD(%ClarionWordList,'%LOCALDATAHEADER')
  #ADD(%ClarionWordList,'%LOCALDATAPICTURE')
  #ADD(%ClarionWordList,'%LOCALDATAJUSTTYPE')               #! L,R,C,D
  #ADD(%ClarionWordList,'%LOCALDATAJUSTINDENT')
  #ADD(%ClarionWordList,'%LOCALDATAFORMATWIDTH')
  #ADD(%ClarionWordList,'%ACTIVETEMPLATE')
  #ADD(%ClarionWordList,'%ACTIVETEMPLATEINSTANCE')
  #ADD(%ClarionWordList,'%ACTIVETEMPLATEOWNERINSTANCE')
  #ADD(%ClarionWordList,'%ACTIVETEMPLATEPARENTINSTANCE')
  #ADD(%ClarionWordList,'%ACTIVETEMPLATEPRIMARYINSTANCE')
  #ADD(%ClarionWordList,'%WINDOW')                          #! %WINDOW / %CONTROL
  #ADD(%ClarionWordList,'%WINDOWSTATEMENT')
  #ADD(%ClarionWordList,'%MENUBARSTATEMENT')
  #ADD(%ClarionWordList,'%TOOLBARSTATEMENT')
  #ADD(%ClarionWordList,'%WINDOWEVENT')
  #ADD(%ClarionWordList,'%CONTROL')
  #ADD(%ClarionWordList,'%CONTROLUSE')
  #ADD(%ClarionWordList,'%CONTROLSTATEMENT')
  #ADD(%ClarionWordList,'%CONTROLUNSPLITSTATEMENT')
  #ADD(%ClarionWordList,'%CONTROLTYPE')                     #! MENU,ITEM,ENTRY,BUTTON,...
  #ADD(%ClarionWordList,'%CONTROLTEMPLATE')
  #ADD(%ClarionWordList,'%CONTROLTOOL')
  #ADD(%ClarionWordList,'%CONTROLPARENT')                   #! OPTION,GROUP
  #ADD(%ClarionWordList,'%CONTROLPARENTTYPE')
  #ADD(%ClarionWordList,'%CONTROLPARENTTAB')
  #ADD(%ClarionWordList,'%CONTROLPARAMETER')
  #ADD(%ClarionWordList,'%CONTROLDEFAULTWIDTH')
  #ADD(%ClarionWordList,'%CONTROLDEFAULTHEIGHT')
  #ADD(%ClarionWordList,'%CONTROLMENU')
  #ADD(%ClarionWordList,'%CONTROLTOOLBAR')
  #ADD(%ClarionWordList,'%CONTROLMENUBAR')
  #ADD(%ClarionWordList,'%CONTROLINDENT')
  #ADD(%ClarionWordList,'%CONTROLINSTANCE')
  #ADD(%ClarionWordList,'%CONTROLORIGINAL')
  #ADD(%ClarionWordList,'%CONTROLFROM')
  #ADD(%ClarionWordList,'%CONTROLALERT')
  #ADD(%ClarionWordList,'%CONTROLEVENT')
  #ADD(%ClarionWordList,'%CONTROLFIELD')
  #ADD(%ClarionWordList,'%CONTROLFIELDHASICON')
  #ADD(%ClarionWordList,'%CONTROLFIELDHASCOLOR')
  #ADD(%ClarionWordList,'%CONTROLFIELDHASTREE')
  #ADD(%ClarionWordList,'%CONTROLFIELDHASLOCATOR')
  #ADD(%ClarionWordList,'%CONTROLFIELDPICTURE')
  #ADD(%ClarionWordList,'%CONTROLFIELDHEADING')
  #ADD(%ClarionWordList,'%CONTROLFIELDFORMAT')
  #ADD(%ClarionWordList,'%REPORT')                          #! %REPORT
  #ADD(%ClarionWordList,'%REPORTSTATEMENT')
  #ADD(%ClarionWordList,'%REPORTCONTROL')
  #ADD(%ClarionWordList,'%REPORTCONTROLUSE')
  #ADD(%ClarionWordList,'%REPORTCONTROLSTATEMENT')
  #ADD(%ClarionWordList,'%REPORTCONTROLTYPE')
  #ADD(%ClarionWordList,'%REPORTCONTROLTEMPLATE')
  #ADD(%ClarionWordList,'%REPORTCONTROLINDENT')
  #ADD(%ClarionWordList,'%REPORTCONTROLINSTANCE')
  #ADD(%ClarionWordList,'%REPORTCONTROLORIGINAL')
  #ADD(%ClarionWordList,'%REPORTCONTROLLABEL')
  #ADD(%ClarionWordList,'%REPORTCONTROLFIELD')
  #ADD(%ClarionWordList,'%FORMULA')                         #! %FORMULA
  #ADD(%ClarionWordList,'%FORMULADESCRIPTION')
  #ADD(%ClarionWordList,'%FORMULACLASS')
  #ADD(%ClarionWordList,'%FORMULAINSTANCE')
  #ADD(%ClarionWordList,'%FORMULAEXPRESSION')
  #ADD(%ClarionWordList,'%FORMULAEXPRESSIONTYPE')
  #ADD(%ClarionWordList,'%FORMULAEXPRESSIONTRUE')
  #ADD(%ClarionWordList,'%FORMULAEXPRESSIONFALSE')
  #ADD(%ClarionWordList,'%FORMULAEXPRESSIONOF')
  #ADD(%ClarionWordList,'%FORMULAEXPRESSIONCASE')
  #ADD(%ClarionWordList,'%PRIMARY')                         #! %PRIMARY (File Schematic)
  #ADD(%ClarionWordList,'%PRIMARYKEY')
  #ADD(%ClarionWordList,'%PRIMARYINSTANCE')
  #ADD(%ClarionWordList,'%SECONDARY')
  #ADD(%ClarionWordList,'%SECONDARYTO')
  #ADD(%ClarionWordList,'%SECONDARYTYPE')                   #! 1:MANY,MANY:1
  #ADD(%ClarionWordList,'%SECONDARYCUSTOMJOIN')
  #ADD(%ClarionWordList,'%SECONDARYCUSTOMTEXT')
  #ADD(%ClarionWordList,'%OTHERFILES')
  #ADD(%ClarionWordList,'%DRIVER')                          #! %DRIVER
  #ADD(%ClarionWordList,'%DRIVERDLL')
  #ADD(%ClarionWordList,'%DRIVERLIB')
  #ADD(%ClarionWordList,'%DRIVERDESCRIPTION')
  #ADD(%ClarionWordList,'%DRIVERCREATE')
  #ADD(%ClarionWordList,'%DRIVEROWNER')
  #ADD(%ClarionWordList,'%DRIVERENCRYPT')
  #ADD(%ClarionWordList,'%DRIVERRECLAIM')
  #ADD(%ClarionWordList,'%DRIVERMAXKEYS')
  #ADD(%ClarionWordList,'%DRIVERUNIQUEKEY')
  #ADD(%ClarionWordList,'%DRIVERREQUIRED')
  #ADD(%ClarionWordList,'%DRIVERMEMO')
  #ADD(%ClarionWordList,'%DRIVERBINMEMO')
  #ADD(%ClarionWordList,'%DRIVERSQL')
  #ADD(%ClarionWordList,'%DRIVERTYPE')
  #ADD(%ClarionWordList,'%DRIVEROPCODE')
  #ADD(%ClarionWordList,'%CONDITIONALGENERATE')             #! Miscellaneous symbols
  #ADD(%ClarionWordList,'%CWVERSION')
  #ADD(%ClarionWordList,'%NULL')
  #ADD(%ClarionWordList,'%TRUE')
  #ADD(%ClarionWordList,'%FALSE')
  #ADD(%ClarionWordList,'%EOF')
  #ADD(%ClarionWordList,'%BYTESOUTPUT')
  #ADD(%ClarionWordList,'%EMBEDID')
  #ADD(%ClarionWordList,'%EMBEDDESCRIPTION')
  #ADD(%ClarionWordList,'%EMBEDPARAMETERS')
  #ADD(%ClarionWordList,'%WIN32')
  #ADD(%ClarionWordList,'[END]')                            #! Export/Inport text formats
  #ADD(%ClarionWordList,'!!>')
  #ADD(%ClarionWordList,'[DICTIONARY]')                     #! TXD
  #ADD(%ClarionWordList,'[FILES]')
  #ADD(%ClarionWordList,'[ALIASES]')
  #ADD(%ClarionWordList,'[RELATIONS]')
  #ADD(%ClarionWordList,'[LONGDESC]')
  #ADD(%ClarionWordList,'[QUICKCODE]')
  #ADD(%ClarionWordList,'[USEROPTION]')
  #ADD(%ClarionWordList,'[TOOLOPTION]')
  #ADD(%ClarionWordList,'[SCREENCONTROLS]')
  #ADD(%ClarionWordList,'[REPORTCONTROLS]')
  #ADD(%ClarionWordList,'[APPLICATION]')                    #! TXA
  #ADD(%ClarionWordList,'[PROJECT]')
  #ADD(%ClarionWordList,'[PROGRAM]')
  #ADD(%ClarionWordList,'[MODULE]')
  #ADD(%ClarionWordList,'[PROCEDURE]')
  #ADD(%ClarionWordList,'[COMMON]') 
  #ADD(%ClarionWordList,'[DATA]')
  #ADD(%ClarionWordList,'[FILES]')
  #ADD(%ClarionWordList,'[PRIMARY]')
  #ADD(%ClarionWordList,'[INSTANCE]')
  #ADD(%ClarionWordList,'[KEY]')
  #ADD(%ClarionWordList,'[SECONDARY]')
  #ADD(%ClarionWordList,'[OTHERS]')
  #ADD(%ClarionWordList,'[PROMPTS]')
  #ADD(%ClarionWordList,'[EMBED]')
  #ADD(%ClarionWordList,'[INSTANCES]')
  #ADD(%ClarionWordList,'[DEFINITION]')
  #ADD(%ClarionWordList,'[SOURCE]')
  #ADD(%ClarionWordList,'[TEMPLATE]')
  #ADD(%ClarionWordList,'[GROUP]')
  #ADD(%ClarionWordList,'[ADDITION]')
  #ADD(%ClarionWordList,'[FIELDPROMPT]')
  #ADD(%ClarionWordList,'[INSTANCE]')
  #ADD(%ClarionWordList,'[PROMPTS]')
  #ADD(%ClarionWordList,'[PERSIST]')
  #ADD(%ClarionWordList,'[CALLS]')
  #ADD(%ClarionWordList,'[WINDOW]')
  #ADD(%ClarionWordList,'[REPORT]')
  #ADD(%ClarionWordList,'[FORMULA]')
  #ADD(%ClarionWordList,'VERSION')                          #! Miscellaneous
  #ADD(%ClarionWordList,'CREATED')
  #ADD(%ClarionWordList,'MODIFIED')
  #ADD(%ClarionWordList,'PASSWORD')
  #ADD(%ClarionWordList,'NOPOPULATE')
  #ADD(%ClarionWordList,'IDENT')
  #ADD(%ClarionWordList,'USAGE')
  #ADD(%ClarionWordList,'FILE')
  #ADD(%ClarionWordList,'GLOBAL')
  #ADD(%ClarionWordList,'POOL')
  #ADD(%ClarionWordList,'LAST')
  #ADD(%ClarionWordList,'ORDER')
  #ADD(%ClarionWordList,'NORMAL')
  #ADD(%ClarionWordList,'FIRST')
  #ADD(%ClarionWordList,'AUTO')
  #ADD(%ClarionWordList,'VERTICALSPACE')
  #ADD(%ClarionWordList,'TAB')
  #ADD(%ClarionWordList,'VALID')
  #ADD(%ClarionWordList,'INITIAL')
  #ADD(%ClarionWordList,'PROMPT')
  #ADD(%ClarionWordList,'HEADER')
  #ADD(%ClarionWordList,'HELP')
  #ADD(%ClarionWordList,'MESSAGE')
  #ADD(%ClarionWordList,'TOOLTIP')
  #ADD(%ClarionWordList,'PICTURE')
  #ADD(%ClarionWordList,'CASE')
  #ADD(%ClarionWordList,'TYPEMODE')
  #ADD(%ClarionWordList,'READONLY')
  #ADD(%ClarionWordList,'NONZERO')
  #ADD(%ClarionWordList,'INRANGE')
  #ADD(%ClarionWordList,'BOOLEAN')
  #ADD(%ClarionWordList,'INFILE')
  #ADD(%ClarionWordList,'INLIST')
  #ADD(%ClarionWordList,'RELATION')
  #ADD(%ClarionWordList,'ONE:MANY')
  #ADD(%ClarionWordList,'MANY:ONE')
  #ADD(%ClarionWordList,'UPDATE')
  #ADD(%ClarionWordList,'DELETE')
  #ADD(%ClarionWordList,'NONE')
  #ADD(%ClarionWordList,'RESTRICT')
  #ADD(%ClarionWordList,'CASCADE')
  #ADD(%ClarionWordList,'CLEAR')
  #ADD(%ClarionWordList,'RESTRICT-SERVER')
  #ADD(%ClarionWordList,'CASCADE-SERVER')
  #ADD(%ClarionWordList,'CLEAR-SERVER')
  #ADD(%ClarionWordList,'FILE_TO_RELATED_KEY')
  #ADD(%ClarionWordList,'RELATED_FILE_TO_KEY')
  #ADD(%ClarionWordList,'FIELD')
  #ADD(%ClarionWordList,'NOLINK')
  #ADD(%ClarionWordList,'HLP')
  #ADD(%ClarionWordList,'DICTIONARY')
  #ADD(%ClarionWordList,'PROCEDURE')
  #ADD(%ClarionWordList,'LONGDESC')
  #ADD(%ClarionWordList,'FROM')
  #ADD(%ClarionWordList,'NAME')
  #ADD(%ClarionWordList,'INCLUDE')
  #ADD(%ClarionWordList,'#SEQ')
  #ADD(%ClarionWordList,'#ORIG')
  #ADD(%ClarionWordList,'#FIELDS')
  #ADD(%ClarionWordList,'#LINK')
  #ADD(%ClarionWordList,'DEFINE')
  #ADD(%ClarionWordList,'ASSIGN')
  #ADD(%ClarionWordList,'CLASS')
  #ADD(%ClarionWordList,'DESCRIPTION')
  #ADD(%ClarionWordList,'LONG')
  #ADD(%ClarionWordList,'REAL')
  #ADD(%ClarionWordList,'STRING')
  #ADD(%ClarionWordList,'FILE')
  #ADD(%ClarionWordList,'FIELD')
  #ADD(%ClarionWordList,'KEY')
  #ADD(%ClarionWordList,'COMPONENT')
  #ADD(%ClarionWordList,'PROCEDURE')
  #ADD(%ClarionWordList,'DEFAULT')
  #ADD(%ClarionWordList,'DEPEND')
  #ADD(%ClarionWordList,'WHEN')
  #ADD(%ClarionWordList,'TIMES')
  #ADD(%ClarionWordList,'INSTANCE')
  #ADD(%ClarionWordList,'PARENT')
  #ADD(%ClarionWordList,'PROCPROP')
  #ADD(%ClarionWordList,'#ABORT')                           #! Project System
  #ADD(%ClarionWordList,'#AND')
  #ADD(%ClarionWordList,'#AUTOCOMPILE')
  #ADD(%ClarionWordList,'#COMPILE')
  #ADD(%ClarionWordList,'#DECLARE_COMPILER')
  #ADD(%ClarionWordList,'#DOLINK')
  #ADD(%ClarionWordList,'#ELSE')
  #ADD(%ClarionWordList,'#ELSIF')
  #ADD(%ClarionWordList,'#ENDIF')
  #ADD(%ClarionWordList,'#ERROR')
  #ADD(%ClarionWordList,'#EXEMOD')
  #ADD(%ClarionWordList,'#EXISTS')
  #ADD(%ClarionWordList,'#EXPAND')
  #ADD(%ClarionWordList,'#FILE')
  #ADD(%ClarionWordList,'#IF')
  #ADD(%ClarionWordList,'#IGNORE')
  #ADD(%ClarionWordList,'#IMPLIB')
  #ADD(%ClarionWordList,'#INCLUDE')
  #ADD(%ClarionWordList,'#LINK')
  #ADD(%ClarionWordList,'#MESSAGE')
  #ADD(%ClarionWordList,'#MODEL')
  #ADD(%ClarionWordList,'#NOEDIT')
  #ADD(%ClarionWordList,'#NOT')
  #ADD(%ClarionWordList,'#OLDER')
  #ADD(%ClarionWordList,'#OR')
  #ADD(%ClarionWordList,'#PRAGMA')
  #ADD(%ClarionWordList,'#PROMPT')
  #ADD(%ClarionWordList,'#RUN')
  #ADD(%ClarionWordList,'#RUNDLL')
  #ADD(%ClarionWordList,'#SET')
  #ADD(%ClarionWordList,'#SPLIT')
  #ADD(%ClarionWordList,'#SYSTEM')
  #ADD(%ClarionWordList,'#THEN')
  #ADD(%ClarionWordList,'#TO')
  #ADD(%ClarionWordList,'EVENT:ACCEPTED')                   #! Event Equates
  #ADD(%ClarionWordList,'EVENT:NEWSELECTION')
  #ADD(%ClarionWordList,'EVENT:SCROLLUP')
  #ADD(%ClarionWordList,'EVENT:SCROLLDOWN')
  #ADD(%ClarionWordList,'EVENT:PAGEUP')
  #ADD(%ClarionWordList,'EVENT:PAGEDOWN')
  #ADD(%ClarionWordList,'EVENT:SCROLLTOP')
  #ADD(%ClarionWordList,'EVENT:SCROLLBOTTOM')
  #ADD(%ClarionWordList,'EVENT:LOCATE')
  #ADD(%ClarionWordList,'EVENT:MOUSEDOWN')
  #ADD(%ClarionWordList,'EVENT:MOUSEUP')
  #ADD(%ClarionWordList,'EVENT:MOUSEIN')
  #ADD(%ClarionWordList,'EVENT:MOUSEOUT')
  #ADD(%ClarionWordList,'EVENT:MOUSEMOVE')
  #ADD(%ClarionWordList,'EVENT:VBXEVENT')
  #ADD(%ClarionWordList,'EVENT:ALERTKEY')
  #ADD(%ClarionWordList,'EVENT:PREALERTKEY')
  #ADD(%ClarionWordList,'EVENT:DRAGGING')
  #ADD(%ClarionWordList,'EVENT:DRAG')
  #ADD(%ClarionWordList,'EVENT:DROP')
  #ADD(%ClarionWordList,'EVENT:SCROLLDRAG')
  #ADD(%ClarionWordList,'EVENT:TABCHANGING')
  #ADD(%ClarionWordList,'EVENT:EXPANDING')
  #ADD(%ClarionWordList,'EVENT:CONTRACTING')
  #ADD(%ClarionWordList,'EVENT:EXPANDED')
  #ADD(%ClarionWordList,'EVENT:CONTRACTED')
  #ADD(%ClarionWordList,'EVENT:REJECTED')
  #ADD(%ClarionWordList,'EVENT:DROPPINGDOWN')
  #ADD(%ClarionWordList,'EVENT:DROPPEDDOWN')
  #ADD(%ClarionWordList,'EVENT:SCROLLTRACK')
  #ADD(%ClarionWordList,'EVENT:COLUMNRESIZE')
  #ADD(%ClarionWordList,'EVENT:SELECTING')
  #ADD(%ClarionWordList,'EVENT:SELECTED')
  #ADD(%ClarionWordList,'EVENT:CLOSEWINDOW')
  #ADD(%ClarionWordList,'EVENT:CLOSEDOWN')
  #ADD(%ClarionWordList,'EVENT:OPENWINDOW')
  #ADD(%ClarionWordList,'EVENT:OPENFAILED')
  #ADD(%ClarionWordList,'EVENT:LOSEFOCUS')
  #ADD(%ClarionWordList,'EVENT:GAINFOCUS')
  #ADD(%ClarionWordList,'EVENT:SUSPEND')
  #ADD(%ClarionWordList,'EVENT:RESUME')
  #ADD(%ClarionWordList,'EVENT:TIMER')
  #ADD(%ClarionWordList,'EVENT:DDEREQUEST')
  #ADD(%ClarionWordList,'EVENT:DDEADVISE')
  #ADD(%ClarionWordList,'EVENT:DDEDATA')
  #ADD(%ClarionWordList,'EVENT:DDECOMMAND')
  #ADD(%ClarionWordList,'EVENT:DDEEXECUTE')
  #ADD(%ClarionWordList,'EVENT:DDEPOKE')
  #ADD(%ClarionWordList,'EVENT:DDECLOSED')
  #ADD(%ClarionWordList,'EVENT:MOVE')
  #ADD(%ClarionWordList,'EVENT:SIZE')
  #ADD(%ClarionWordList,'EVENT:RESTORE')
  #ADD(%ClarionWordList,'EVENT:MAXIMIZE')
  #ADD(%ClarionWordList,'EVENT:ICONIZE')
  #ADD(%ClarionWordList,'EVENT:COMPLETED')
  #ADD(%ClarionWordList,'EVENT:MOVED')
  #ADD(%ClarionWordList,'EVENT:SIZED')
  #ADD(%ClarionWordList,'EVENT:RESTORED')
  #ADD(%ClarionWordList,'EVENT:MAXIMIZED')
  #ADD(%ClarionWordList,'EVENT:ICONIZED')
  #ADD(%ClarionWordList,'EVENT:DOCKED')
  #ADD(%ClarionWordList,'EVENT:UNDOCKED')
  #ADD(%ClarionWordList,'EVENT:BUILDFILE')
  #ADD(%ClarionWordList,'EVENT:BUILDKEY')
  #ADD(%ClarionWordList,'EVENT:BUILDDONE')
  #ADD(%ClarionWordList,'EVENT:USER')
  #ADD(%ClarionWordList,'EVENT:LAST')
  #ADD(%ClarionWordList,'STD:WINDOWLIST')                   #! Standard Equates
  #ADD(%ClarionWordList,'STD:TILEWINDOW')
  #ADD(%ClarionWordList,'STD:CASCADEWINDOW')
  #ADD(%ClarionWordList,'STD:ARRANGEICONS')
  #ADD(%ClarionWordList,'STD:HELPINDEX')
  #ADD(%ClarionWordList,'STD:HELPONHELP')
  #ADD(%ClarionWordList,'STD:HELPSEARCH')
  #ADD(%ClarionWordList,'STD:HELP')
  #ADD(%ClarionWordList,'STD:CUT')
  #ADD(%ClarionWordList,'STD:COPY')
  #ADD(%ClarionWordList,'STD:PASTE')
  #ADD(%ClarionWordList,'STD:CLEAR')
  #ADD(%ClarionWordList,'STD:UNDO')
  #ADD(%ClarionWordList,'STD:CLOSE')
  #ADD(%ClarionWordList,'STD:PRINTSETUP')
  #ADD(%ClarionWordList,'STD:TILEHORIZONTAL')
  #ADD(%ClarionWordList,'STD:TILEVERTICAL')
  #ADD(%ClarionWordList,'CURSOR:NONE')                      #! Cursor Equates
  #ADD(%ClarionWordList,'CURSOR:ARROW')
  #ADD(%ClarionWordList,'CURSOR:IBEAM')
  #ADD(%ClarionWordList,'CURSOR:WAIT')
  #ADD(%ClarionWordList,'CURSOR:CROSS')
  #ADD(%ClarionWordList,'CURSOR:UPARROW')
  #ADD(%ClarionWordList,'CURSOR:SIZE')
  #ADD(%ClarionWordList,'CURSOR:ICON')
  #ADD(%ClarionWordList,'CURSOR:SIZENWSE')
  #ADD(%ClarionWordList,'CURSOR:SIZENESW')
  #ADD(%ClarionWordList,'CURSOR:SIZEWE')
  #ADD(%ClarionWordList,'CURSOR:SIZENS')
  #ADD(%ClarionWordList,'CURSOR:DRAGWE')
  #ADD(%ClarionWordList,'CURSOR:DROP')
  #ADD(%ClarionWordList,'CURSOR:NODROP')
  #ADD(%ClarionWordList,'CURSOR:ZOOM')
  #ADD(%ClarionWordList,'ICON:NONE')                        #! Icon Equates
  #ADD(%ClarionWordList,'ICON:APPLICATION')
  #ADD(%ClarionWordList,'ICON:HAND')
  #ADD(%ClarionWordList,'ICON:QUESTION')
  #ADD(%ClarionWordList,'ICON:EXCLAMATION')
  #ADD(%ClarionWordList,'ICON:ASTERISK')
  #ADD(%ClarionWordList,'ICON:PICK')
  #ADD(%ClarionWordList,'ICON:SAVE')
  #ADD(%ClarionWordList,'ICON:PRINT')
  #ADD(%ClarionWordList,'ICON:PASTE')
  #ADD(%ClarionWordList,'ICON:OPEN')
  #ADD(%ClarionWordList,'ICON:NEW')
  #ADD(%ClarionWordList,'ICON:HELP')
  #ADD(%ClarionWordList,'ICON:CUT')
  #ADD(%ClarionWordList,'ICON:COPY')
  #ADD(%ClarionWordList,'ICON:CHILD')
  #ADD(%ClarionWordList,'ICON:FRAME')
  #ADD(%ClarionWordList,'ICON:CLARION')
  #ADD(%ClarionWordList,'ICON:NOPRINT')
  #ADD(%ClarionWordList,'ICON:ZOOM')
  #ADD(%ClarionWordList,'ICON:NEXTPAGE')
  #ADD(%ClarionWordList,'ICON:PREVPAGE')
  #ADD(%ClarionWordList,'ICON:JUMPPAGE')
  #ADD(%ClarionWordList,'ICON:THUMBNAIL')
  #ADD(%ClarionWordList,'ICON:TICK')
  #ADD(%ClarionWordList,'ICON:CROSS')
  #ADD(%ClarionWordList,'ICON:CONNECT')
  #ADD(%ClarionWordList,'ICON:PRINT1')
  #ADD(%ClarionWordList,'ICON:ELLIPSIS')
  #ADD(%ClarionWordList,'ICON:VCRTOP')
  #ADD(%ClarionWordList,'ICON:VCRREWIND')
  #ADD(%ClarionWordList,'ICON:VCRBACK')
  #ADD(%ClarionWordList,'ICON:VCRPLAY')
  #ADD(%ClarionWordList,'ICON:VCRFASTFORWARD')
  #ADD(%ClarionWordList,'ICON:VCRBOTTOM')
  #ADD(%ClarionWordList,'ICON:VCRLOCATE')
  #ADD(%ClarionWordList,'BEEP:SYSTEMDEFAULT')               #! Speaker equates
  #ADD(%ClarionWordList,'BEEP:SYSTEMHAND')
  #ADD(%ClarionWordList,'BEEP:SYSTEMQUESTION')
  #ADD(%ClarionWordList,'BEEP:SYSTEMEXCLAMATION')
  #ADD(%ClarionWordList,'BEEP:SYSTEMASTERISK')
  #ADD(%ClarionWordList,'REJECT:RANGEHIGH')                 #! Record Reject Equates
  #ADD(%ClarionWordList,'REJECT:RANGELOW')
  #ADD(%ClarionWordList,'REJECT:RANGE')
  #ADD(%ClarionWordList,'REJECT:INVALID')
  #ADD(%ClarionWordList,'COLOR:NONE')                       #! Color Equates
  #ADD(%ClarionWordList,'COLOR:NONE')
  #ADD(%ClarionWordList,'COLOR:SCROLLBAR')
  #ADD(%ClarionWordList,'COLOR:BACKGROUND')
  #ADD(%ClarionWordList,'COLOR:ACTIVECAPTION')
  #ADD(%ClarionWordList,'COLOR:INACTIVECAPTION')
  #ADD(%ClarionWordList,'COLOR:MENU')
  #ADD(%ClarionWordList,'COLOR:WINDOW')
  #ADD(%ClarionWordList,'COLOR:WINDOWFRAME')
  #ADD(%ClarionWordList,'COLOR:MENUTEXT')
  #ADD(%ClarionWordList,'COLOR:WINDOWTEXT')
  #ADD(%ClarionWordList,'COLOR:CAPTIONTEXT')
  #ADD(%ClarionWordList,'COLOR:ACTIVEBORDER')
  #ADD(%ClarionWordList,'COLOR:INACTIVEBORDER')
  #ADD(%ClarionWordList,'COLOR:APPWORKSPACE')
  #ADD(%ClarionWordList,'COLOR:HIGHLIGHT')
  #ADD(%ClarionWordList,'COLOR:HIGHLIGHTTEXT')
  #ADD(%ClarionWordList,'COLOR:BTNFACE')
  #ADD(%ClarionWordList,'COLOR:BTNSHADOW')
  #ADD(%ClarionWordList,'COLOR:GRAYTEXT')
  #ADD(%ClarionWordList,'COLOR:BTNTEXT')
  #ADD(%ClarionWordList,'COLOR:INACTIVECAPTIONTEXT')
  #ADD(%ClarionWordList,'COLOR:BTNHIGHLIGHT')
  #ADD(%ClarionWordList,'COLOR:BLACK')
  #ADD(%ClarionWordList,'COLOR:MAROON')
  #ADD(%ClarionWordList,'COLOR:GREEN')
  #ADD(%ClarionWordList,'COLOR:OLIVE')
  #ADD(%ClarionWordList,'COLOR:NAVY')
  #ADD(%ClarionWordList,'COLOR:PURPLE')
  #ADD(%ClarionWordList,'COLOR:TEAL')
  #ADD(%ClarionWordList,'COLOR:GRAY')
  #ADD(%ClarionWordList,'COLOR:SILVER')
  #ADD(%ClarionWordList,'COLOR:RED')
  #ADD(%ClarionWordList,'COLOR:LIME')
  #ADD(%ClarionWordList,'COLOR:YELLOW')
  #ADD(%ClarionWordList,'COLOR:BLUE')
  #ADD(%ClarionWordList,'COLOR:FUSCHIA')
  #ADD(%ClarionWordList,'COLOR:AQUA')
  #ADD(%ClarionWordList,'COLOR:WHITE')
  #ADD(%ClarionWordList,'CREATE:SSTRING')                   #! Control Type Equates
  #ADD(%ClarionWordList,'CREATE:STRING')
  #ADD(%ClarionWordList,'CREATE:IMAGE')
  #ADD(%ClarionWordList,'CREATE:REGION')
  #ADD(%ClarionWordList,'CREATE:LINE')
  #ADD(%ClarionWordList,'CREATE:BOX')
  #ADD(%ClarionWordList,'CREATE:ELLIPSE')
  #ADD(%ClarionWordList,'CREATE:ENTRY')
  #ADD(%ClarionWordList,'CREATE:BUTTON')
  #ADD(%ClarionWordList,'CREATE:PROMPT')
  #ADD(%ClarionWordList,'CREATE:OPTION')
  #ADD(%ClarionWordList,'CREATE:CHECK')
  #ADD(%ClarionWordList,'CREATE:GROUP')
  #ADD(%ClarionWordList,'CREATE:LIST')
  #ADD(%ClarionWordList,'CREATE:COMBO')
  #ADD(%ClarionWordList,'CREATE:SPIN')
  #ADD(%ClarionWordList,'CREATE:TEXT')
  #ADD(%ClarionWordList,'CREATE:CUSTOM')
  #ADD(%ClarionWordList,'CREATE:MENU')
  #ADD(%ClarionWordList,'CREATE:ITEM')
  #ADD(%ClarionWordList,'CREATE:RADIO')
  #ADD(%ClarionWordList,'CREATE:MENUBAR')
  #ADD(%ClarionWordList,'CREATE:APPLICATION')
  #ADD(%ClarionWordList,'CREATE:WINDOW')
  #ADD(%ClarionWordList,'CREATE:REPORT')
  #ADD(%ClarionWordList,'CREATE:HEADER')
  #ADD(%ClarionWordList,'CREATE:FOOTER')
  #ADD(%ClarionWordList,'CREATE:BREAK')
  #ADD(%ClarionWordList,'CREATE:FORM')
  #ADD(%ClarionWordList,'CREATE:DETAIL')
  #ADD(%ClarionWordList,'CREATE:OLE')
  #ADD(%ClarionWordList,'CREATE:DROPLIST')
  #ADD(%ClarionWordList,'CREATE:DROPCOMBO')
  #ADD(%ClarionWordList,'CREATE:PROGRESS')
  #ADD(%ClarionWordList,'CREATE:SHEET')
  #ADD(%ClarionWordList,'CREATE:TAB')
  #ADD(%ClarionWordList,'CREATE:PANEL')
  #ADD(%ClarionWordList,'CREATE:SUBLIST')
  #ADD(%ClarionWordList,'CREATE:TOOLBAR')
  #ADD(%ClarionWordList,'FONT:THIN')                        #! Font Equates
  #ADD(%ClarionWordList,'FONT:REGULAR')
  #ADD(%ClarionWordList,'FONT:BOLD')
  #ADD(%ClarionWordList,'FONT:WEIGHT')
  #ADD(%ClarionWordList,'FONT:FIXED')
  #ADD(%ClarionWordList,'FONT:ITALIC')
  #ADD(%ClarionWordList,'FONT:UNDERLINE')
  #ADD(%ClarionWordList,'FONT:STRIKEOUT')
  #ADD(%ClarionWordList,'CHARSET:ANSI')                     #! Character Set Equates
  #ADD(%ClarionWordList,'CHARSET:DEFAULT')
  #ADD(%ClarionWordList,'CHARSET:SYMBOL')
  #ADD(%ClarionWordList,'CHARSET:MAC')
  #ADD(%ClarionWordList,'CHARSET:SHIFTJIS')
  #ADD(%ClarionWordList,'CHARSET:HANGEUL')
  #ADD(%ClarionWordList,'CHARSET:JOHAB')
  #ADD(%ClarionWordList,'CHARSET:GB2312')
  #ADD(%ClarionWordList,'CHARSET:CHINESEBIG5')
  #ADD(%ClarionWordList,'CHARSET:GREEK')
  #ADD(%ClarionWordList,'CHARSET:TURKISH')
  #ADD(%ClarionWordList,'CHARSET:HEBREW')
  #ADD(%ClarionWordList,'CHARSET:ARABIC')
  #ADD(%ClarionWordList,'CHARSET:BALTIC')
  #ADD(%ClarionWordList,'CHARSET:CYRILLIC')
  #ADD(%ClarionWordList,'CHARSET:THAI')
  #ADD(%ClarionWordList,'CHARSET:EASTEUROPE')
  #ADD(%ClarionWordList,'CHARSET:OEM')
  #ADD(%ClarionWordList,'PEN:SOLID')                        #! Pen Equates
  #ADD(%ClarionWordList,'PEN:DASH')
  #ADD(%ClarionWordList,'PEN:DOT')
  #ADD(%ClarionWordList,'PEN:DASHDOT')
  #ADD(%ClarionWordList,'PEN:DASHDOTDOT')
  #ADD(%ClarionWordList,'PEN:NULL')
  #ADD(%ClarionWordList,'PEN:INSIDEFRAME')
  #ADD(%ClarionWordList,'LISTZONE:FIELD')                   #! List Zone Equates
  #ADD(%ClarionWordList,'LISTZONE:RIGHT')
  #ADD(%ClarionWordList,'LISTZONE:HEADER')
  #ADD(%ClarionWordList,'LISTZONE:EXPANDBOX')
  #ADD(%ClarionWordList,'LISTZONE:TREE')
  #ADD(%ClarionWordList,'LISTZONE:ICON')
  #ADD(%ClarionWordList,'LISTZONE:NOWHERE')
  #ADD(%ClarionWordList,'VBXEVENT:CLICK')                   #! VBX Event Equates
  #ADD(%ClarionWordList,'VBXEVENT:DBLCLICK')
  #ADD(%ClarionWordList,'VBXEVENT:GOTFOCUS')
  #ADD(%ClarionWordList,'VBXEVENT:KEYDOWN')
  #ADD(%ClarionWordList,'VBXEVENT:KEYPRESS')
  #ADD(%ClarionWordList,'VBXEVENT:KEYUP')
  #ADD(%ClarionWordList,'VBXEVENT:LOSTFOCUS')
  #ADD(%ClarionWordList,'VBXEVENT:MOUSEDOWN')
  #ADD(%ClarionWordList,'VBXEVENT:MOUSEMOVE')
  #ADD(%ClarionWordList,'VBXEVENT:MOUSEUP')
  #ADD(%ClarionWordList,'BUTTON:OK')                        #! Button ID equates
  #ADD(%ClarionWordList,'BUTTON:YES')
  #ADD(%ClarionWordList,'BUTTON:NO')
  #ADD(%ClarionWordList,'BUTTON:ABORT')
  #ADD(%ClarionWordList,'BUTTON:RETRY')
  #ADD(%ClarionWordList,'BUTTON:IGNORE')
  #ADD(%ClarionWordList,'BUTTON:CANCEL')
  #ADD(%ClarionWordList,'BUTTON:HELP')
  #ADD(%ClarionWordList,'DDE:AUTO')                         #! DDE Equates
  #ADD(%ClarionWordList,'DDE:MANUAL')
  #ADD(%ClarionWordList,'DDE:REMOVE')
  #ADD(%ClarionWordList,'FF_:NORMAL')                       #! Directory Equates
  #ADD(%ClarionWordList,'FF_:READONLY')
  #ADD(%ClarionWordList,'FF_:HIDDEN')
  #ADD(%ClarionWordList,'FF_:SYSTEM')
  #ADD(%ClarionWordList,'FF_:DIRECTORY')
  #ADD(%ClarionWordList,'FF_:ARCHIVE')
  #ADD(%ClarionWordList,'FF_:LFN')
  #ADD(%ClarionWordList,'FF_:QUEUE')
  #ADD(%ClarionWordList,'FILE:MAXFILENAME')                 #! File Equates
  #ADD(%ClarionWordList,'FILE:MAXFILEPATH')
  #ADD(%ClarionWordList,'FILE:QUEUE')
  #ADD(%ClarionWordList,'FILE:SAVE')
  #ADD(%ClarionWordList,'FILE:KEEPDIR')
  #ADD(%ClarionWordList,'FILE:NOERROR')
  #ADD(%ClarionWordList,'FILE:MULTI')
  #ADD(%ClarionWordList,'FILE:LONGNAME')
  #ADD(%ClarionWordList,'FILE:DIRECTORY')
  #ADD(%ClarionWordList,'OCX:DEFAULT')                      #! OCX Equates
  #ADD(%ClarionWordList,'OCX:16BIT')
  #ADD(%ClarionWordList,'OCX:32BIT')
  #ADD(%ClarionWordList,'OCX:1632BIT')
  #ADD(%ClarionWordList,'DOCK:LEFT')                        #! Docking Equates
  #ADD(%ClarionWordList,'DOCK:TOP')
  #ADD(%ClarionWordList,'DOCK:RIGHT')
  #ADD(%ClarionWordList,'DOCK:BOTTOM')
  #ADD(%ClarionWordList,'DOCK:FLOAT')
  #ADD(%ClarionWordList,'DOCK:ALL')
  #ADD(%ClarionWordList,'TPSREADONLY')                      #! Odds and Ends
  #ADD(%ClarionWordList,'FALSE')
  #ADD(%ClarionWordList,'TRUE')
  #ADD(%ClarionWordList,'Insert:None')
  #ADD(%ClarionWordList,'Delete:None')
  #ADD(%ClarionWordList,'Cancel:Cancel')
  #ADD(%ClarionWordList,'Resize:SetMinSize')
  #ADD(%ClarionWordList,'AppStrategy:Surface')
  #ADD(%ClarionWordList,'RequestCancelled')
  #ADD(%ClarionWordList,'MATCH:SIMPLE')                     #! MATCH Equates
  #ADD(%ClarionWordList,'MATCH:WILD')
  #ADD(%ClarionWordList,'MATCH:REGULAR')
  #ADD(%ClarionWordList,'MATCH:SOUNDEX')
  #ADD(%ClarionWordList,'MATCH:NOCASE')
  #ADD(%ClarionWordList,'PAPER:LETTER')                     #! Paper Equates
  #ADD(%ClarionWordList,'PAPER:LETTERSMALL')
  #ADD(%ClarionWordList,'PAPER:TABLOID')
  #ADD(%ClarionWordList,'PAPER:LEDGER')
  #ADD(%ClarionWordList,'PAPER:LEGAL')
  #ADD(%ClarionWordList,'PAPER:STATEMENT')
  #ADD(%ClarionWordList,'PAPER:EXECUTIVE')
  #ADD(%ClarionWordList,'PAPER:A3')
  #ADD(%ClarionWordList,'PAPER:A4')
  #ADD(%ClarionWordList,'PAPER:A4SMALL')
  #ADD(%ClarionWordList,'PAPER:A5')
  #ADD(%ClarionWordList,'PAPER:B4')
  #ADD(%ClarionWordList,'PAPER:B5')
  #ADD(%ClarionWordList,'PAPER:FOLIO')
  #ADD(%ClarionWordList,'PAPER:QUARTO')
  #ADD(%ClarionWordList,'PAPER:10X14')
  #ADD(%ClarionWordList,'PAPER:11X17')
  #ADD(%ClarionWordList,'PAPER:NOTE')
  #ADD(%ClarionWordList,'PAPER:ENV_9')
  #ADD(%ClarionWordList,'PAPER:ENV_10')
  #ADD(%ClarionWordList,'PAPER:ENV_11')
  #ADD(%ClarionWordList,'PAPER:ENV_12')
  #ADD(%ClarionWordList,'PAPER:ENV_14')
  #ADD(%ClarionWordList,'PAPER:CSHEET')
  #ADD(%ClarionWordList,'PAPER:DSHEET')
  #ADD(%ClarionWordList,'PAPER:ESHEET')
  #ADD(%ClarionWordList,'PAPER:ENV_DL')
  #ADD(%ClarionWordList,'PAPER:ENV_C5')
  #ADD(%ClarionWordList,'PAPER:ENV_C3')
  #ADD(%ClarionWordList,'PAPER:ENV_C4')
  #ADD(%ClarionWordList,'PAPER:ENV_C6')
  #ADD(%ClarionWordList,'PAPER:ENV_C65')
  #ADD(%ClarionWordList,'PAPER:ENV_B4')
  #ADD(%ClarionWordList,'PAPER:ENV_B5')
  #ADD(%ClarionWordList,'PAPER:ENV_B6')
  #ADD(%ClarionWordList,'PAPER:ENV_ITALY')
  #ADD(%ClarionWordList,'PAPER:ENV_MONARCH')
  #ADD(%ClarionWordList,'PAPER:ENV_PERSONAL')
  #ADD(%ClarionWordList,'PAPER:FANFOLD_US')
  #ADD(%ClarionWordList,'PAPER:FANFOLD_STD_GERMAN')
  #ADD(%ClarionWordList,'PAPER:FANFOLD_LGL_GERMAN')
  #ADD(%ClarionWordList,'PAPER:LAST')
  #ADD(%ClarionWordList,'PAPER:USER')
  #ADD(%ClarionWordList,'PROP:DISABLE')                     #! PROP Equates
  #ADD(%ClarionWordList,'PROP:HEIGHT')
  #ADD(%ClarionWordList,'PROP:MAXIMIZE')
  #ADD(%ClarionWordList,'PROP:WIDTH')
  #ADD(%ClarionWordList,'PROP:XPOS')
  #ADD(%ClarionWordList,'PROP:YPOS')
  #ADD(%ClarionWordList,'PROP:TEXT')
  #ADD(%ClarionWordList,'PROP:TYPE')
  #ADD(%ClarionWordList,'PROP:AT')
  #ADD(%ClarionWordList,'PROP:XPOS')
  #ADD(%ClarionWordList,'PROP:YPOS')
  #ADD(%ClarionWordList,'PROP:WIDTH')
  #ADD(%ClarionWordList,'PROP:HEIGHT')
  #ADD(%ClarionWordList,'PROP:CENTER')
  #ADD(%ClarionWordList,'PROP:CENTEROFFSET')
  #ADD(%ClarionWordList,'PROP:LEFT')
  #ADD(%ClarionWordList,'PROP:LEFTOFFSET')
  #ADD(%ClarionWordList,'PROP:DECIMAL')
  #ADD(%ClarionWordList,'PROP:DECIMALOFFSET')
  #ADD(%ClarionWordList,'PROP:RIGHT')
  #ADD(%ClarionWordList,'PROP:RIGHTOFFSET')
  #ADD(%ClarionWordList,'PROP:ABOVE')
  #ADD(%ClarionWordList,'PROP:ABOVESIZE')
  #ADD(%ClarionWordList,'PROP:BELOW')
  #ADD(%ClarionWordList,'PROP:BELOWSIZE')
  #ADD(%ClarionWordList,'PROP:CLASS')
  #ADD(%ClarionWordList,'PROP:VBXFILE')
  #ADD(%ClarionWordList,'PROP:VBXNAME')
  #ADD(%ClarionWordList,'PROP:FONT')
  #ADD(%ClarionWordList,'PROP:FONTNAME')
  #ADD(%ClarionWordList,'PROP:FONTSIZE')
  #ADD(%ClarionWordList,'PROP:FONTCOLOR')
  #ADD(%ClarionWordList,'PROP:FONTSTYLE')
  #ADD(%ClarionWordList,'PROP:TIPSFONT')
  #ADD(%ClarionWordList,'PROP:STATUSFONT')
  #ADD(%ClarionWordList,'PROP:RANGE')
  #ADD(%ClarionWordList,'PROP:RANGELOW')
  #ADD(%ClarionWordList,'PROP:RANGEHIGH')
  #ADD(%ClarionWordList,'PROP:VCR')
  #ADD(%ClarionWordList,'PROP:VCRFEQ')
  #ADD(%ClarionWordList,'PROP:DOUBLE')
  #ADD(%ClarionWordList,'PROP:RESIZE')
  #ADD(%ClarionWordList,'PROP:NOFRAME')
  #ADD(%ClarionWordList,'PROP:MM')
  #ADD(%ClarionWordList,'PROP:THOUS')
  #ADD(%ClarionWordList,'PROP:POINTS')
  #ADD(%ClarionWordList,'PROP:PIXELS')
  #ADD(%ClarionWordList,'PROP:SUM')
  #ADD(%ClarionWordList,'PROP:AVE')
  #ADD(%ClarionWordList,'PROP:MAX')
  #ADD(%ClarionWordList,'PROP:MIN')
  #ADD(%ClarionWordList,'PROP:CNT')
  #ADD(%ClarionWordList,'PROP:PAGENO')
  #ADD(%ClarionWordList,'PROP:PAGE')
  #ADD(%ClarionWordList,'PROP:ABSOLUTE')
  #ADD(%ClarionWordList,'PROP:ALONE')
  #ADD(%ClarionWordList,'PROP:PREVIEW')
  #ADD(%ClarionWordList,'PROP:FLUSHPREVIEW')
  #ADD(%ClarionWordList,'PROP:FIRST')
  #ADD(%ClarionWordList,'PROP:LAST')
  #ADD(%ClarionWordList,'PROP:INS')
  #ADD(%ClarionWordList,'PROP:OVR')
  #ADD(%ClarionWordList,'PROP:BOXED')
  #ADD(%ClarionWordList,'PROP:CAP')
  #ADD(%ClarionWordList,'PROP:COLUMN')
  #ADD(%ClarionWordList,'PROP:CURSOR')
  #ADD(%ClarionWordList,'PROP:DEFAULT')
  #ADD(%ClarionWordList,'PROP:DISABLE')
  #ADD(%ClarionWordList,'PROP:DROP')
  #ADD(%ClarionWordList,'PROP:FILL')
  #ADD(%ClarionWordList,'PROP:FROM')
  #ADD(%ClarionWordList,'PROP:FULL')
  #ADD(%ClarionWordList,'PROP:GRAY')
  #ADD(%ClarionWordList,'PROP:HIDE')
  #ADD(%ClarionWordList,'PROP:HLP')
  #ADD(%ClarionWordList,'PROP:HSCROLL')
  #ADD(%ClarionWordList,'PROP:ICON')
  #ADD(%ClarionWordList,'PROP:ICONIZE')
  #ADD(%ClarionWordList,'PROP:IMM')
  #ADD(%ClarionWordList,'PROP:KEY')
  #ADD(%ClarionWordList,'PROP:LANDSCAPE')
  #ADD(%ClarionWordList,'PROP:MARK')
  #ADD(%ClarionWordList,'PROP:MASK')
  #ADD(%ClarionWordList,'PROP:MAXIMIZE')
  #ADD(%ClarionWordList,'PROP:MDI')
  #ADD(%ClarionWordList,'PROP:META')
  #ADD(%ClarionWordList,'PROP:MODAL')
  #ADD(%ClarionWordList,'PROP:MSG')
  #ADD(%ClarionWordList,'PROP:NOBAR')
  #ADD(%ClarionWordList,'PROP:NOMERGE')
  #ADD(%ClarionWordList,'PROP:PAGEAFTER')
  #ADD(%ClarionWordList,'PROP:PAGEAFTERNUM')
  #ADD(%ClarionWordList,'PROP:PAGEBEFORE')
  #ADD(%ClarionWordList,'PROP:PAGEBEFORENUM')
  #ADD(%ClarionWordList,'PROP:PASSWORD')
  #ADD(%ClarionWordList,'PROP:READONLY')
  #ADD(%ClarionWordList,'PROP:REQ')
  #ADD(%ClarionWordList,'PROP:RESET')
  #ADD(%ClarionWordList,'PROP:ROUND')
  #ADD(%ClarionWordList,'PROP:SCROLL')
  #ADD(%ClarionWordList,'PROP:SEPARATE')
  #ADD(%ClarionWordList,'PROP:SKIP')
  #ADD(%ClarionWordList,'PROP:STD')
  #ADD(%ClarionWordList,'PROP:STEP')
  #ADD(%ClarionWordList,'PROP:SYSTEM')
  #ADD(%ClarionWordList,'PROP:FORMAT')
  #ADD(%ClarionWordList,'PROP:TIMER')
  #ADD(%ClarionWordList,'PROP:CHECK')
  #ADD(%ClarionWordList,'PROP:TRN')
  #ADD(%ClarionWordList,'PROP:UPR')
  #ADD(%ClarionWordList,'PROP:VSCROLL')
  #ADD(%ClarionWordList,'PROP:WITHNEXT')
  #ADD(%ClarionWordList,'PROP:WITHPRIOR')
  #ADD(%ClarionWordList,'PROP:ITEMS')
  #ADD(%ClarionWordList,'PROP:SELECTED')
  #ADD(%ClarionWordList,'PROP:SELSTART')
  #ADD(%ClarionWordList,'PROP:SELEND')
  #ADD(%ClarionWordList,'PROP:AUTO')
  #ADD(%ClarionWordList,'PROP:TOOLBOX')
  #ADD(%ClarionWordList,'PROP:PALETTE')
  #ADD(%ClarionWordList,'PROP:IMAGEBITS')
  #ADD(%ClarionWordList,'PROP:THREAD')
  #ADD(%ClarionWordList,'PROP:HANDLE')
  #ADD(%ClarionWordList,'PROP:ACTIVE')
  #ADD(%ClarionWordList,'PROP:VBXEVENT')
  #ADD(%ClarionWordList,'PROP:FOLLOWS')
  #ADD(%ClarionWordList,'PROP:ACCEPTALL')
  #ADD(%ClarionWordList,'PROP:TOUCHED')
  #ADD(%ClarionWordList,'PROP:VSCROLLPOS')
  #ADD(%ClarionWordList,'PROP:CLIPBITS')
  #ADD(%ClarionWordList,'PROP:TIP')
  #ADD(%ClarionWordList,'PROP:TOOLTIP')
  #ADD(%ClarionWordList,'PROP:LFNSUPPORT')
  #ADD(%ClarionWordList,'PROP:PROGRESS')
  #ADD(%ClarionWordList,'PROP:VISIBLE')
  #ADD(%ClarionWordList,'PROP:ENABLED')
  #ADD(%ClarionWordList,'PROP:WIZARD')
  #ADD(%ClarionWordList,'PROP:CHOICEFEQ')
  #ADD(%ClarionWordList,'PROP:CLIENTHANDLE')
  #ADD(%ClarionWordList,'PROP:LINECOUNT')
  #ADD(%ClarionWordList,'PROP:MINWIDTH')
  #ADD(%ClarionWordList,'PROP:MINHEIGHT')
  #ADD(%ClarionWordList,'PROP:MAXWIDTH')
  #ADD(%ClarionWordList,'PROP:MAXHEIGHT')
  #ADD(%ClarionWordList,'PROP:NOTIPS')
  #ADD(%ClarionWordList,'PROP:TIPDELAY')
  #ADD(%ClarionWordList,'PROP:TIPDISPLAY')
  #ADD(%ClarionWordList,'PROP:WNDPROC')
  #ADD(%ClarionWordList,'PROP:CLIENTWNDPROC')
  #ADD(%ClarionWordList,'PROP:IMAGEBLOB')
  #ADD(%ClarionWordList,'PROP:SPREAD')
  #ADD(%ClarionWordList,'PROP:SIZE')
  #ADD(%ClarionWordList,'PROP:SCREENTEXT')
  #ADD(%ClarionWordList,'PROP:HSCROLLPOS')
  #ADD(%ClarionWordList,'PROP:LAZYDISPLAY')
  #ADD(%ClarionWordList,'PROP:DEFERMOVE')
  #ADD(%ClarionWordList,'PROP:APPINSTANCE')
  #ADD(%ClarionWordList,'PROP:VALUE')
  #ADD(%ClarionWordList,'PROP:TRUEVALUE')
  #ADD(%ClarionWordList,'PROP:FALSEVALUE')
  #ADD(%ClarionWordList,'PROP:DDETIMEOUT')
  #ADD(%ClarionWordList,'PROP:TABROWS')
  #ADD(%ClarionWordList,'PROP:NUMTABS')
  #ADD(%ClarionWordList,'PROP:LIBVERSION')
  #ADD(%ClarionWordList,'PROP:EXEVERSION')
  #ADD(%ClarionWordList,'PROP:CREATE')
  #ADD(%ClarionWordList,'PROP:SAVEAS')
  #ADD(%ClarionWordList,'PROP:OPEN')
  #ADD(%ClarionWordList,'PROP:BLOB')
  #ADD(%ClarionWordList,'PROP:DOVERB')
  #ADD(%ClarionWordList,'PROP:SIZEMODE')
  #ADD(%ClarionWordList,'PROP:SELECTINTERFACE')
  #ADD(%ClarionWordList,'PROP:ADDREF')
  #ADD(%ClarionWordList,'PROP:RELEASE')
  #ADD(%ClarionWordList,'PROP:DEACTIVATE')
  #ADD(%ClarionWordList,'PROP:UPDATE')
  #ADD(%ClarionWordList,'PROP:PASTE')
  #ADD(%ClarionWordList,'PROP:REPORTEXCEPTION')
  #ADD(%ClarionWordList,'PROP:PASTELINK')
  #ADD(%ClarionWordList,'PROP:COPY')
  #ADD(%ClarionWordList,'PROP:CANPASTE')
  #ADD(%ClarionWordList,'PROP:CANPASTELINK')
  #ADD(%ClarionWordList,'PROP:WINDOWUI')
  #ADD(%ClarionWordList,'PROP:DESIGNMODE')
  #ADD(%ClarionWordList,'PROP:CTRL')
  #ADD(%ClarionWordList,'PROP:GRABHANDLES')
  #ADD(%ClarionWordList,'PROP:OLE')
  #ADD(%ClarionWordList,'PROP:ISRADIO')
  #ADD(%ClarionWordList,'PROP:LASTEVENTNAME')
  #ADD(%ClarionWordList,'PROP:CLSID')
  #ADD(%ClarionWordList,'PROP:PROGID')
  #ADD(%ClarionWordList,'PROP:BEVELSTYLE')
  #ADD(%ClarionWordList,'PROP:JOIN')
  #ADD(%ClarionWordList,'PROP:NOSHEET')
  #ADD(%ClarionWordList,'PROP:BEVEL')
  #ADD(%ClarionWordList,'PROP:BEVELOUTER')
  #ADD(%ClarionWordList,'PROP:BEVELINNER')
  #ADD(%ClarionWordList,'PROP:LINEWIDTH')
  #ADD(%ClarionWordList,'PROP:ANGLE')
  #ADD(%ClarionWordList,'PROP:AUTOSIZE')
  #ADD(%ClarionWordList,'PROP:CLIP')
  #ADD(%ClarionWordList,'PROP:STRETCH')
  #ADD(%ClarionWordList,'PROP:ZOOM')
  #ADD(%ClarionWordList,'PROP:COMPATIBILITY')
  #ADD(%ClarionWordList,'PROP:DESIGN')
  #ADD(%ClarionWordList,'PROP:DOCUMENT')
  #ADD(%ClarionWordList,'PROP:LINK')
  #ADD(%ClarionWordList,'PROP:CREATEFROMFILE')
  #ADD(%ClarionWordList,'PROP:CREATELINKTOFILE')
  #ADD(%ClarionWordList,'PROP:ALIGN')
  #ADD(%ClarionWordList,'PROP:CANCEL')
  #ADD(%ClarionWordList,'PROP:TEXTALIGN')
  #ADD(%ClarionWordList,'PROP:OBJECT')
  #ADD(%ClarionWordList,'PROP:LICENSE')
  #ADD(%ClarionWordList,'PROP:LANGUAGE')
  #ADD(%ClarionWordList,'PROP:COLOR')
  #ADD(%ClarionWordList,'PROP:BACKGROUND')
  #ADD(%ClarionWordList,'PROP:FILLCOLOR')
  #ADD(%ClarionWordList,'PROP:SELECTEDCOLOR')
  #ADD(%ClarionWordList,'PROP:SELECTEDFILLCOLOR')
  #ADD(%ClarionWordList,'PROP:LINEHEIGHT')
  #ADD(%ClarionWordList,'PROP:DROPWIDTH')
  #ADD(%ClarionWordList,'PROP:ALWAYSDROP')
  #ADD(%ClarionWordList,'PROP:UP')
  #ADD(%ClarionWordList,'PROP:DOWN')
  #ADD(%ClarionWordList,'PROP:UPSIDEDOWN')
  #ADD(%ClarionWordList,'PROP:HEADERHEIGHT')
  #ADD(%ClarionWordList,'PROP:CHECKED')
  #ADD(%ClarionWordList,'PROP:AUTOPAPER')
  #ADD(%ClarionWordList,'PROP:SINGLE')
  #ADD(%ClarionWordList,'PROP:PARENT')
  #ADD(%ClarionWordList,'PROP:REPEAT')
  #ADD(%ClarionWordList,'PROP:EVENTSWAITING')
  #ADD(%ClarionWordList,'PROP:DDEMODE')
  #ADD(%ClarionWordList,'PROP:THREADING')
  #ADD(%ClarionWordList,'PROP:TEMPNAMEFUNC')
  #ADD(%ClarionWordList,'PROP:DELAY')
  #ADD(%ClarionWordList,'PROP:BREAKVAR')
  #ADD(%ClarionWordList,'PROP:USE')
  #ADD(%ClarionWordList,'PROP:FEQ')
  #ADD(%ClarionWordList,'PROP:LISTFEQ')
  #ADD(%ClarionWordList,'PROP:BUTTONFEQ')
  #ADD(%ClarionWordList,'PROP:FLAT')
  #ADD(%ClarionWordList,'PROP:WALLPAPER')
  #ADD(%ClarionWordList,'PROP:TILED')
  #ADD(%ClarionWordList,'PROP:CENTERED')
  #ADD(%ClarionWordList,'PROP:TILEIMAGE')
  #ADD(%ClarionWordList,'PROP:CENTERIMAGE')
  #ADD(%ClarionWordList,'PROP:CHILDINDEX')
  #ADD(%ClarionWordList,'PROP:INTOOLBAR')
  #ADD(%ClarionWordList,'PROP:PRINTMODE')
  #ADD(%ClarionWordList,'PROP:REJECTCODE')
  #ADD(%ClarionWordList,'PROP:VLBPROC')
  #ADD(%ClarionWordList,'PROP:VLBVAL')
  #ADD(%ClarionWordList,'PROP:TEMPIMAGE')
  #ADD(%ClarionWordList,'PROP:TEMPPATH')
  #ADD(%ClarionWordList,'PROP:TEMPPAGEPATH')
  #ADD(%ClarionWordList,'PROP:TEMPIMAGEPATH')
  #ADD(%ClarionWordList,'PROP:LIBHOOK')
  #ADD(%ClarionWordList,'PROP:COLORDIALOGHOOK')
  #ADD(%ClarionWordList,'PROP:FILEDIALOGHOOK')
  #ADD(%ClarionWordList,'PROP:FONTDIALOGHOOK')
  #ADD(%ClarionWordList,'PROP:PRINTERDIALOGHOOK')
  #ADD(%ClarionWordList,'PROP:HALTHOOK')
  #ADD(%ClarionWordList,'PROP:MESSAGEHOOK')
  #ADD(%ClarionWordList,'PROP:STOPHOOK')
  #ADD(%ClarionWordList,'PROP:ASSERTHOOK')
  #ADD(%ClarionWordList,'PROP:FATALERRORHOOK')
  #ADD(%ClarionWordList,'PROP:CHARSET')
  #ADD(%ClarionWordList,'PROP:FONTCHARSET')
  #ADD(%ClarionWordList,'PROP:SYSTEMPROPHOOK')
  #ADD(%ClarionWordList,'PROP:ASSERTHOOK2')
  #ADD(%ClarionWordList,'PROP:INITASTRINGHOOK')
  #ADD(%ClarionWordList,'PROP:NOWIDTH')
  #ADD(%ClarionWordList,'PROP:NOHEIGHT')
  #ADD(%ClarionWordList,'PROP:NEXTPAGENO')
  #ADD(%ClarionWordList,'PROP:XORIGIN')
  #ADD(%ClarionWordList,'PROP:YORIGIN')
  #ADD(%ClarionWordList,'PROP:TARGET')
  #ADD(%ClarionWordList,'PROP:TOGETHER')
  #ADD(%ClarionWordList,'PROP:DOCK')
  #ADD(%ClarionWordList,'PROP:DOCKED')
  #ADD(%ClarionWordList,'PROP:BROKENTABS')
  #ADD(%ClarionWordList,'PROP:IMAGEINSTANCE')
  #ADD(%ClarionWordList,'PROP:GLOBALHELP')
  #ADD(%ClarionWordList,'PROP:BUFFER')
  #ADD(%ClarionWordList,'PROP:CLIENTX')
  #ADD(%ClarionWordList,'PROP:CLIENTY')
  #ADD(%ClarionWordList,'PROP:CLIENTWIDTH')
  #ADD(%ClarionWordList,'PROP:CLIENTHEIGHT')
  #ADD(%ClarionWordList,'PROP:USEADDRESS')
  #ADD(%ClarionWordList,'PROP:FLUSHPAGENUMFUNC')
  #ADD(%ClarionWordList,'PROP:STATUS')
  #ADD(%ClarionWordList,'PROP:STATUSTEXT')
  #ADD(%ClarionWordList,'PROP:DRAGID')
  #ADD(%ClarionWordList,'PROP:DROPID')
  #ADD(%ClarionWordList,'PROP:VBXEVENTARG')
  #ADD(%ClarionWordList,'PROP:EDIT')
  #ADD(%ClarionWordList,'PROP:ALRT')
  #ADD(%ClarionWordList,'PROP:ICONLIST')
  #ADD(%ClarionWordList,'PROP:LINE')
  #ADD(%ClarionWordList,'PROP:TALLY')
  #ADD(%ClarionWordList,'PROP:CHILD')
  #ADD(%ClarionWordList,'PROP:NEXTFIELD')
  #ADD(%ClarionWordList,'PROP:SNAPWIDTH')
  #ADD(%ClarionWordList,'PROP:SNAPHEIGHT')
  #ADD(%ClarionWordList,'PROP:CURRENTKEY')
  #ADD(%ClarionWordList,'PROP:LOGOUT')
  #ADD(%ClarionWordList,'PROP:LOG')
  #ADD(%ClarionWordList,'PROP:PROFILE')
  #ADD(%ClarionWordList,'PROP:DETAILS')
  #ADD(%ClarionWordList,'PROP:WATCHED')
  #ADD(%ClarionWordList,'PROP:HELD')
  #ADD(%ClarionWordList,'PROP:PROGRESSEVENTS')
  #ADD(%ClarionWordList,'PROP:COMPLETED')
  #ADD(%ClarionWordList,'PROP:DRIVER')
  #ADD(%ClarionWordList,'PROP:DRIVERLOGSOUTALIAS')
  #ADD(%ClarionWordList,'PROP:KEYS')
  #ADD(%ClarionWordList,'PROP:BLOBS')
  #ADD(%ClarionWordList,'PROP:MEMOS')
  #ADD(%ClarionWordList,'PROP:FIELDS')
  #ADD(%ClarionWordList,'PROP:ENCRYPT')
  #ADD(%ClarionWordList,'PROP:DRIVERSTRING')
  #ADD(%ClarionWordList,'PROP:OWNER')
  #ADD(%ClarionWordList,'PROP:NAME')
  #ADD(%ClarionWordList,'PROP:LABEL')
  #ADD(%ClarionWordList,'PROP:OEM')
  #ADD(%ClarionWordList,'PROP:RECLAIM')
  #ADD(%ClarionWordList,'PROP:SQLDRIVER')
  #ADD(%ClarionWordList,'PROP:FILESIZE')
  #ADD(%ClarionWordList,'PROP:SUPPORTSOP')
  #ADD(%ClarionWordList,'PROP:SUPPORTSTYPE')
  #ADD(%ClarionWordList,'PROP:RECORD')
  #ADD(%ClarionWordList,'PROP:COMPONENTS')
  #ADD(%ClarionWordList,'PROP:DUP')
  #ADD(%ClarionWordList,'PROP:OPT')
  #ADD(%ClarionWordList,'PROP:NOCASE')
  #ADD(%ClarionWordList,'PROP:PRIMARY')
  #ADD(%ClarionWordList,'PROP:FIELD')
  #ADD(%ClarionWordList,'PROP:ASCENDING')
  #ADD(%ClarionWordList,'PROP:BINARY')
  #ADD(%ClarionWordList,'PROP:PLACES')
  #ADD(%ClarionWordList,'PROP:DIM')
  #ADD(%ClarionWordList,'PROP:OVER')
  #ADD(%ClarionWordList,'PROP:ORDER')
  #ADD(%ClarionWordList,'PROP:FILTER')
  #ADD(%ClarionWordList,'PROP:JOINEXPRESSION')
  #ADD(%ClarionWordList,'PROP:FILES')
  #ADD(%ClarionWordList,'PROP:FILE')
  #ADD(%ClarionWordList,'PROP:PROFILEINTOFILES')
  #ADD(%ClarionWordList,'PROP:INNER')
  #ADD(%ClarionWordList,'PROP:FIELD')
  #ADD(%ClarionWordList,'PROP:FIELDSFILE')
  #ADD(%ClarionWordList,'PROP:SQL')
  #ADD(%ClarionWordList,'PROP:ORDERALLTABLES')
  #ADD(%ClarionWordList,'PROP:SQLFILTER')
  #ADD(%ClarionWordList,'PROP:LOGFILE')
  #ADD(%ClarionWordList,'PROP:WHERE')
  #ADD(%ClarionWordList,'PROP:FETCHSIZE')
  #ADD(%ClarionWordList,'PROP:ALIAS')
  #ADD(%ClarionWordList,'PROP:DISCONNECT')
  #ADD(%ClarionWordList,'PROP:SQLORDER')
  #ADD(%ClarionWordList,'PROP:SQLJOINEXPRESSION')
  #ADD(%ClarionWordList,'PROP:HINT')
  #ADD(%ClarionWordList,'PROP:APPENDBUFFER')
  #ADD(%ClarionWordList,'PROP:CONNECTSTRING')
  #ADD(%ClarionWordList,'PROP:LOGINTIMEOUT')
  #ADD(%ClarionWordList,'PROP:HENV')
  #ADD(%ClarionWordList,'PROP:HDBC')
  #ADD(%ClarionWordList,'PROP:HSTMT')
  #ADD(%ClarionWordList,'PROP:ORDERINSELECT')
  #ADD(%ClarionWordList,'PROP:QUOTESTRING')
  #ADD(%ClarionWordList,'PROP:LOGONSCREEN')
  #ADD(%ClarionWordList,'PROP:ALWAYSREBIND')
  #ADD(%ClarionWordList,'PROP:DBMSVER')
  #ADD(%ClarionWordList,'PROP:ISOLATIONLEVEL')
  #ADD(%ClarionWordList,'PROP:MAXSTATEMENTS')
  #ADD(%ClarionWordList,'PROP:STMTATTR')
  #ADD(%ClarionWordList,'PROP:LOGOUTISOLATIONLEVEL')
  #ADD(%ClarionWordList,'PROP:FULLBUILD')
  #ADD(%ClarionWordList,'PROP:POSITIONBLOCK')
  #ADD(%ClarionWordList,'PROP:NEXTTABSTOP')                 #! RAS.2001.10.17
  #ADD(%ClarionWordList,'PROP:PREVTABSTOP')                 #! RAS.2001.10.17
  #ADD(%ClarionWordList,'PROPSTYLE:FIRST')                  #! PROPSTYLE Equates
  #ADD(%ClarionWordList,'PROPSTYLE:FONTNAME')
  #ADD(%ClarionWordList,'PROPSTYLE:FONTSIZE')
  #ADD(%ClarionWordList,'PROPSTYLE:FONTCOLOR')
  #ADD(%ClarionWordList,'PROPSTYLE:FONTSTYLE')
  #ADD(%ClarionWordList,'PROPSTYLE:TEXTCOLOR')
  #ADD(%ClarionWordList,'PROPSTYLE:BACKCOLOR')
  #ADD(%ClarionWordList,'PROPSTYLE:TEXTSELECTED')
  #ADD(%ClarionWordList,'PROPSTYLE:BACKSELECTED')
  #ADD(%ClarionWordList,'PROPSTYLE:PICTURE')
  #ADD(%ClarionWordList,'PROPSTYLE:CHARSET')
  #ADD(%ClarionWordList,'PROPSTYLE:LAST')
  #ADD(%ClarionWordList,'PROPLIST:UNDERLINE')               #! PROPLIST Equates
  #ADD(%ClarionWordList,'PROPLIST:RESIZE')
  #ADD(%ClarionWordList,'PROPLIST:RIGHTBORDER')
  #ADD(%ClarionWordList,'PROPLIST:HEADER')
  #ADD(%ClarionWordList,'PROPLIST:WIDTH')
  #ADD(%ClarionWordList,'PROPLIST:PICTURE')
  #ADD(%ClarionWordList,'PROPLIST:FIXED')
  #ADD(%ClarionWordList,'PROPLIST:SCROLL')
  #ADD(%ClarionWordList,'PROPLIST:LASTONLINE')
  #ADD(%ClarionWordList,'PROPLIST:LOCATOR')
  #ADD(%ClarionWordList,'PROPLIST:EXISTS')
  #ADD(%ClarionWordList,'PROPLIST:RESVD2')
  #ADD(%ClarionWordList,'PROPLIST:RESVD3')
  #ADD(%ClarionWordList,'PROPLIST:GROUPNO')
  #ADD(%ClarionWordList,'PROPLIST:FIELDNO')
  #ADD(%ClarionWordList,'PROPLIST:FORMAT')
  #ADD(%ClarionWordList,'PROPLIST:LEFT')
  #ADD(%ClarionWordList,'PROPLIST:LEFTOFFSET')
  #ADD(%ClarionWordList,'PROPLIST:RIGHT')
  #ADD(%ClarionWordList,'PROPLIST:RIGHTOFFSET')
  #ADD(%ClarionWordList,'PROPLIST:CENTER')
  #ADD(%ClarionWordList,'PROPLIST:CENTEROFFSET')
  #ADD(%ClarionWordList,'PROPLIST:DECIMAL')
  #ADD(%ClarionWordList,'PROPLIST:DECIMALOFFSET')
  #ADD(%ClarionWordList,'PROPLIST:HEADERLEFT')
  #ADD(%ClarionWordList,'PROPLIST:HEADERLEFTOFFSET')
  #ADD(%ClarionWordList,'PROPLIST:HEADERRIGHT')
  #ADD(%ClarionWordList,'PROPLIST:HEADERRIGHTOFFSET')
  #ADD(%ClarionWordList,'PROPLIST:HEADERCENTER')
  #ADD(%ClarionWordList,'PROPLIST:HEADERCENTEROFFSET')
  #ADD(%ClarionWordList,'PROPLIST:HEADERDECIMAL')
  #ADD(%ClarionWordList,'PROPLIST:HEADERDECIMALOFFSET')
  #ADD(%ClarionWordList,'PROPLIST:ICON')
  #ADD(%ClarionWordList,'PROPLIST:COLOR')
  #ADD(%ClarionWordList,'PROPLIST:TREE')
  #ADD(%ClarionWordList,'PROPLIST:TREELINES')
  #ADD(%ClarionWordList,'PROPLIST:TREEBOXES')
  #ADD(%ClarionWordList,'PROPLIST:TREEINDENT')
  #ADD(%ClarionWordList,'PROPLIST:TREEOFFSET')
  #ADD(%ClarionWordList,'PROPLIST:TREEROOT')
  #ADD(%ClarionWordList,'PROPLIST:DEFCOLORS')
  #ADD(%ClarionWordList,'PROPLIST:TEXTCOLOR')
  #ADD(%ClarionWordList,'PROPLIST:BACKCOLOR')
  #ADD(%ClarionWordList,'PROPLIST:TEXTSELECTED')
  #ADD(%ClarionWordList,'PROPLIST:BACKSELECTED')
  #ADD(%ClarionWordList,'PROPLIST:CELLSTYLE')
  #ADD(%ClarionWordList,'PROPLIST:COLSTYLE')
  #ADD(%ClarionWordList,'PROPLIST:ICONTRN')
  #ADD(%ClarionWordList,'PROPLIST:GROUP')
  #ADD(%ClarionWordList,'PROPLIST:STYLE')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEDOWNROW')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEMOVEROW')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEUPROW')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEDOWNFIELD')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEMOVEFIELD')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEUPFIELD')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEDOWNZONE')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEMOVEZONE')
  #ADD(%ClarionWordList,'PROPLIST:MOUSEUPZONE')
  #ADD(%ClarionWordList,'PROPLIST:GRID')
  #ADD(%ClarionWordList,'PROPLIST:BARCOLOR')
  #ADD(%ClarionWordList,'LEVEL:BENIGN')                     #! LEVEL Equates
  #ADD(%ClarionWordList,'LEVEL:USER')
  #ADD(%ClarionWordList,'LEVEL:PROGRAM')
  #ADD(%ClarionWordList,'LEVEL:FATAL')
  #ADD(%ClarionWordList,'LEVEL:CANCEL')
  #ADD(%ClarionWordList,'LEVEL:NOTIFY')
  #ADD(%ClarionWordList,'OCXEVENT:AUTOSIZE')                #! OCXEVENT Equates
  #ADD(%ClarionWordList,'OCXEVENT:BACKCOLOR')
  #ADD(%ClarionWordList,'OCXEVENT:BACKSTYLE')
  #ADD(%ClarionWordList,'OCXEVENT:BORDERCOLOR')
  #ADD(%ClarionWordList,'OCXEVENT:BORDERSTYLE')
  #ADD(%ClarionWordList,'OCXEVENT:BORDERWIDTH')
  #ADD(%ClarionWordList,'OCXEVENT:DRAWMODE')
  #ADD(%ClarionWordList,'OCXEVENT:DRAWSTYLE')
  #ADD(%ClarionWordList,'OCXEVENT:DRAWWIDTH')
  #ADD(%ClarionWordList,'OCXEVENT:FILLCOLOR')
  #ADD(%ClarionWordList,'OCXEVENT:FILLSTYLE')
  #ADD(%ClarionWordList,'OCXEVENT:FONT')
  #ADD(%ClarionWordList,'OCXEVENT:FORECOLOR')
  #ADD(%ClarionWordList,'OCXEVENT:ENABLED')
  #ADD(%ClarionWordList,'OCXEVENT:HWND')
  #ADD(%ClarionWordList,'OCXEVENT:TABSTOP')
  #ADD(%ClarionWordList,'OCXEVENT:TEXT')
  #ADD(%ClarionWordList,'OCXEVENT:CAPTION')
  #ADD(%ClarionWordList,'OCXEVENT:BORDERVISIBLE')
  #ADD(%ClarionWordList,'OCXEVENT:REFRESH')
  #ADD(%ClarionWordList,'OCXEVENT:DOCLICK')
  #ADD(%ClarionWordList,'OCXEVENT:ABOUTBOX')
  #ADD(%ClarionWordList,'OCXEVENT:CLICK')
  #ADD(%ClarionWordList,'OCXEVENT:DBLCLICK')
  #ADD(%ClarionWordList,'OCXEVENT:KEYDOWN')
  #ADD(%ClarionWordList,'OCXEVENT:KEYPRESS')
  #ADD(%ClarionWordList,'OCXEVENT:KEYUP')
  #ADD(%ClarionWordList,'OCXEVENT:MOUSEDOWN')
  #ADD(%ClarionWordList,'OCXEVENT:MOUSEMOVE')
  #ADD(%ClarionWordList,'OCXEVENT:MOUSEUP')
  #ADD(%ClarionWordList,'OCXEVENT:ERROREVENT')
  #ADD(%ClarionWordList,'PROPPRINT:DEVMODE')                #! PROPPRINT Equates
  #ADD(%ClarionWordList,'PROPPRINT:PAPER')
  #ADD(%ClarionWordList,'PROPPRINT:PAPERHEIGHT')
  #ADD(%ClarionWordList,'PROPPRINT:PAPERWIDTH')
  #ADD(%ClarionWordList,'PROPPRINT:PERCENT')
  #ADD(%ClarionWordList,'PROPPRINT:COPIES')
  #ADD(%ClarionWordList,'PROPPRINT:PAPERBIN')
  #ADD(%ClarionWordList,'PROPPRINT:RESOLUTION')
  #ADD(%ClarionWordList,'PROPPRINT:COLOR')
  #ADD(%ClarionWordList,'PROPPRINT:DUPLEX')
  #ADD(%ClarionWordList,'PROPPRINT:YRESOLUTION')
  #ADD(%ClarionWordList,'PROPPRINT:FONTMODE')
  #ADD(%ClarionWordList,'PROPPRINT:PRINTTOFILE')
  #ADD(%ClarionWordList,'PROPPRINT:PRINTTONAME')
  #ADD(%ClarionWordList,'PROPPRINT:FROMPAGE')
  #ADD(%ClarionWordList,'PROPPRINT:TOPAGE')
  #ADD(%ClarionWordList,'PROPPRINT:FROMMAX')
  #ADD(%ClarionWordList,'PROPPRINT:FROMMIN')
  #ADD(%ClarionWordList,'PROPPRINT:TOMAX')
  #ADD(%ClarionWordList,'PROPPRINT:COLLATE')
  #ADD(%ClarionWordList,'PROPPRINT:DRIVER')
  #ADD(%ClarionWordList,'PROPPRINT:DEVICE')
  #ADD(%ClarionWordList,'PROPPRINT:PORT')
  #ADD(%ClarionWordList,'PROPPRINT:CONTEXT')
  #ADD(%ClarionWordList,'PAPERBIN:UPPER')                   #! PAPERBIN Equates
  #ADD(%ClarionWordList,'PAPERBIN:ONLYONE')
  #ADD(%ClarionWordList,'PAPERBIN:LOWER')
  #ADD(%ClarionWordList,'PAPERBIN:MIDDLE')
  #ADD(%ClarionWordList,'PAPERBIN:MANUAL')
  #ADD(%ClarionWordList,'PAPERBIN:ENVELOPE')
  #ADD(%ClarionWordList,'PAPERBIN:ENVMANUAL')
  #ADD(%ClarionWordList,'PAPERBIN:AUTO')
  #ADD(%ClarionWordList,'PAPERBIN:TRACTOR')
  #ADD(%ClarionWordList,'PAPERBIN:SMALLFMT')
  #ADD(%ClarionWordList,'PAPERBIN:LARGEFMT')
  #ADD(%ClarionWordList,'PAPERBIN:LARGECAPACITY')
  #ADD(%ClarionWordList,'PAPERBIN:CASSETTE')
  #ADD(%ClarionWordList,'RESOLUTION:DRAFT')                 #! Other Printer Equates
  #ADD(%ClarionWordList,'RESOLUTION:LOW')
  #ADD(%ClarionWordList,'RESOLUTION:MEDIUM')
  #ADD(%ClarionWordList,'RESOLUTION:HIGH')
  #ADD(%ClarionWordList,'DUPLEX:SIMPLEX')
  #ADD(%ClarionWordList,'DUPLEX:VERTICAL')
  #ADD(%ClarionWordList,'DUPLEX:HORIZONTAL')
  #ADD(%ClarionWordList,'FONTMODE:BITMAP')
  #ADD(%ClarionWordList,'FONTMODE:DOWNLOAD')
  #ADD(%ClarionWordList,'FONTMODE:SUBDEV')
  #SET(%ClarionWordCount,ITEMS(%ClarionWordList))           #! How many are there?
#GROUP(%ClarionReservedWordsEnd)

#!--------------------------------------------------------------------!
#! 2001.03.10.SAT - Roberto Artigas Jr          IMPORTANT PLEASE READ !
#!--------------------------------------------------------------------!
#! This group contains the code necessary to build a searchable list  !
#! of Suneido reserved words. This is used to make sure field, key,   !
#! and table names are not in conflict with reserved words.           !
#!--------------------------------------------------------------------!
#! ALSO: I am a realist. I can pretty much say with a great amount of !
#! certainty, that once having seen this list, most individuals are   !
#! not going to type in their own to achieve the same functionality.  !
#! If you use this list at least have the courtesy of giving credit   !
#! to Roberto Artigas Jr for having typed all of this in. Leave this  !
#! documentation block intact and give credit where credit is due.    !
#!--------------------------------------------------------------------!
#GROUP(%SuneidoReservedWords)
  #DECLARE(%SuneidoWordCount)
  #DECLARE(%SuneidoWordItem)
  #DECLARE(%SuneidoWordList),MULTI,UNIQUE
  #ADD(%SuneidoWordList,'Address')
  #ADD(%SuneidoWordList,'alter')
  #ADD(%SuneidoWordList,'and')
  #ADD(%SuneidoWordList,'ascending')
  #ADD(%SuneidoWordList,'average')
  #ADD(%SuneidoWordList,'Backup')
  #ADD(%SuneidoWordList,'Boolean?')
  #ADD(%SuneidoWordList,'Built')
  #ADD(%SuneidoWordList,'bool')
  #ADD(%SuneidoWordList,'break')
  #ADD(%SuneidoWordList,'buffer')
  #ADD(%SuneidoWordList,'by')
  #ADD(%SuneidoWordList,'Call')
  #ADD(%SuneidoWordList,'CallClass')
  #ADD(%SuneidoWordList,'Class?')
  #ADD(%SuneidoWordList,'ClearCallBack')
  #ADD(%SuneidoWordList,'Cmdline')
  #ADD(%SuneidoWordList,'COMobject')
  #ADD(%SuneidoWordList,'Construct')
  #ADD(%SuneidoWordList,'Construct2')
  #ADD(%SuneidoWordList,'Cursor')
  #ADD(%SuneidoWordList,'callback')
  #ADD(%SuneidoWordList,'cascade')
  #ADD(%SuneidoWordList,'catch')
  #ADD(%SuneidoWordList,'class')
  #ADD(%SuneidoWordList,'case')
  #ADD(%SuneidoWordList,'char')
  #ADD(%SuneidoWordList,'continue')
  #ADD(%SuneidoWordList,'count')
  #ADD(%SuneidoWordList,'create')
  #ADD(%SuneidoWordList,'Database')
  #ADD(%SuneidoWordList,'Date')
  #ADD(%SuneidoWordList,'Date?')
  #ADD(%SuneidoWordList,'Debug')
  #ADD(%SuneidoWordList,'Default')
  #ADD(%SuneidoWordList,'Display')
  #ADD(%SuneidoWordList,'Dump')
  #ADD(%SuneidoWordList,'default')
  #ADD(%SuneidoWordList,'delete')
  #ADD(%SuneidoWordList,'descending')
  #ADD(%SuneidoWordList,'destroy')
  #ADD(%SuneidoWordList,'dll')
  #ADD(%SuneidoWordList,'do')
  #ADD(%SuneidoWordList,'else')
  #ADD(%SuneidoWordList,'ensure')
  #ADD(%SuneidoWordList,'extend')
  #ADD(%SuneidoWordList,'False')
  #ADD(%SuneidoWordList,'File')
  #ADD(%SuneidoWordList,'Frame')
  #ADD(%SuneidoWordList,'Function?')
  #ADD(%SuneidoWordList,'for')
  #ADD(%SuneidoWordList,'foreach')
  #ADD(%SuneidoWordList,'forever')
  #ADD(%SuneidoWordList,'function')
  #ADD(%SuneidoWordList,'history')
  #ADD(%SuneidoWordList,'Integer?')
  #ADD(%SuneidoWordList,'if')
  #ADD(%SuneidoWordList,'in')
  #ADD(%SuneidoWordList,'index')
  #ADD(%SuneidoWordList,'insert')
  #ADD(%SuneidoWordList,'instantiate')
  #ADD(%SuneidoWordList,'intersect')
  #ADD(%SuneidoWordList,'into')
  #ADD(%SuneidoWordList,'is')
  #ADD(%SuneidoWordList,'isnt')
  #ADD(%SuneidoWordList,'join')
  #ADD(%SuneidoWordList,'key')
  #ADD(%SuneidoWordList,'Libraries')
  #ADD(%SuneidoWordList,'Locals')
  #ADD(%SuneidoWordList,'leftjoin')
  #ADD(%SuneidoWordList,'list')
  #ADD(%SuneidoWordList,'long')
  #ADD(%SuneidoWordList,'Memcopy')
  #ADD(%SuneidoWordList,'Memory')
  #ADD(%SuneidoWordList,'max')
  #ADD(%SuneidoWordList,'min')
  #ADD(%SuneidoWordList,'minus')
  #ADD(%SuneidoWordList,'Name')
  #ADD(%SuneidoWordList,'New')
  #ADD(%SuneidoWordList,'Number?')
  #ADD(%SuneidoWordList,'new')
  #ADD(%SuneidoWordList,'not')
  #ADD(%SuneidoWordList,'Object')
  #ADD(%SuneidoWordList,'Object?')
  #ADD(%SuneidoWordList,'or')
  #ADD(%SuneidoWordList,'project')
  #ADD(%SuneidoWordList,'Random')
  #ADD(%SuneidoWordList,'Record?')
  #ADD(%SuneidoWordList,'RichEditGet')
  #ADD(%SuneidoWordList,'RichEditOle')
  #ADD(%SuneidoWordList,'RichEditPut')
  #ADD(%SuneidoWordList,'rename')
  #ADD(%SuneidoWordList,'return')
  #ADD(%SuneidoWordList,'Scanner')
  #ADD(%SuneidoWordList,'ScintillaStyle')
  #ADD(%SuneidoWordList,'Server?')
  #ADD(%SuneidoWordList,'SetAccelerators')
  #ADD(%SuneidoWordList,'SocketClient')
  #ADD(%SuneidoWordList,'SocketServer')
  #ADD(%SuneidoWordList,'String?')
  #ADD(%SuneidoWordList,'StringFrom')
  #ADD(%SuneidoWordList,'Suneido')
  #ADD(%SuneidoWordList,'set')
  #ADD(%SuneidoWordList,'short')
  #ADD(%SuneidoWordList,'sort')
  #ADD(%SuneidoWordList,'string')
  #ADD(%SuneidoWordList,'struct')
  #ADD(%SuneidoWordList,'summarize')
  #ADD(%SuneidoWordList,'super')
  #ADD(%SuneidoWordList,'switch')
  #ADD(%SuneidoWordList,'TestAsync')
  #ADD(%SuneidoWordList,'TestFiber')
  #ADD(%SuneidoWordList,'Thread')
  #ADD(%SuneidoWordList,'Timestamp')
  #ADD(%SuneidoWordList,'Trace')
  #ADD(%SuneidoWordList,'Transactions')
  #ADD(%SuneidoWordList,'True')
  #ADD(%SuneidoWordList,'throw')
  #ADD(%SuneidoWordList,'this')
  #ADD(%SuneidoWordList,'times')
  #ADD(%SuneidoWordList,'to')
  #ADD(%SuneidoWordList,'total')
  #ADD(%SuneidoWordList,'try')
  #ADD(%SuneidoWordList,'Unload')
  #ADD(%SuneidoWordList,'Unuse')
  #ADD(%SuneidoWordList,'Use')
  #ADD(%SuneidoWordList,'union')
  #ADD(%SuneidoWordList,'update')
  #ADD(%SuneidoWordList,'value')
  #ADD(%SuneidoWordList,'view')
  #ADD(%SuneidoWordList,'where')
  #ADD(%SuneidoWordList,'while')
  #SET(%SuneidoWordCount,ITEMS(%SuneidoWordList))           #! How many are there?
#GROUP(%SuneidoReservedWordsEnd)

#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
#!---------------------------------------------------------------------
